#include "proxies_accessrights.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyACLManager::ProxyACLManager(::Diamesh::ACLManagerPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyACLManager::~ProxyACLManager()
{
}

void ProxyACLManager::_forward_aclAdded(QString arg0, QString arg1)
{

  emit aclAdded(arg0,arg1);
}

void ProxyACLManager::_forward_aclChanged(QString arg0, QString arg1)
{

  emit aclChanged(arg0,arg1);
}

void ProxyACLManager::_forward_aclRemoved(QString arg0, QString arg1)
{

  emit aclRemoved(arg0,arg1);
}

::Diamesh::AccessRightList ProxyACLManager::getRegisteredRights()
{
  return _prx->getRegisteredRights();
}

void ProxyACLManager::begin_getRegisteredRights(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_getRegisteredRightsPtr resultsCb = new Callback_ProxyACLManager_getRegisteredRights;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::AccessRightList >("::Diamesh::AccessRightList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::AccessRightList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_getRegisteredRightsPtr __cb = ::Diamesh::newCallback_ACLManager_getRegisteredRights(resultsCb, &Callback_ProxyACLManager_getRegisteredRights::_success, &Callback_ProxyACLManager_getRegisteredRights::_failure);
  _prx->begin_getRegisteredRights(__cb);
}



::Diamesh::StringStringMap ProxyACLManager::getTargetTypes()
{
  return _prx->getTargetTypes();
}

void ProxyACLManager::begin_getTargetTypes(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_getTargetTypesPtr resultsCb = new Callback_ProxyACLManager_getTargetTypes;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::StringStringMap >("::Diamesh::StringStringMap");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::StringStringMap,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_getTargetTypesPtr __cb = ::Diamesh::newCallback_ACLManager_getTargetTypes(resultsCb, &Callback_ProxyACLManager_getTargetTypes::_success, &Callback_ProxyACLManager_getTargetTypes::_failure);
  _prx->begin_getTargetTypes(__cb);
}



::Diamesh::AccessControlList ProxyACLManager::getACL(const ::std::string& target, const ::std::string& subject)
{
  return _prx->getACL(target, subject);
}

void ProxyACLManager::begin_getACL(const ::std::string& target, const ::std::string& subject, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_getACLPtr resultsCb = new Callback_ProxyACLManager_getACL;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::AccessControlList >("::Diamesh::AccessControlList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::AccessControlList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_getACLPtr __cb = ::Diamesh::newCallback_ACLManager_getACL(resultsCb, &Callback_ProxyACLManager_getACL::_success, &Callback_ProxyACLManager_getACL::_failure);
  _prx->begin_getACL(target, subject, __cb);
}



::Diamesh::StringList ProxyACLManager::getSubjectsForTarget(const ::Diamesh::ACLTargetPtr& target)
{
  return _prx->getSubjectsForTarget(target);
}

void ProxyACLManager::begin_getSubjectsForTarget(const ::Diamesh::ACLTargetPtr& target, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_getSubjectsForTargetPtr resultsCb = new Callback_ProxyACLManager_getSubjectsForTarget;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::StringList >("::Diamesh::StringList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::StringList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_getSubjectsForTargetPtr __cb = ::Diamesh::newCallback_ACLManager_getSubjectsForTarget(resultsCb, &Callback_ProxyACLManager_getSubjectsForTarget::_success, &Callback_ProxyACLManager_getSubjectsForTarget::_failure);
  _prx->begin_getSubjectsForTarget(target, __cb);
}



::Diamesh::ACLList ProxyACLManager::getACLsForTarget(const ::Diamesh::ACLTargetPtr& target)
{
  return _prx->getACLsForTarget(target);
}

void ProxyACLManager::begin_getACLsForTarget(const ::Diamesh::ACLTargetPtr& target, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_getACLsForTargetPtr resultsCb = new Callback_ProxyACLManager_getACLsForTarget;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ACLList >("::Diamesh::ACLList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ACLList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_getACLsForTargetPtr __cb = ::Diamesh::newCallback_ACLManager_getACLsForTarget(resultsCb, &Callback_ProxyACLManager_getACLsForTarget::_success, &Callback_ProxyACLManager_getACLsForTarget::_failure);
  _prx->begin_getACLsForTarget(target, __cb);
}



bool ProxyACLManager::setACL(const ::std::string& target, const ::std::string& subject, const ::Diamesh::LongList& rightsIds, ::Ice::Long hSetId)
{
  return _prx->setACL(target, subject, rightsIds, hSetId);
}

void ProxyACLManager::begin_setACL(const ::std::string& target, const ::std::string& subject, const ::Diamesh::LongList& rightsIds, ::Ice::Long hSetId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_setACLPtr resultsCb = new Callback_ProxyACLManager_setACL;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_setACLPtr __cb = ::Diamesh::newCallback_ACLManager_setACL(resultsCb, &Callback_ProxyACLManager_setACL::_success, &Callback_ProxyACLManager_setACL::_failure);
  _prx->begin_setACL(target, subject, rightsIds, hSetId, __cb);
}



bool ProxyACLManager::removeACL(const ::std::string& target, const ::std::string& subject)
{
  return _prx->removeACL(target, subject);
}

void ProxyACLManager::begin_removeACL(const ::std::string& target, const ::std::string& subject, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_removeACLPtr resultsCb = new Callback_ProxyACLManager_removeACL;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_removeACLPtr __cb = ::Diamesh::newCallback_ACLManager_removeACL(resultsCb, &Callback_ProxyACLManager_removeACL::_success, &Callback_ProxyACLManager_removeACL::_failure);
  _prx->begin_removeACL(target, subject, __cb);
}



void ProxyACLManager::targetRemoved(const ::std::string& target)
{
  _prx->targetRemoved(target);
}

void ProxyACLManager::begin_targetRemoved(const ::std::string& target, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_targetRemovedPtr resultsCb = new Callback_ProxyACLManager_targetRemoved;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_targetRemovedPtr __cb = ::Diamesh::newCallback_ACLManager_targetRemoved(resultsCb, &Callback_ProxyACLManager_targetRemoved::_success, &Callback_ProxyACLManager_targetRemoved::_failure);
  _prx->begin_targetRemoved(target, __cb);
}



void ProxyACLManager::subjectRemoved(const ::std::string& target)
{
  _prx->subjectRemoved(target);
}

void ProxyACLManager::begin_subjectRemoved(const ::std::string& target, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_subjectRemovedPtr resultsCb = new Callback_ProxyACLManager_subjectRemoved;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_subjectRemovedPtr __cb = ::Diamesh::newCallback_ACLManager_subjectRemoved(resultsCb, &Callback_ProxyACLManager_subjectRemoved::_success, &Callback_ProxyACLManager_subjectRemoved::_failure);
  _prx->begin_subjectRemoved(target, __cb);
}



bool ProxyACLManager::testRightForObject(const ::Diamesh::ACLTargetPtr& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId)
{
  return _prx->testRightForObject(target, subject, rightId);
}

void ProxyACLManager::begin_testRightForObject(const ::Diamesh::ACLTargetPtr& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_testRightForObjectPtr resultsCb = new Callback_ProxyACLManager_testRightForObject;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_testRightForObjectPtr __cb = ::Diamesh::newCallback_ACLManager_testRightForObject(resultsCb, &Callback_ProxyACLManager_testRightForObject::_success, &Callback_ProxyACLManager_testRightForObject::_failure);
  _prx->begin_testRightForObject(target, subject, rightId, __cb);
}



bool ProxyACLManager::testRight(const ::std::string& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId)
{
  return _prx->testRight(target, subject, rightId);
}

void ProxyACLManager::begin_testRight(const ::std::string& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyACLManager_testRightPtr resultsCb = new Callback_ProxyACLManager_testRight;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_ACLManager_testRightPtr __cb = ::Diamesh::newCallback_ACLManager_testRight(resultsCb, &Callback_ProxyACLManager_testRight::_success, &Callback_ProxyACLManager_testRight::_failure);
  _prx->begin_testRight(target, subject, rightId, __cb);
}



void Callback_ProxyACLManager_getRegisteredRights::_success(const ::Diamesh::AccessRightList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_getRegisteredRights::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_getTargetTypes::_success(const ::Diamesh::StringStringMap& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_getTargetTypes::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_getACL::_success(const ::Diamesh::AccessControlList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_getACL::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_getSubjectsForTarget::_success(const ::Diamesh::StringList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_getSubjectsForTarget::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_getACLsForTarget::_success(const ::Diamesh::ACLList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_getACLsForTarget::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_setACL::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_setACL::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_removeACL::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_removeACL::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_targetRemoved::_success()
{
  emit succeeded(_cookie);
}

void Callback_ProxyACLManager_targetRemoved::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_subjectRemoved::_success()
{
  emit succeeded(_cookie);
}

void Callback_ProxyACLManager_subjectRemoved::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_testRightForObject::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_testRightForObject::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyACLManager_testRight::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyACLManager_testRight::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

