// This file was generated with slice2qt.
// All modifications will be overwritten.


#ifndef _DIAMESH_PROXIES_ACCESSRIGHTS_H
#define _DIAMESH_PROXIES_ACCESSRIGHTS_H

#include <QtIce/qiceobjectproxy.h>
#include "accessrights.h"
#include <QtCore/QSharedPointer>

namespace Diamesh {

class ProxyACLManager;
typedef QIceObjectProxyPointer< ProxyACLManager> ACLManagerQPrx;

class ProxyACLManager : public QIceObjectProxy
{
  friend class QIceObjectProxyPointer< ProxyACLManager>;
  Q_OBJECT

protected:
  ProxyACLManager(::Diamesh::ACLManagerPrx prx, Ice::ObjectAdapterPtr adapter = 0);

  Q_INVOKABLE void _forward_aclAdded(QString, QString);
  Q_INVOKABLE void _forward_aclChanged(QString, QString);
  Q_INVOKABLE void _forward_aclRemoved(QString, QString);
  public:
  typedef ::Diamesh::ACLManagerPrx proxy_type;

  virtual ~ProxyACLManager();

  ::Diamesh::AccessRightList getRegisteredRights();
  void begin_getRegisteredRights(QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  ::Diamesh::StringStringMap getTargetTypes();
  void begin_getTargetTypes(QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  ::Diamesh::AccessControlList getACL(const ::std::string& target, const ::std::string& subject);
  void begin_getACL(const ::std::string& target, const ::std::string& subject, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  ::Diamesh::StringList getSubjectsForTarget(const ::Diamesh::ACLTargetPtr& target);
  void begin_getSubjectsForTarget(const ::Diamesh::ACLTargetPtr& target, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  ::Diamesh::ACLList getACLsForTarget(const ::Diamesh::ACLTargetPtr& target);
  void begin_getACLsForTarget(const ::Diamesh::ACLTargetPtr& target, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  bool setACL(const ::std::string& target, const ::std::string& subject, const ::Diamesh::LongList& rightsIds, ::Ice::Long hSetId);
  void begin_setACL(const ::std::string& target, const ::std::string& subject, const ::Diamesh::LongList& rightsIds, ::Ice::Long hSetId, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  bool removeACL(const ::std::string& target, const ::std::string& subject);
  void begin_removeACL(const ::std::string& target, const ::std::string& subject, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  void targetRemoved(const ::std::string& target);
  void begin_targetRemoved(const ::std::string& target, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  void subjectRemoved(const ::std::string& target);
  void begin_subjectRemoved(const ::std::string& target, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  bool testRightForObject(const ::Diamesh::ACLTargetPtr& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId);
  void begin_testRightForObject(const ::Diamesh::ACLTargetPtr& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);

  bool testRight(const ::std::string& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId);
  void begin_testRight(const ::std::string& target, const ::Diamesh::UserPtr& subject, ::Ice::Long rightId, QObject * __receiver = 0, const char * __successSlot = 0, QObject * __fReceiver = 0, const char * __failureSlot = 0, QObject *cookie = 0);


signals:
  void aclAdded(QString, QString);
  void aclChanged(QString, QString);
  void aclRemoved(QString, QString);
  

private:
::Diamesh::ACLManagerPrx _prx;
};

class Callback_ProxyACLManager_getRegisteredRights : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(const ::Diamesh::AccessRightList&);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(::Diamesh::AccessRightList, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_getRegisteredRights> Callback_ProxyACLManager_getRegisteredRightsPtr;

class Callback_ProxyACLManager_getTargetTypes : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(const ::Diamesh::StringStringMap&);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(::Diamesh::StringStringMap, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_getTargetTypes> Callback_ProxyACLManager_getTargetTypesPtr;

class Callback_ProxyACLManager_getACL : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(const ::Diamesh::AccessControlList&);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(::Diamesh::AccessControlList, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_getACL> Callback_ProxyACLManager_getACLPtr;

class Callback_ProxyACLManager_getSubjectsForTarget : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(const ::Diamesh::StringList&);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(::Diamesh::StringList, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_getSubjectsForTarget> Callback_ProxyACLManager_getSubjectsForTargetPtr;

class Callback_ProxyACLManager_getACLsForTarget : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(const ::Diamesh::ACLList&);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(::Diamesh::ACLList, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_getACLsForTarget> Callback_ProxyACLManager_getACLsForTargetPtr;

class Callback_ProxyACLManager_setACL : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(bool);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(bool, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_setACL> Callback_ProxyACLManager_setACLPtr;

class Callback_ProxyACLManager_removeACL : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(bool);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(bool, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_removeACL> Callback_ProxyACLManager_removeACLPtr;

class Callback_ProxyACLManager_targetRemoved : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success();
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_targetRemoved> Callback_ProxyACLManager_targetRemovedPtr;

class Callback_ProxyACLManager_subjectRemoved : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success();
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_subjectRemoved> Callback_ProxyACLManager_subjectRemovedPtr;

class Callback_ProxyACLManager_testRightForObject : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(bool);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(bool, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_testRightForObject> Callback_ProxyACLManager_testRightForObjectPtr;

class Callback_ProxyACLManager_testRight : public QObject, public IceUtil::Shared
{
  Q_OBJECT

  public:
    void _success(bool);
    void _failure(const Ice::Exception&);



    QObject *_cookie;  signals:
    void succeeded(bool, QObject*);
    void failed(QSharedPointer<Ice::Exception>, QObject*);
};
typedef IceUtil::Handle<Callback_ProxyACLManager_testRight> Callback_ProxyACLManager_testRightPtr;

} // Diamesh



#endif // PROXIES_ACCESSRIGHTS_H
