#include "proxies_filetransfer.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyFileTransfer::ProxyFileTransfer(::Diamesh::FileTransferPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyFileTransfer::~ProxyFileTransfer()
{
}

::Diamesh::ByteArray ProxyFileTransfer::readFile(::Ice::Long offset, ::Ice::Long num)
{
  return _prx->readFile(offset, num);
}

void ProxyFileTransfer::begin_readFile(::Ice::Long offset, ::Ice::Long num, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyFileTransfer_readFilePtr resultsCb = new Callback_ProxyFileTransfer_readFile;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ByteArray >("::Diamesh::ByteArray");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ByteArray,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_FileTransfer_readFilePtr __cb = ::Diamesh::newCallback_FileTransfer_readFile(resultsCb, &Callback_ProxyFileTransfer_readFile::_success, &Callback_ProxyFileTransfer_readFile::_failure);
  _prx->begin_readFile(offset, num, __cb);
}



::Ice::Long ProxyFileTransfer::getSize()
{
  return _prx->getSize();
}

void ProxyFileTransfer::begin_getSize(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyFileTransfer_getSizePtr resultsCb = new Callback_ProxyFileTransfer_getSize;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_FileTransfer_getSizePtr __cb = ::Diamesh::newCallback_FileTransfer_getSize(resultsCb, &Callback_ProxyFileTransfer_getSize::_success, &Callback_ProxyFileTransfer_getSize::_failure);
  _prx->begin_getSize(__cb);
}



::std::string ProxyFileTransfer::getFileName()
{
  return _prx->getFileName();
}

void ProxyFileTransfer::begin_getFileName(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyFileTransfer_getFileNamePtr resultsCb = new Callback_ProxyFileTransfer_getFileName;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::std::string >("::std::string");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::std::string,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_FileTransfer_getFileNamePtr __cb = ::Diamesh::newCallback_FileTransfer_getFileName(resultsCb, &Callback_ProxyFileTransfer_getFileName::_success, &Callback_ProxyFileTransfer_getFileName::_failure);
  _prx->begin_getFileName(__cb);
}



void ProxyFileTransfer::setFilePath(const ::std::string& filepath)
{
  _prx->setFilePath(filepath);
}

void ProxyFileTransfer::begin_setFilePath(const ::std::string& filepath, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyFileTransfer_setFilePathPtr resultsCb = new Callback_ProxyFileTransfer_setFilePath;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_FileTransfer_setFilePathPtr __cb = ::Diamesh::newCallback_FileTransfer_setFilePath(resultsCb, &Callback_ProxyFileTransfer_setFilePath::_success, &Callback_ProxyFileTransfer_setFilePath::_failure);
  _prx->begin_setFilePath(filepath, __cb);
}



void Callback_ProxyFileTransfer_readFile::_success(const ::Diamesh::ByteArray& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyFileTransfer_readFile::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyFileTransfer_getSize::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyFileTransfer_getSize::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyFileTransfer_getFileName::_success(const ::std::string& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyFileTransfer_getFileName::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyFileTransfer_setFilePath::_success()
{
  emit succeeded(_cookie);
}

void Callback_ProxyFileTransfer_setFilePath::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

