#include "proxies_hsetmanager.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyHSetManager::ProxyHSetManager(::Diamesh::HSetManagerPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyHSetManager::~ProxyHSetManager()
{
}

void ProxyHSetManager::_forward_hSetAdded(Ice::Long arg0)
{

  emit hSetAdded(arg0);
}

void ProxyHSetManager::_forward_hSetChanged(Ice::Long arg0)
{

  emit hSetChanged(arg0);
}

void ProxyHSetManager::_forward_hSetRemoved(Ice::Long arg0)
{

  emit hSetRemoved(arg0);
}

::Ice::Long ProxyHSetManager::addHSet(::Ice::Long rank, const ::std::string& name, const ::std::string& description)
{
  return _prx->addHSet(rank, name, description);
}

void ProxyHSetManager::begin_addHSet(::Ice::Long rank, const ::std::string& name, const ::std::string& description, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyHSetManager_addHSetPtr resultsCb = new Callback_ProxyHSetManager_addHSet;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_HSetManager_addHSetPtr __cb = ::Diamesh::newCallback_HSetManager_addHSet(resultsCb, &Callback_ProxyHSetManager_addHSet::_success, &Callback_ProxyHSetManager_addHSet::_failure);
  _prx->begin_addHSet(rank, name, description, __cb);
}



bool ProxyHSetManager::updateHSet(const ::Diamesh::HierarchicalSet& updatedHSet)
{
  return _prx->updateHSet(updatedHSet);
}

void ProxyHSetManager::begin_updateHSet(const ::Diamesh::HierarchicalSet& updatedHSet, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyHSetManager_updateHSetPtr resultsCb = new Callback_ProxyHSetManager_updateHSet;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_HSetManager_updateHSetPtr __cb = ::Diamesh::newCallback_HSetManager_updateHSet(resultsCb, &Callback_ProxyHSetManager_updateHSet::_success, &Callback_ProxyHSetManager_updateHSet::_failure);
  _prx->begin_updateHSet(updatedHSet, __cb);
}



bool ProxyHSetManager::removeHSet(::Ice::Long hSetId)
{
  return _prx->removeHSet(hSetId);
}

void ProxyHSetManager::begin_removeHSet(::Ice::Long hSetId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyHSetManager_removeHSetPtr resultsCb = new Callback_ProxyHSetManager_removeHSet;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_HSetManager_removeHSetPtr __cb = ::Diamesh::newCallback_HSetManager_removeHSet(resultsCb, &Callback_ProxyHSetManager_removeHSet::_success, &Callback_ProxyHSetManager_removeHSet::_failure);
  _prx->begin_removeHSet(hSetId, __cb);
}



::Diamesh::HierarchicalSet ProxyHSetManager::getHSet(::Ice::Long hSetId)
{
  return _prx->getHSet(hSetId);
}

void ProxyHSetManager::begin_getHSet(::Ice::Long hSetId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyHSetManager_getHSetPtr resultsCb = new Callback_ProxyHSetManager_getHSet;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::HierarchicalSet >("::Diamesh::HierarchicalSet");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::HierarchicalSet,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_HSetManager_getHSetPtr __cb = ::Diamesh::newCallback_HSetManager_getHSet(resultsCb, &Callback_ProxyHSetManager_getHSet::_success, &Callback_ProxyHSetManager_getHSet::_failure);
  _prx->begin_getHSet(hSetId, __cb);
}



::Diamesh::HierarchicalSetList ProxyHSetManager::getHSets()
{
  return _prx->getHSets();
}

void ProxyHSetManager::begin_getHSets(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyHSetManager_getHSetsPtr resultsCb = new Callback_ProxyHSetManager_getHSets;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::HierarchicalSetList >("::Diamesh::HierarchicalSetList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::HierarchicalSetList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_HSetManager_getHSetsPtr __cb = ::Diamesh::newCallback_HSetManager_getHSets(resultsCb, &Callback_ProxyHSetManager_getHSets::_success, &Callback_ProxyHSetManager_getHSets::_failure);
  _prx->begin_getHSets(__cb);
}



void Callback_ProxyHSetManager_addHSet::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyHSetManager_addHSet::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyHSetManager_updateHSet::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyHSetManager_updateHSet::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyHSetManager_removeHSet::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyHSetManager_removeHSet::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyHSetManager_getHSet::_success(const ::Diamesh::HierarchicalSet& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyHSetManager_getHSet::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyHSetManager_getHSets::_success(const ::Diamesh::HierarchicalSetList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyHSetManager_getHSets::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

