#include "proxies_master.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyMaster::ProxyMaster(::Diamesh::MasterPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyMaster::~ProxyMaster()
{
}

void ProxyMaster::_forward_nodeAdded(QString arg0)
{

  emit nodeAdded(arg0);
}

void ProxyMaster::_forward_nodeRemoved(QString arg0)
{

  emit nodeRemoved(arg0);
}

bool ProxyMaster::addNode(const ::Diamesh::NodePrx& s, const ::std::string& key)
{
  return _prx->addNode(s, key);
}

void ProxyMaster::begin_addNode(const ::Diamesh::NodePrx& s, const ::std::string& key, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_addNodePtr resultsCb = new Callback_ProxyMaster_addNode;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_addNodePtr __cb = ::Diamesh::newCallback_Master_addNode(resultsCb, &Callback_ProxyMaster_addNode::_success, &Callback_ProxyMaster_addNode::_failure);
  _prx->begin_addNode(s, key, __cb);
}



void ProxyMaster::removeNode(const ::Diamesh::NodePrx& n, const ::std::string& key)
{
  _prx->removeNode(n, key);
}

void ProxyMaster::begin_removeNode(const ::Diamesh::NodePrx& n, const ::std::string& key, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_removeNodePtr resultsCb = new Callback_ProxyMaster_removeNode;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_removeNodePtr __cb = ::Diamesh::newCallback_Master_removeNode(resultsCb, &Callback_ProxyMaster_removeNode::_success, &Callback_ProxyMaster_removeNode::_failure);
  _prx->begin_removeNode(n, key, __cb);
}



::Diamesh::AuthManagerPrx ProxyMaster::getAuthManager()
{
  return _prx->getAuthManager();
}

void ProxyMaster::begin_getAuthManager(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getAuthManagerPtr resultsCb = new Callback_ProxyMaster_getAuthManager;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::AuthManagerPrx >("::Diamesh::AuthManagerPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::AuthManagerPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getAuthManagerPtr __cb = ::Diamesh::newCallback_Master_getAuthManager(resultsCb, &Callback_ProxyMaster_getAuthManager::_success, &Callback_ProxyMaster_getAuthManager::_failure);
  _prx->begin_getAuthManager(__cb);
}



::Diamesh::SessionManagerPrx ProxyMaster::getSessionManager()
{
  return _prx->getSessionManager();
}

void ProxyMaster::begin_getSessionManager(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getSessionManagerPtr resultsCb = new Callback_ProxyMaster_getSessionManager;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SessionManagerPrx >("::Diamesh::SessionManagerPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SessionManagerPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getSessionManagerPtr __cb = ::Diamesh::newCallback_Master_getSessionManager(resultsCb, &Callback_ProxyMaster_getSessionManager::_success, &Callback_ProxyMaster_getSessionManager::_failure);
  _prx->begin_getSessionManager(__cb);
}



::Diamesh::UserManagerPrx ProxyMaster::getUserManager()
{
  return _prx->getUserManager();
}

void ProxyMaster::begin_getUserManager(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getUserManagerPtr resultsCb = new Callback_ProxyMaster_getUserManager;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::UserManagerPrx >("::Diamesh::UserManagerPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::UserManagerPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getUserManagerPtr __cb = ::Diamesh::newCallback_Master_getUserManager(resultsCb, &Callback_ProxyMaster_getUserManager::_success, &Callback_ProxyMaster_getUserManager::_failure);
  _prx->begin_getUserManager(__cb);
}



::Diamesh::NodeInfoMap ProxyMaster::getNodeInfoMap()
{
  return _prx->getNodeInfoMap();
}

void ProxyMaster::begin_getNodeInfoMap(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getNodeInfoMapPtr resultsCb = new Callback_ProxyMaster_getNodeInfoMap;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::NodeInfoMap >("::Diamesh::NodeInfoMap");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::NodeInfoMap,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getNodeInfoMapPtr __cb = ::Diamesh::newCallback_Master_getNodeInfoMap(resultsCb, &Callback_ProxyMaster_getNodeInfoMap::_success, &Callback_ProxyMaster_getNodeInfoMap::_failure);
  _prx->begin_getNodeInfoMap(__cb);
}



::Diamesh::VersionInfo ProxyMaster::getDiameshVersionInfo()
{
  return _prx->getDiameshVersionInfo();
}

void ProxyMaster::begin_getDiameshVersionInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getDiameshVersionInfoPtr resultsCb = new Callback_ProxyMaster_getDiameshVersionInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::VersionInfo >("::Diamesh::VersionInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::VersionInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getDiameshVersionInfoPtr __cb = ::Diamesh::newCallback_Master_getDiameshVersionInfo(resultsCb, &Callback_ProxyMaster_getDiameshVersionInfo::_success, &Callback_ProxyMaster_getDiameshVersionInfo::_failure);
  _prx->begin_getDiameshVersionInfo(__cb);
}



::Diamesh::SystemInfo ProxyMaster::getSystemInfo()
{
  return _prx->getSystemInfo();
}

void ProxyMaster::begin_getSystemInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getSystemInfoPtr resultsCb = new Callback_ProxyMaster_getSystemInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SystemInfo >("::Diamesh::SystemInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SystemInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getSystemInfoPtr __cb = ::Diamesh::newCallback_Master_getSystemInfo(resultsCb, &Callback_ProxyMaster_getSystemInfo::_success, &Callback_ProxyMaster_getSystemInfo::_failure);
  _prx->begin_getSystemInfo(__cb);
}



::Diamesh::ServiceInfo ProxyMaster::getServiceInfo()
{
  return _prx->getServiceInfo();
}

void ProxyMaster::begin_getServiceInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getServiceInfoPtr resultsCb = new Callback_ProxyMaster_getServiceInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ServiceInfo >("::Diamesh::ServiceInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ServiceInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getServiceInfoPtr __cb = ::Diamesh::newCallback_Master_getServiceInfo(resultsCb, &Callback_ProxyMaster_getServiceInfo::_success, &Callback_ProxyMaster_getServiceInfo::_failure);
  _prx->begin_getServiceInfo(__cb);
}



::std::string ProxyMaster::getName()
{
  return _prx->getName();
}

void ProxyMaster::begin_getName(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getNamePtr resultsCb = new Callback_ProxyMaster_getName;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::std::string >("::std::string");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::std::string,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getNamePtr __cb = ::Diamesh::newCallback_Master_getName(resultsCb, &Callback_ProxyMaster_getName::_success, &Callback_ProxyMaster_getName::_failure);
  _prx->begin_getName(__cb);
}



::Diamesh::ACLManagerPrx ProxyMaster::getACLManager()
{
  return _prx->getACLManager();
}

void ProxyMaster::begin_getACLManager(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getACLManagerPtr resultsCb = new Callback_ProxyMaster_getACLManager;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ACLManagerPrx >("::Diamesh::ACLManagerPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ACLManagerPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getACLManagerPtr __cb = ::Diamesh::newCallback_Master_getACLManager(resultsCb, &Callback_ProxyMaster_getACLManager::_success, &Callback_ProxyMaster_getACLManager::_failure);
  _prx->begin_getACLManager(__cb);
}



::Diamesh::HSetManagerPrx ProxyMaster::getHSetManager()
{
  return _prx->getHSetManager();
}

void ProxyMaster::begin_getHSetManager(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getHSetManagerPtr resultsCb = new Callback_ProxyMaster_getHSetManager;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::HSetManagerPrx >("::Diamesh::HSetManagerPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::HSetManagerPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getHSetManagerPtr __cb = ::Diamesh::newCallback_Master_getHSetManager(resultsCb, &Callback_ProxyMaster_getHSetManager::_success, &Callback_ProxyMaster_getHSetManager::_failure);
  _prx->begin_getHSetManager(__cb);
}



::Ice::Long ProxyMaster::getCapabilitiesFlags()
{
  return _prx->getCapabilitiesFlags();
}

void ProxyMaster::begin_getCapabilitiesFlags(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyMaster_getCapabilitiesFlagsPtr resultsCb = new Callback_ProxyMaster_getCapabilitiesFlags;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Master_getCapabilitiesFlagsPtr __cb = ::Diamesh::newCallback_Master_getCapabilitiesFlags(resultsCb, &Callback_ProxyMaster_getCapabilitiesFlags::_success, &Callback_ProxyMaster_getCapabilitiesFlags::_failure);
  _prx->begin_getCapabilitiesFlags(__cb);
}



void Callback_ProxyMaster_addNode::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_addNode::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_removeNode::_success()
{
  emit succeeded(_cookie);
}

void Callback_ProxyMaster_removeNode::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getAuthManager::_success(const ::Diamesh::AuthManagerPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getAuthManager::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getSessionManager::_success(const ::Diamesh::SessionManagerPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getSessionManager::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getUserManager::_success(const ::Diamesh::UserManagerPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getUserManager::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getNodeInfoMap::_success(const ::Diamesh::NodeInfoMap& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getNodeInfoMap::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getDiameshVersionInfo::_success(const ::Diamesh::VersionInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getDiameshVersionInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getSystemInfo::_success(const ::Diamesh::SystemInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getSystemInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getServiceInfo::_success(const ::Diamesh::ServiceInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getServiceInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getName::_success(const ::std::string& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getName::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getACLManager::_success(const ::Diamesh::ACLManagerPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getACLManager::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getHSetManager::_success(const ::Diamesh::HSetManagerPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getHSetManager::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyMaster_getCapabilitiesFlags::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyMaster_getCapabilitiesFlags::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

