#include "proxies_node.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyNode::ProxyNode(::Diamesh::NodePrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyNode::~ProxyNode()
{
}

::std::string ProxyNode::getName()
{
  return _prx->getName();
}

void ProxyNode::begin_getName(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNode_getNamePtr resultsCb = new Callback_ProxyNode_getName;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::std::string >("::std::string");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::std::string,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Node_getNamePtr __cb = ::Diamesh::newCallback_Node_getName(resultsCb, &Callback_ProxyNode_getName::_success, &Callback_ProxyNode_getName::_failure);
  _prx->begin_getName(__cb);
}



::Diamesh::VersionInfo ProxyNode::getDiameshVersionInfo()
{
  return _prx->getDiameshVersionInfo();
}

void ProxyNode::begin_getDiameshVersionInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNode_getDiameshVersionInfoPtr resultsCb = new Callback_ProxyNode_getDiameshVersionInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::VersionInfo >("::Diamesh::VersionInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::VersionInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Node_getDiameshVersionInfoPtr __cb = ::Diamesh::newCallback_Node_getDiameshVersionInfo(resultsCb, &Callback_ProxyNode_getDiameshVersionInfo::_success, &Callback_ProxyNode_getDiameshVersionInfo::_failure);
  _prx->begin_getDiameshVersionInfo(__cb);
}



::Diamesh::SystemInfo ProxyNode::getSystemInfo()
{
  return _prx->getSystemInfo();
}

void ProxyNode::begin_getSystemInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNode_getSystemInfoPtr resultsCb = new Callback_ProxyNode_getSystemInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SystemInfo >("::Diamesh::SystemInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SystemInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Node_getSystemInfoPtr __cb = ::Diamesh::newCallback_Node_getSystemInfo(resultsCb, &Callback_ProxyNode_getSystemInfo::_success, &Callback_ProxyNode_getSystemInfo::_failure);
  _prx->begin_getSystemInfo(__cb);
}



::Diamesh::ServiceInfo ProxyNode::getServiceInfo()
{
  return _prx->getServiceInfo();
}

void ProxyNode::begin_getServiceInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNode_getServiceInfoPtr resultsCb = new Callback_ProxyNode_getServiceInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ServiceInfo >("::Diamesh::ServiceInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ServiceInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Node_getServiceInfoPtr __cb = ::Diamesh::newCallback_Node_getServiceInfo(resultsCb, &Callback_ProxyNode_getServiceInfo::_success, &Callback_ProxyNode_getServiceInfo::_failure);
  _prx->begin_getServiceInfo(__cb);
}



::Diamesh::NodePrx ProxyNode::getPingNodeProxy()
{
  return _prx->getPingNodeProxy();
}

void ProxyNode::begin_getPingNodeProxy(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNode_getPingNodeProxyPtr resultsCb = new Callback_ProxyNode_getPingNodeProxy;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::NodePrx >("::Diamesh::NodePrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::NodePrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_Node_getPingNodeProxyPtr __cb = ::Diamesh::newCallback_Node_getPingNodeProxy(resultsCb, &Callback_ProxyNode_getPingNodeProxy::_success, &Callback_ProxyNode_getPingNodeProxy::_failure);
  _prx->begin_getPingNodeProxy(__cb);
}



void Callback_ProxyNode_getName::_success(const ::std::string& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNode_getName::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNode_getDiameshVersionInfo::_success(const ::Diamesh::VersionInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNode_getDiameshVersionInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNode_getSystemInfo::_success(const ::Diamesh::SystemInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNode_getSystemInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNode_getServiceInfo::_success(const ::Diamesh::ServiceInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNode_getServiceInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNode_getPingNodeProxy::_success(const ::Diamesh::NodePrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNode_getPingNodeProxy::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

