#include "proxies_nodeinfo.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyNodeInfo::ProxyNodeInfo(::Diamesh::NodeInfoPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyNodeInfo::~ProxyNodeInfo()
{
}

::std::string ProxyNodeInfo::getName()
{
  return _prx->getName();
}

void ProxyNodeInfo::begin_getName(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNodeInfo_getNamePtr resultsCb = new Callback_ProxyNodeInfo_getName;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::std::string >("::std::string");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::std::string,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_NodeInfo_getNamePtr __cb = ::Diamesh::newCallback_NodeInfo_getName(resultsCb, &Callback_ProxyNodeInfo_getName::_success, &Callback_ProxyNodeInfo_getName::_failure);
  _prx->begin_getName(__cb);
}



::Diamesh::VersionInfo ProxyNodeInfo::getDiameshVersionInfo()
{
  return _prx->getDiameshVersionInfo();
}

void ProxyNodeInfo::begin_getDiameshVersionInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNodeInfo_getDiameshVersionInfoPtr resultsCb = new Callback_ProxyNodeInfo_getDiameshVersionInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::VersionInfo >("::Diamesh::VersionInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::VersionInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_NodeInfo_getDiameshVersionInfoPtr __cb = ::Diamesh::newCallback_NodeInfo_getDiameshVersionInfo(resultsCb, &Callback_ProxyNodeInfo_getDiameshVersionInfo::_success, &Callback_ProxyNodeInfo_getDiameshVersionInfo::_failure);
  _prx->begin_getDiameshVersionInfo(__cb);
}



::Diamesh::SystemInfo ProxyNodeInfo::getSystemInfo()
{
  return _prx->getSystemInfo();
}

void ProxyNodeInfo::begin_getSystemInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNodeInfo_getSystemInfoPtr resultsCb = new Callback_ProxyNodeInfo_getSystemInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SystemInfo >("::Diamesh::SystemInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SystemInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_NodeInfo_getSystemInfoPtr __cb = ::Diamesh::newCallback_NodeInfo_getSystemInfo(resultsCb, &Callback_ProxyNodeInfo_getSystemInfo::_success, &Callback_ProxyNodeInfo_getSystemInfo::_failure);
  _prx->begin_getSystemInfo(__cb);
}



::Diamesh::ServiceInfo ProxyNodeInfo::getServiceInfo()
{
  return _prx->getServiceInfo();
}

void ProxyNodeInfo::begin_getServiceInfo(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyNodeInfo_getServiceInfoPtr resultsCb = new Callback_ProxyNodeInfo_getServiceInfo;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::ServiceInfo >("::Diamesh::ServiceInfo");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::ServiceInfo,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_NodeInfo_getServiceInfoPtr __cb = ::Diamesh::newCallback_NodeInfo_getServiceInfo(resultsCb, &Callback_ProxyNodeInfo_getServiceInfo::_success, &Callback_ProxyNodeInfo_getServiceInfo::_failure);
  _prx->begin_getServiceInfo(__cb);
}



void Callback_ProxyNodeInfo_getName::_success(const ::std::string& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNodeInfo_getName::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNodeInfo_getDiameshVersionInfo::_success(const ::Diamesh::VersionInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNodeInfo_getDiameshVersionInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNodeInfo_getSystemInfo::_success(const ::Diamesh::SystemInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNodeInfo_getSystemInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyNodeInfo_getServiceInfo::_success(const ::Diamesh::ServiceInfo& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyNodeInfo_getServiceInfo::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

