#include "proxies_sessionManager.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxySessionManager::ProxySessionManager(::Diamesh::SessionManagerPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxySessionManager::~ProxySessionManager()
{
}

void ProxySessionManager::_forward_sessionCreated(QString arg0)
{

  emit sessionCreated(arg0);
}

void ProxySessionManager::_forward_sessionDestroyed(QString arg0)
{

  emit sessionDestroyed(arg0);
}

void ProxySessionManager::_forward_userDisconnected(Ice::Long arg0)
{

  emit userDisconnected(arg0);
}

void ProxySessionManager::disconnectUser(::Ice::Long userId)
{
  _prx->disconnectUser(userId);
}

void ProxySessionManager::begin_disconnectUser(::Ice::Long userId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxySessionManager_disconnectUserPtr resultsCb = new Callback_ProxySessionManager_disconnectUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_SessionManager_disconnectUserPtr __cb = ::Diamesh::newCallback_SessionManager_disconnectUser(resultsCb, &Callback_ProxySessionManager_disconnectUser::_success, &Callback_ProxySessionManager_disconnectUser::_failure);
  _prx->begin_disconnectUser(userId, __cb);
}



::Diamesh::SessionList ProxySessionManager::getSessions()
{
  return _prx->getSessions();
}

void ProxySessionManager::begin_getSessions(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxySessionManager_getSessionsPtr resultsCb = new Callback_ProxySessionManager_getSessions;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SessionList >("::Diamesh::SessionList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SessionList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_SessionManager_getSessionsPtr __cb = ::Diamesh::newCallback_SessionManager_getSessions(resultsCb, &Callback_ProxySessionManager_getSessions::_success, &Callback_ProxySessionManager_getSessions::_failure);
  _prx->begin_getSessions(__cb);
}



::Diamesh::SessionPrx ProxySessionManager::getSession(const ::std::string& sessionId)
{
  return _prx->getSession(sessionId);
}

void ProxySessionManager::begin_getSession(const ::std::string& sessionId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxySessionManager_getSessionPtr resultsCb = new Callback_ProxySessionManager_getSession;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::SessionPrx >("::Diamesh::SessionPrx");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::SessionPrx,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_SessionManager_getSessionPtr __cb = ::Diamesh::newCallback_SessionManager_getSession(resultsCb, &Callback_ProxySessionManager_getSession::_success, &Callback_ProxySessionManager_getSession::_failure);
  _prx->begin_getSession(sessionId, __cb);
}



void Callback_ProxySessionManager_disconnectUser::_success()
{
  emit succeeded(_cookie);
}

void Callback_ProxySessionManager_disconnectUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxySessionManager_getSessions::_success(const ::Diamesh::SessionList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxySessionManager_getSessions::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxySessionManager_getSession::_success(const ::Diamesh::SessionPrx& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxySessionManager_getSession::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

