#include "proxies_usermanager.h"

#include <QtCore/QMetaType>
#include <QtCore/QDebug>

namespace Diamesh {

ProxyUserManager::ProxyUserManager(::Diamesh::UserManagerPrx prx, Ice::ObjectAdapterPtr adapter) :
  QIceObjectProxy(prx, adapter), _prx(prx)
{
}

ProxyUserManager::~ProxyUserManager()
{
}

void ProxyUserManager::_forward_userChanged(Ice::Long arg0)
{

  emit userChanged(arg0);
}

void ProxyUserManager::_forward_userRemoved(Ice::Long arg0)
{

  emit userRemoved(arg0);
}

void ProxyUserManager::_forward_userAdded(Ice::Long arg0)
{

  emit userAdded(arg0);
}

void ProxyUserManager::_forward_groupChanged(Ice::Long arg0)
{

  emit groupChanged(arg0);
}

void ProxyUserManager::_forward_groupRemoved(Ice::Long arg0)
{

  emit groupRemoved(arg0);
}

void ProxyUserManager::_forward_groupAdded(Ice::Long arg0)
{

  emit groupAdded(arg0);
}

::Ice::Long ProxyUserManager::addUser(const ::Diamesh::UserPtr& u)
{
  return _prx->addUser(u);
}

void ProxyUserManager::begin_addUser(const ::Diamesh::UserPtr& u, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_addUserPtr resultsCb = new Callback_ProxyUserManager_addUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_addUserPtr __cb = ::Diamesh::newCallback_UserManager_addUser(resultsCb, &Callback_ProxyUserManager_addUser::_success, &Callback_ProxyUserManager_addUser::_failure);
  _prx->begin_addUser(u, __cb);
}



::Diamesh::LongList ProxyUserManager::cloneUser(const ::Diamesh::UserPtr& u, ::Ice::Int clonesNumber)
{
  return _prx->cloneUser(u, clonesNumber);
}

void ProxyUserManager::begin_cloneUser(const ::Diamesh::UserPtr& u, ::Ice::Int clonesNumber, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_cloneUserPtr resultsCb = new Callback_ProxyUserManager_cloneUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::LongList >("::Diamesh::LongList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::LongList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_cloneUserPtr __cb = ::Diamesh::newCallback_UserManager_cloneUser(resultsCb, &Callback_ProxyUserManager_cloneUser::_success, &Callback_ProxyUserManager_cloneUser::_failure);
  _prx->begin_cloneUser(u, clonesNumber, __cb);
}



bool ProxyUserManager::deleteUser(::Ice::Long userId)
{
  return _prx->deleteUser(userId);
}

void ProxyUserManager::begin_deleteUser(::Ice::Long userId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_deleteUserPtr resultsCb = new Callback_ProxyUserManager_deleteUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_deleteUserPtr __cb = ::Diamesh::newCallback_UserManager_deleteUser(resultsCb, &Callback_ProxyUserManager_deleteUser::_success, &Callback_ProxyUserManager_deleteUser::_failure);
  _prx->begin_deleteUser(userId, __cb);
}



::Diamesh::UserPtr ProxyUserManager::getUser(::Ice::Long userId)
{
  return _prx->getUser(userId);
}

void ProxyUserManager::begin_getUser(::Ice::Long userId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_getUserPtr resultsCb = new Callback_ProxyUserManager_getUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::UserPtr >("::Diamesh::UserPtr");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::UserPtr,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_getUserPtr __cb = ::Diamesh::newCallback_UserManager_getUser(resultsCb, &Callback_ProxyUserManager_getUser::_success, &Callback_ProxyUserManager_getUser::_failure);
  _prx->begin_getUser(userId, __cb);
}



bool ProxyUserManager::updateUser(const ::Diamesh::UserPtr& u)
{
  return _prx->updateUser(u);
}

void ProxyUserManager::begin_updateUser(const ::Diamesh::UserPtr& u, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_updateUserPtr resultsCb = new Callback_ProxyUserManager_updateUser;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_updateUserPtr __cb = ::Diamesh::newCallback_UserManager_updateUser(resultsCb, &Callback_ProxyUserManager_updateUser::_success, &Callback_ProxyUserManager_updateUser::_failure);
  _prx->begin_updateUser(u, __cb);
}



::Ice::Long ProxyUserManager::addGroup(const ::Diamesh::GroupPtr& g)
{
  return _prx->addGroup(g);
}

void ProxyUserManager::begin_addGroup(const ::Diamesh::GroupPtr& g, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_addGroupPtr resultsCb = new Callback_ProxyUserManager_addGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_addGroupPtr __cb = ::Diamesh::newCallback_UserManager_addGroup(resultsCb, &Callback_ProxyUserManager_addGroup::_success, &Callback_ProxyUserManager_addGroup::_failure);
  _prx->begin_addGroup(g, __cb);
}



bool ProxyUserManager::deleteGroup(::Ice::Long groupId)
{
  return _prx->deleteGroup(groupId);
}

void ProxyUserManager::begin_deleteGroup(::Ice::Long groupId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_deleteGroupPtr resultsCb = new Callback_ProxyUserManager_deleteGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_deleteGroupPtr __cb = ::Diamesh::newCallback_UserManager_deleteGroup(resultsCb, &Callback_ProxyUserManager_deleteGroup::_success, &Callback_ProxyUserManager_deleteGroup::_failure);
  _prx->begin_deleteGroup(groupId, __cb);
}



::Diamesh::GroupPtr ProxyUserManager::getGroup(::Ice::Long groupId)
{
  return _prx->getGroup(groupId);
}

void ProxyUserManager::begin_getGroup(::Ice::Long groupId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_getGroupPtr resultsCb = new Callback_ProxyUserManager_getGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::GroupPtr >("::Diamesh::GroupPtr");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::GroupPtr,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_getGroupPtr __cb = ::Diamesh::newCallback_UserManager_getGroup(resultsCb, &Callback_ProxyUserManager_getGroup::_success, &Callback_ProxyUserManager_getGroup::_failure);
  _prx->begin_getGroup(groupId, __cb);
}



bool ProxyUserManager::updateGroup(const ::Diamesh::GroupPtr& g)
{
  return _prx->updateGroup(g);
}

void ProxyUserManager::begin_updateGroup(const ::Diamesh::GroupPtr& g, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_updateGroupPtr resultsCb = new Callback_ProxyUserManager_updateGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_updateGroupPtr __cb = ::Diamesh::newCallback_UserManager_updateGroup(resultsCb, &Callback_ProxyUserManager_updateGroup::_success, &Callback_ProxyUserManager_updateGroup::_failure);
  _prx->begin_updateGroup(g, __cb);
}



bool ProxyUserManager::addUserToGroup(::Ice::Long userId, ::Ice::Long groupId)
{
  return _prx->addUserToGroup(userId, groupId);
}

void ProxyUserManager::begin_addUserToGroup(::Ice::Long userId, ::Ice::Long groupId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_addUserToGroupPtr resultsCb = new Callback_ProxyUserManager_addUserToGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_addUserToGroupPtr __cb = ::Diamesh::newCallback_UserManager_addUserToGroup(resultsCb, &Callback_ProxyUserManager_addUserToGroup::_success, &Callback_ProxyUserManager_addUserToGroup::_failure);
  _prx->begin_addUserToGroup(userId, groupId, __cb);
}



bool ProxyUserManager::removeUserFromGroup(::Ice::Long userId, ::Ice::Long groupId)
{
  return _prx->removeUserFromGroup(userId, groupId);
}

void ProxyUserManager::begin_removeUserFromGroup(::Ice::Long userId, ::Ice::Long groupId, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_removeUserFromGroupPtr resultsCb = new Callback_ProxyUserManager_removeUserFromGroup;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< bool >("bool");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(bool,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_removeUserFromGroupPtr __cb = ::Diamesh::newCallback_UserManager_removeUserFromGroup(resultsCb, &Callback_ProxyUserManager_removeUserFromGroup::_success, &Callback_ProxyUserManager_removeUserFromGroup::_failure);
  _prx->begin_removeUserFromGroup(userId, groupId, __cb);
}



::Diamesh::LongList ProxyUserManager::getUsers()
{
  return _prx->getUsers();
}

void ProxyUserManager::begin_getUsers(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_getUsersPtr resultsCb = new Callback_ProxyUserManager_getUsers;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::LongList >("::Diamesh::LongList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::LongList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_getUsersPtr __cb = ::Diamesh::newCallback_UserManager_getUsers(resultsCb, &Callback_ProxyUserManager_getUsers::_success, &Callback_ProxyUserManager_getUsers::_failure);
  _prx->begin_getUsers(__cb);
}



::Diamesh::LongList ProxyUserManager::getGroups()
{
  return _prx->getGroups();
}

void ProxyUserManager::begin_getGroups(QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_getGroupsPtr resultsCb = new Callback_ProxyUserManager_getGroups;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Diamesh::LongList >("::Diamesh::LongList");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Diamesh::LongList,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_getGroupsPtr __cb = ::Diamesh::newCallback_UserManager_getGroups(resultsCb, &Callback_ProxyUserManager_getGroups::_success, &Callback_ProxyUserManager_getGroups::_failure);
  _prx->begin_getGroups(__cb);
}



::Ice::Long ProxyUserManager::getUserIdFromName(const ::std::string& userName)
{
  return _prx->getUserIdFromName(userName);
}

void ProxyUserManager::begin_getUserIdFromName(const ::std::string& userName, QObject * __receiver, const char * __successSlot, QObject * __fReceiver, const char * __failureSlot, QObject *cookie)
{
  Callback_ProxyUserManager_getUserIdFromNamePtr resultsCb = new Callback_ProxyUserManager_getUserIdFromName;
  resultsCb->moveToThread(this->thread());
  resultsCb->_cookie = cookie;
  qRegisterMetaType< ::Ice::Long >("::Ice::Long");
  qRegisterMetaType< QObject* >("QObject*");
  if (__receiver && __successSlot)
      QObject::connect(resultsCb.get(), SIGNAL(succeeded(::Ice::Long,QObject*)), __receiver, __successSlot);
  if (__fReceiver && __failureSlot)
      QObject::connect(resultsCb.get(), SIGNAL(failed(QSharedPointer<Ice::Exception>, QObject*)), __fReceiver, __failureSlot);
  ::Diamesh::Callback_UserManager_getUserIdFromNamePtr __cb = ::Diamesh::newCallback_UserManager_getUserIdFromName(resultsCb, &Callback_ProxyUserManager_getUserIdFromName::_success, &Callback_ProxyUserManager_getUserIdFromName::_failure);
  _prx->begin_getUserIdFromName(userName, __cb);
}



void Callback_ProxyUserManager_addUser::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_addUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_cloneUser::_success(const ::Diamesh::LongList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_cloneUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_deleteUser::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_deleteUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_getUser::_success(const ::Diamesh::UserPtr& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_getUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_updateUser::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_updateUser::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_addGroup::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_addGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_deleteGroup::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_deleteGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_getGroup::_success(const ::Diamesh::GroupPtr& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_getGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_updateGroup::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_updateGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_addUserToGroup::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_addUserToGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_removeUserFromGroup::_success(bool returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_removeUserFromGroup::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_getUsers::_success(const ::Diamesh::LongList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_getUsers::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_getGroups::_success(const ::Diamesh::LongList& returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_getGroups::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

void Callback_ProxyUserManager_getUserIdFromName::_success(::Ice::Long returnArg)
{
  emit succeeded(returnArg, _cookie);
}

void Callback_ProxyUserManager_getUserIdFromName::_failure(const Ice::Exception& ex)
{
  emit failed(QSharedPointer<Ice::Exception>(ex.ice_clone()), _cookie);
}

} // Diamesh

