add_custom_target(lupdate)

macro(diamesh_create_translation outfiles qrc_prefix)
  set(_ts_files)
  set(_src_files)
  foreach(_file ${ARGN})
    get_filename_component(_ext ${_file} EXT)
    get_filename_component(_abs_file ${_file} ABSOLUTE)
    if(_ext MATCHES "ts")
      list(APPEND _ts_files ${_abs_file})
    else()
      list(APPEND _src_files ${_abs_file})
    endif()
  endforeach()

  get_directory_property(_inc_dirs INCLUDE_DIRECTORIES)
  set(_pro_incs)
  foreach(_inc_dir ${_inc_dirs})
    set(_pro_incs "${_pro_incs} \"${_inc_dir}\"")
  endforeach()

  foreach(_ts_file ${_ts_files})
    get_filename_component(_ts_name ${_ts_file} NAME_WE)
    set(_ts_pro ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${_ts_name}_lupdate.pro)
    set(_pro_srcs)
    foreach(_pro_src ${_src_files})
      set(_pro_srcs "${_pro_srcs} \"${_pro_src}\"")
    endforeach()
    file(WRITE ${_ts_pro} "SOURCES = ${_pro_srcs} \n\nINCLUDEPATH = ${_pro_incs}")

    add_custom_target(lupdate_${_ts_name}
      ${QT_LUPDATE_EXECUTABLE} ${_ts_pro} -ts ${_ts_file}
      DEPENDS ${_src_files}
      COMMENT "Running lupdate on ${_ts_name}.ts")
    add_dependencies(lupdate lupdate_${_ts_name})
  endforeach()

  qt4_add_translation(_qm_files ${_ts_files})

  set(_res_file ${CMAKE_CURRENT_BINARY_DIR}/${qrc_prefix}_i18n.qrc)
  file(WRITE ${_res_file} "<!DOCTYPE RCC><RCC version=\"1.0\">\n"
       "<qresource prefix=\"/i18n\">\n")
  foreach(_file ${_qm_files})
    get_filename_component(_file_name ${_file} NAME)
    file(APPEND ${_res_file} " <file>${_file_name}</file>\n")
  endforeach()
  file(APPEND ${_res_file} "</qresource>\n</RCC>\n")

  qt4_add_resources(${outfiles} ${_res_file})
endmacro(diamesh_create_translation)
