/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DIAMESH_APPLICATION_H
#define DIAMESH_APPLICATION_H

#include <Ice/CommunicatorF.h>
#include <Ice/PropertiesF.h>
#include <QtCore/QHash>
#include <QtGui/QApplication>

class QTranslator;
struct option;

namespace Diamesh {

class Instance;

class Application : public QApplication
{
    Q_OBJECT

protected:
    explicit Application(int &argc, char **argv, Instance *instance);

public:
    virtual ~Application();

    static Application *create(int &argc, char **argv, const option *opts, const QHash<QString, QString> &appConfigHash = QHash<QString, QString>());
    static Application *instance();

    bool notify(QObject *receiver, QEvent *event);

private:
    QTranslator *_diameshGuiTranslator;
};

}

#endif // DIAMESH_APPLICATION_H
