/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DIAMESH_CONNECTIONWIDGET_H
#define DIAMESH_CONNECTIONWIDGET_H

#include <QtGui/QDialog>
#include <QtGui/QWidget>
#include <QtCore/QStringList>
#include <QtCore/QSharedPointer>
#include <diamesh/sessionhelper.h>

namespace Diamesh
{

namespace Ui {
    class ConnectionWidget;
}

class ConnectionWidget : public QWidget
{
    Q_OBJECT

public:
    explicit ConnectionWidget(QWidget *parent = 0);
    virtual ~ConnectionWidget();

private slots:
    void on_rememberCheckBox_toggled(bool checked);
    void on_buttonBox_accepted();
    void on_usernameComboBox_editTextChanged(const QString &userName);

signals:
    void connecting();
    void connectFailed();
    void connected(QSharedPointer<SessionHelper>);
    void rejected();

private:
    Ui::ConnectionWidget *_ui;
    SessionHelperFactory *_factory;
};

class ConnectionDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ConnectionDialog(QWidget *parent = 0);
    virtual ~ConnectionDialog();

    QSharedPointer<SessionHelper> sessionHelper();

signals:
    void connecting();
    void connectFailed();

private slots:
    void _accept(QSharedPointer<SessionHelper> sessionHelper);

private:
    QSharedPointer<SessionHelper> _sessionHelper;
};

}

#endif // DIAMESH_CONNECTIONWIDGET_H
