#ifndef DIAMESH_CONSTANTS_H
#define DIAMESH_CONSTANTS_H

namespace Diamesh {
namespace Constants {

const char SETTINGS_GROUP[] = "Diamesh";
const char SESSION_MANAGER_GROUP[] = "SessionManager";
const char NODE_KEY_SETTING[] = "Key";

const char SETTINGS_ALLOWED_FSTYPE[] = "AllowedFileSystems";
const char SETTINGS_SHORTNAME[] = "ShortName";
const char SETTINGS_DESCRIPTION[] = "Description";

const char SETTINGS_LOG_METHOD[]    = "LogMethod";
const char SETTINGS_LOG_DEFAULT[]   = "Default";
const char SETTINGS_LOG_SYSTEM[]    = "System";
const char SETTINGS_LOG_FILE[]      = "File";
const char SETTINGS_LOG_FILENAME[]  = "LogFile";
const char SETTINGS_LOG_LEVEL[]     = "LogLevel";
const char SETTINGS_TRANSLATION_LANGUAGE[] = "Lang";

const char * const ACCESS_RIGHT_SEPARATOR = ".";
const char * const RIGHT_NAME_SEPARATOR = " ";

const char * const ACL_MANAGER_PROXY_NAME   = "ACLManager";
const char * const ACL_TARGET_FIELD_NAME    = "target";
const char * const ACL_SUBJECT_FIELD_NAME   = "subject";
const char * const ACL_RIGHTS_FIELD_NAME    = "rights";
const char * const ACL_HSETID_FIELD_NAME    = "hsetid";
const char * const ACL_TARGET_GENERIC_ID    = "*";
const char * const ACL_TARGET_ALL_TARGETS   = "*";
const char * const ACL_ALL_RIGHTS           = "*";

const char * const ACL_TARGET_USER          = "u";
const char * const ACL_TARGET_GROUP         = "g";

const char * const RIGHT_TARGET_GLOBAL_USERMANAGER              = "usermanager";
const char * const RIGHT_DIAMESH_USERMANAGER_USER_ADD           = "diamesh.usermanager.user.add";
const char * const RIGHT_DIAMESH_USERMANAGER_USER_EDIT          = "diamesh.usermanager.user.edit";
const char * const RIGHT_DIAMESH_USERMANAGER_USER_DELETE        = "diamesh.usermanager.user.delete";
const char * const RIGHT_DIAMESH_USERMANAGER_GROUP_ADD          = "diamesh.usermanager.group.add";
const char * const RIGHT_DIAMESH_USERMANAGER_GROUP_EDIT         = "diamesh.usermanager.group.edit";
const char * const RIGHT_DIAMESH_USERMANAGER_GROUP_DELETE       = "diamesh.usermanager.group.delete";
const char * const RIGHT_DIAMESH_USERMANAGER_GROUP_USERS_ADD    = "diamesh.usermanager.group.users.add";
const char * const RIGHT_DIAMESH_USERMANAGER_GROUP_USERS_REMOVE = "diamesh.usermanager.group.users.remove";
const char * const RIGHT_DIAMESH_USER_SESSION                   = "diamesh.user.session";
const char * const RIGHT_DIAMESH_USER_DISCONNECT                = "diamesh.user.disconnect";
const char * const RIGHT_DIAMESH_USER_PASSWORD                  = "diamesh.user.password";
const char * const RIGHT_DIAMESH_USER                           = "diamesh.user"; //No need to register, it is automatically done with the rights abovs

const char * const HSET_MANAGER_PROXY_NAME  = "HSetManager";
const char * const HSET_ID_FIELD_NAME       = "id";
const char * const HSET_RANK_FIELD_NAME     = "rank";
const char * const HSET_NAME_FIELD_NAME     = "name";
const char * const HSET_DESC_FIELD_NAME     = "description";

const char * const APP_CONFIG_NAME = "appConfigName";
const char * const APP_CONFIG_ORGANIZATION = "appConfigOrganization";

const qlonglong CUSTOM_MASTER_FLAG = 0x100000000;

} // namespace Constants
} // namespace Diamesh

#endif // DIAMESH_CONSTANTS_H
