/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DIAMESH_H
#define DIAMESH_H

#include <QtCore/QObject>
#include <QtCore/QHash>
#include <Ice/PropertiesF.h>

class QTranslator;
struct option;

namespace Diamesh
{

class Instance : public QObject
{
    Q_OBJECT

public:
    // This should not be called directly, use initialize() instead
    Instance(const Ice::PropertiesPtr &props, const QHash<QString, QString> &parsedOpts, const QHash<QString, QString> &appConfigHash);
    ~Instance();

    QString configFileName();
    const QHash<QString, QString> &parsedOpts();
    Ice::PropertiesPtr props();
    void handleException();
    void loadTranslations();
    void loadExternalTranslations(QString fileName);
    static QString extTr(QString translationId);
    const QHash<QString, QString> &appConfigHash();
    QString applicationLanguage();

signals:
    void connectionExceptionCatched();

private:
    Ice::PropertiesPtr _props;
    QHash<QString, QString> _parsedOpts;
    QTranslator *_qtTranslator;
    QTranslator *_diameshTranslator;
    QHash<QString, QString> _externalTranslations;
    QHash<QString, QString> _appConfigHash;
};

Instance *initialize(int &argc, char **argv, const QVector<option> &options, const QHash<QString, QString> &appConfigHash);
Instance *instance();

}

#endif // DIAMESH_H
