/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef FILETRANSFERI_H
#define FILETRANSFERI_H
#include "diamesh/qiceobj_filetransfer.h"
#include "diamesh/types.h"
#include <Glacier2/Glacier2.h>
#include <QtCore/QFile>
#include <QtCore/QByteArray>

namespace Diamesh
{

class FileTransferI : public _Diamesh_FileTransfer
{
public:
    explicit FileTransferI(const QString fileName, Ice::ObjectAdapterPtr adapter);
    ~FileTransferI();
    Diamesh::ByteArray readFile(Ice::Long offset, Ice::Long num, const Ice::Current &);
    Ice::Long getSize(const Ice::Current &);
    std::string getFileName(const Ice::Current &);
    FileTransferPrx proxy();
    void setFilePath(const std::string&, const Ice::Current &);

private :
    QFile _file;
    QString _filePath;
    Ice::ObjectAdapterPtr _adapter;
    Ice::Identity _id;
};

} //Namespace Diamesh
#endif // FILETRANSFERI_H
