/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef GETFILE_H
#define GETFILE_H

#include"diamesh/filetransferI.h"
#include "diamesh/proxies_filetransfer.h"
#include <QtCore/QByteArray>
#include <QtCore/QtConcurrentRun>
#include <QtCore/QObject>
#include<QtCore/QFileInfo>

namespace Diamesh
{
class FileTransferClient : public QObject
{
    Q_OBJECT
public:
    explicit FileTransferClient(FileTransferPrx file, Ice::ObjectAdapterPtr adapter, QObject *parent = 0);
    ~FileTransferClient();
    QString getOriginalFileName();
    QFileInfo getFileWritten();
    Ice::Long getSize();
    void start(QString fileDest, Ice::Long offset = 0, Ice::Long numberOfBytesToTransfer = 1048000);

signals:
    void percentTransfer(int actualPercentOfTransfer);
    void transferIsFinished();
    void fileSize(Ice::Long fileSize);
    void fileName(QString filename);

private slots:
    void _getFileSizeSlot(::Ice::Long);
    void _getOriginalFileNameSlot(::std::string);
    void _transferIsFinished();
    void _progress(int progress);

private :
    void _askSize();
    void _askOriginalFileName();
    QFuture<void> _getFile();
    void _getFileThread(QString fileDest, Ice::Long offset, Ice::Long numberOfBytesToTransfer);
    FileTransferQPrx _fileQPrx;
    Ice::Long _fileSize;
    QByteArray _arrayFile;
    QFileInfo _fileWritten;
    QString _fileNameOriginal;
    QString _fileDest;
    Ice::Long _offset;
    Ice::Long _numberOfBytesToTransfer;

};
}//Diamesh
#endif // GETFILE_H
