// ****************************************************************************
//
// Copyright (C) 2013 DIATEAM. All rights reserved.
//
// This file is part of diamesh.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef HSETMANAGER_ICE
#define HSETMANAGER_ICE

#include <QtIce/qtice.ice>
[["cpp:include:list"]]

module Diamesh
{

struct HierarchicalSet
{
    long id;
    long rank;
    string name;
    string description;
};

["cpp:type:std::list<Diamesh::HierarchicalSet>"]
sequence<HierarchicalSet> HierarchicalSetList;

["signal:void hSetAdded(Ice::Long)",
"signal:void hSetChanged(Ice::Long)",
"signal:void hSetRemoved(Ice::Long)"]
interface HSetManager extends QtIce::SignalEmitter
{
    long addHSet(long rank, string name, string description);
    bool updateHSet(HierarchicalSet updatedHSet);
    bool removeHSet(long hSetId);
    HierarchicalSet getHSet(long hSetId);
    HierarchicalSetList getHSets();
};

};

#endif // HSETMANAGER_ICE
