// ****************************************************************************
//
// Copyright (C) 2011-2012 DIATEAM. All rights reserved.
//
// This file is part of diamesh.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef INFO_ICE
#define INFO_ICE

#include <diamesh/types.ice>

module Diamesh {

["cpp:comparable"]
struct DiskInfo
{
    string filesystem;
    string mountPoint;
    long totalSpace;
    long usedSpace;
    long freeSpace;
    double percentageUsed;
};

["cpp:type:std::list<Diamesh::DiskInfo>"]
sequence<DiskInfo> DiskInfoList;

struct VersionInfo
{
    string version;
    string versionDescription;
    string revision;
    string buildDate;
    string buildTime;
};

["cpp:comparable"]
struct SystemInfo
{
    string kernelInfo;
    StringList processors;
    int uptime; //in seconds
    double cpuUsage;
    long freeMemory;
    long totalMemory;
    long freeSwap;
    long totalSwap;
    DiskInfoList disks;
};

struct ServiceInfo
{
    string name;
    string shortName;
    string description;
    string host;
    string maxThread;
    int uptime;
};

};

#endif // INFO_ICE
