// ****************************************************************************
//
// Copyright (C) 2011-2012 DIATEAM. All rights reserved.
//
// This file is part of diamesh.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef _MASTER_ICE
#define _MASTER_ICE

#include <diamesh/node.ice>
#include <diamesh/usermanager.ice>
#include <QtIce/qtice.ice>
#include <diamesh/info.ice>

module Diamesh
{

interface AuthManager;
interface SessionManager;
interface UserManager;
interface NodeInfo;
interface ACLManager;
interface HSetManager;

dictionary<string, NodeInfo*> NodeInfoMap;
// serialized proxy
["signal:void nodeAdded(QString)", 
"signal:void nodeRemoved(QString)"]
interface Master extends QtIce::SignalEmitter
{
    bool addNode(Node* s, string key);
    void removeNode(Node *n, string key);
    AuthManager* getAuthManager();
    SessionManager* getSessionManager();
    UserManager* getUserManager();
    NodeInfoMap getNodeInfoMap();
    VersionInfo getDiameshVersionInfo();
    SystemInfo getSystemInfo();
    ServiceInfo getServiceInfo();
    string getName();
    ACLManager* getACLManager();
    HSetManager* getHSetManager();
    long getCapabilitiesFlags();
};

};

#endif // _MASTER_ICE
