/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NODE_H
#define NODE_H

#include <diamesh/master.h>
#include <diamesh/node.h>
#include <QtCore/QString>
#include <QtCore/QObject>

#include <diamesh/qiceobj_node.h>
class QSettings;

namespace Diamesh
{

class ServiceDetails;

class NodeI : public _Diamesh_Node
{
    Q_OBJECT

public:
    NodeI();
    ~NodeI();

    std::string getName(const ::Ice::Current & = Ice::Current());
    VersionInfo getDiameshVersionInfo(const ::Ice::Current & = Ice::Current());
    SystemInfo getSystemInfo(const ::Ice::Current & = Ice::Current());
    ServiceInfo getServiceInfo(const ::Ice::Current & = Ice::Current());
    NodePrx getPingNodeProxy(const ::Ice::Current & = Ice::Current());
    std::string getHost();

    Ice::ObjectAdapterPtr adapter();
    QString key();
    void setKey(const QString &key);
    void setShortName(const QString &shortName);
    void setDescription(const QString &description);

    bool connectToMaster();

    static NodeI *instance();

    const MasterPrx &master();

private slots:
    virtual void _shutdown();

private:
    QString _keyFromSettings();

    Ice::CommunicatorPtr _communicator;
    Ice::ObjectAdapterPtr _adapter;
    Ice::ObjectAdapterPtr _pingAdapter;

    MasterPrx _master;
    Ice::Identity _id;

    static NodeI *_instance;
    QSettings *_settings;
    NodePrx _nodeProxy;
    NodePrx _pingNodeProxy;
    ServiceDetails * _serviceDetails;
};

}

#endif // NODE_H
