/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DIAMESH_NODEINFOI_H
#define DIAMESH_NODEINFOI_H

#include <diamesh/qiceobj_nodeinfo.h>
#include <diamesh/node.h>
#include <QtCore/QString>

namespace Diamesh {

class NodeInfoI : public _Diamesh_NodeInfo
{
    Q_OBJECT

public:
    NodeInfoI(const QString &nodeKey, const NodePrx &node);

    std::string getName(const ::Ice::Current & = Ice::Current());
    Diamesh::VersionInfo getDiameshVersionInfo(const ::Ice::Current & = Ice::Current());
    Diamesh::SystemInfo getSystemInfo(const ::Ice::Current & = Ice::Current());
    ServiceInfo getServiceInfo(const ::Ice::Current & = Ice::Current());

    const NodePrx &node();
    Ice::Identity identity();
    void emitNodeRemoved();
    void destroy();
    bool hasNodeBeenRemoved();

signals:
    void nodeRemoved();

private:
    QString _nodeKey;
    NodePrx _node;
    Ice::Identity _identity;
    QAtomicInt _hasNodeBeenRemoved;
};

} // namespace Diamesh

#endif // DIAMESH_NODEINFOI_H
