/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NODEPOLLER_H
#define NODEPOLLER_H


#include <diamesh/node.h>
#include <QThread>
#include <QMutex>

namespace Diamesh
{
class MasterI;

class NodePoller : public QObject
{
    Q_OBJECT
    friend class MasterI;
public:

    NodePoller(const NodePrx &node, const QString &key);
    void timerEvent(QTimerEvent *);
    virtual ~NodePoller();
    virtual void execute();
    virtual void stop();
private slots:
    void _start();


protected slots:
    void _moveToExecutionThread();
    void _killTimerSlot();

signals:
    void nodeDisconnected(const QString & key);
    void killTimerSignal();

protected:
    void run();

private:

    int _timerId;
    QString _key;
    NodePrx _mapNodePrx;
    QThread *_executionThread;
    QMutex _mutexStop;
    bool _stop;
};

}

#endif //NODEPOLLER_H
