// ****************************************************************************
//
// Copyright (C) 2011-2012 DIATEAM. All rights reserved.
//
// This file is part of diamesh.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef _SESSION_MANAGER_ICE
#define _SESSION_MANAGER_ICE
#include <Glacier2/Session.ice>
#include <diamesh/master.ice>
#include <QtIce/qtice.ice>

[["cpp:include:string"]]

module Diamesh
{

struct SessionInfo
{
    string ipAddress = "";
    long userId = 0;
    long connectionDateTime = 0;
};

interface Session extends Glacier2::Session
{
	Master* getMaster();
  SessionInfo getInfo();
};

["cpp:type:std::list<SessionPrx>"]
sequence<Session *> SessionList;

["signal:void sessionCreated(QString)",
"signal:void sessionDestroyed(QString)",
"signal:void userDisconnected(Ice::Long)"]
interface SessionManager extends QtIce::SignalEmitter, Glacier2::SessionManager
{
    void disconnectUser(long userId);
    SessionList getSessions();
    Session *getSession(string sessionId);
};

};

#endif // _SESSION_MANAGER_ICE
