/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SQLDATABASE_H
#define SQLDATABASE_H

#include <QtCore/QMutex>
#include <QtCore/QObject>
#include <QtSql/QSqlDatabase>

class QSqlRecord;

namespace Diamesh
{

class SqlDatabase : public QObject
{
    Q_OBJECT

public:
    SqlDatabase(const QString &type, const QString &dbName, QObject *parent = 0);
    SqlDatabase(const QString &type, const QString &dbName, const QString &host,
                int port, const QString &user, const QString &password, QObject *parent = 0);
    virtual ~SqlDatabase();

    qlonglong executeQuery(const QString &queryStr, const QList<QVariant> &values, QList<QSqlRecord> *results = 0);
    qlonglong executeQuery(const QString &queryStr, const QVariant &value, QList<QSqlRecord> *results = 0);

private:
    void _init(const QString &type, const QString &dbName, const QString &host = QString(),
               int port = 0, const QString &user = QString(), const QString &password = QString());
    QString _getConnectionName();

    QSqlDatabase _mainDb;
    QMutex _mutex;
};

}

#endif // SQLDATABASE_H
