/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <QtCore/QString>

namespace Diamesh
{

  QString absolutePath(const QString &path);
  bool removeDirectory(const QString &path);
  bool copyDirectory(const QString &fromPath, const QString &toPath);

  void setFlags(int flagsToSet, int &currentFlags, bool enabled = true);

  ssize_t saferead(int fd, void *buf, size_t count);
  ssize_t safewrite(int fd, const void *buf, size_t count);

};

#endif // UTILS_H
