DROP TABLE IF EXISTS users;
CREATE TABLE users(id integer primary key autoincrement, name text unique not null, isEnabled integer, createdOn integer, modifiedOn integer, hsetid integer, firstname text, lastname text, isAdvanced integer);
DROP TABLE IF EXISTS groups;
CREATE TABLE groups(id integer primary key autoincrement, name text unique not null, createdOn integer, modifiedOn integer, hsetid integer);
DROP TABLE IF EXISTS join_groups_users;
CREATE TABLE join_groups_users(groupId integer references groups(id) on delete cascade, userId integer references users(id) on delete cascade);
DROP TABLE IF EXISTS auth;
CREATE TABLE auth(userName text primary key, password text, salt text);
DROP TABLE IF EXISTS hsets;
CREATE TABLE hsets(id integer primary key autoincrement, rank integer, name text, description text);
DROP TABLE IF EXISTS acls;
CREATE TABLE acls(target text, subject text, rights text, hsetid integer, primary key(target, subject));

DELETE FROM sqlite_sequence;

INSERT INTO "users" VALUES(1,'admin',1,1302072183,1302072183,1,'Administrator','user', 0);
INSERT INTO "users" VALUES(2,'user1',1,1302072462,1302072462,2,'User1','user', 0);
INSERT INTO "groups" VALUES(1,'admin',1302072183,1302072183,1);
INSERT INTO "groups" VALUES(2,'user1',1302072462,1302072462,2);
INSERT INTO "join_groups_users" VALUES(1,1);
INSERT INTO "join_groups_users" VALUES(2,2);
INSERT INTO "auth" VALUES('admin','81c6aa093f4fe6430bbc5f9f7fa8a7db7f83a7cc','0f54d32588fd461c714b8238db95a4cf6fe778a0');
INSERT INTO "auth" VALUES('user1','8789794ca26d98d0e4adea2bc51ca55ce699fee3','ee3f25ea38a00a788e448d4cf44dee5b08da409f');
-- User Admin/ password Admin
-- User user1/ password user1
INSERT INTO "hsets" VALUES(1,0,'Administrators','Administrators rank');
INSERT INTO "hsets" VALUES(2,1,'Users','User users');
INSERT INTO "acls" VALUES("*","u.1","*",1);
INSERT INTO "acls" VALUES("u.2","u.2","diamesh.usermanager.user.edit diamesh.user",1);
INSERT INTO "acls" VALUES("g.2","u.2","diamesh.usermanager.group.edit diamesh.usermanager.group.users.add diamesh.usermanager.group.users.remove",1);
INSERT INTO "sqlite_sequence" VALUES('users',2);
INSERT INTO "sqlite_sequence" VALUES('groups',2);
INSERT INTO "sqlite_sequence" VALUES('hsets',2);
INSERT INTO "sqlite_sequence" VALUES('acls',3);
