/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include <diamesh/version.h>
#include <diamesh/info.h>

namespace Diamesh {

const char * buildDate()
{
    return __DATE__;
}

const char * buildTime()
{
    return __TIME__;
}

static VersionInfo initInfo()
{
    VersionInfo info;
    info.version = DIAMESH_VERSION_STR;
    info.versionDescription = DIAMESH_VERSION_DESCRIPTION_STR;
    info.revision = DIAMESH_REVISION_STR;
    info.buildDate = Diamesh::buildDate();
    info.buildTime = Diamesh::buildTime();
    return info;
}
static VersionInfo info = initInfo();

const VersionInfo &versionInfo()
{
    return info;
}

}
