#ifndef DIAMESH_VERSION_H
#define DIAMESH_VERSION_H

namespace Diamesh {

struct VersionInfo;

#define STRINGIFY_INTERNAL(x) #x
#define STRINGIFY(x) STRINGIFY_INTERNAL(x)

#cmakedefine DIAMESH_VERSION_MAJOR ${DIAMESH_VERSION_MAJOR}
#ifndef DIAMESH_VERSION_MAJOR
#  define DIAMESH_VERSION_MAJOR 0
#endif

#cmakedefine DIAMESH_VERSION_MINOR ${DIAMESH_VERSION_MINOR}
#ifndef DIAMESH_VERSION_MINOR
#  define DIAMESH_VERSION_MINOR 0
#endif

#cmakedefine DIAMESH_VERSION_RELEASE ${DIAMESH_VERSION_RELEASE}
#ifndef DIAMESH_VERSION_RELEASE
#  define DIAMESH_VERSION_RELEASE 0
#endif

#define DIAMESH_VERSION STRINGIFY(DIAMESH_VERSION_MAJOR) \
    "." STRINGIFY(DIAMESH_VERSION_MINOR) \
    "." STRINGIFY(DIAMESH_VERSION_RELEASE)

const char * const DIAMESH_VERSION_STR = DIAMESH_VERSION;

#cmakedefine DIAMESH_VERSION_DESCRIPTION "${DIAMESH_VERSION_DESCRIPTION}"
#ifdef DIAMESH_VERSION_DESCRIPTION
const char * const DIAMESH_VERSION_DESCRIPTION_STR = STRINGIFY(DIAMESH_VERSION_DESCRIPTION);
#else
const char * const DIAMESH_VERSION_DESCRIPTION_STR = "";
#endif

#cmakedefine DIAMESH_REVISION ${DIAMESH_REVISION}
#ifdef DIAMESH_REVISION
const char * const DIAMESH_REVISION_STR = STRINGIFY(DIAMESH_REVISION);
#else
const char * const DIAMESH_REVISION_STR = "";
#endif

#undef DIAMESH_VERSION
#undef STRINGIFY
#undef STRINGIFY_INTERNAL

const char * buildDate();
const char * buildTime();
const VersionInfo &versionInfo();

} // namespace Diamesh

#endif /* DIAMESH_VERSION_H */
