/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include <diamesh/coreapplication.h>
#include <diamesh/nodeI.h>
#include <QtCore/QDebug>
#include <diamesh/diamesh.h>
#include <Ice/ObjectAdapter.h>

int main(int argc, char **argv)
{
    Diamesh::CoreApplication * app = Diamesh::CoreApplication::create(argc, argv, NULL);
    Q_UNUSED(app);
    Diamesh::NodeI node;
    node.adapter()->activate();

    // Check that the node can not connect to the master with a wrong key
    node.setKey("unknownNodeKey");
    
    if(node.connectToMaster())
    {
      qCritical() << "Node: the connection to the master should have failed with key" << node.key();
      return 1;
    }

    // Check that the node can connect to the master with a right key
    node.setKey("node1");
    
    if(!node.connectToMaster())
    {
      qCritical() << "Node: unable to connect to the master";
      return 1;
    }

    qDebug() << "Node connected to master. OK. Exiting";
    return 0;
}
