/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include <diamesh/coreapplication.h>
#include <diamesh/sessionhelper.h>
#include <diamesh/sessionManager.h>
#include <QtCore/QDebug>
#include <diamesh/diamesh.h>
#include "testmaster.h"

int main(int argc, char **argv)
{
    Diamesh::CoreApplication * app = Diamesh::CoreApplication::create(argc, argv, NULL);
    Q_UNUSED(app);
    Diamesh::SessionHelperFactory sessionFactory;

    QSharedPointer<Diamesh::SessionHelper> sessionHelper = sessionFactory.connect("admin", "doedoe");
    if(sessionHelper)
    {
        qCritical() << "The session should not have been created, as the password is wrong.";
        return 1;
    }

    sessionHelper = sessionFactory.connect();
    if(!sessionHelper)
    {
        qCritical() << "The session should have been created, as the password is right.";
        return 1;
    }

    Diamesh::TestMasterPrx master = Diamesh::TestMasterPrx::uncheckedCast(sessionHelper->session()->getMaster());
    if(!master->userAllowed())
    {
        qCritical() << "The client is not allowed to perform a basic call on the master";
        return 1;
    }

    qDebug() << "Client got session. OK. Exiting";
    return 0;
}
