/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include "testmasterI.h"

#include <diamesh/sessionManagerI.h>
#include <QtCore/QDebug>

bool Diamesh::TestMasterI::userAllowed(const Ice::Current &cur)
{
    ::Ice::Context ctx = cur.ctx;
    if (ctx.find("auth") == ctx.end()) {
        qCritical() << tr("The authentication context was not found.");
        return false;
    }
    QString sessionId = ctx.at("auth").c_str();
    Ice::Long userId = _sessionManager->userFromSessionId(sessionId);
    if (userId == 0) {
        qCritical() << tr("No user is registered with the session id %1.").arg(sessionId);
        return false;
    }
    return true;
}
