/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of diamesh.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include <QtTest/QtTest>

#include <diamesh/sqldatabase.h>
#include <diamesh/sqluserstorage.h>

class tst_SqlUserStorage : public QObject
{
    Q_OBJECT

public:
    tst_SqlUserStorage();
    virtual ~tst_SqlUserStorage();

private slots:
    void getUsers();
    void addUsers();
    void updateUsers();

    void getGroups();
    void addGroups();
    void updateGroups();

    void changeMembership();
    void deleteUsersAndGroups();

private:
    Diamesh::SqlDatabase *_db;
    Diamesh::SqlUserStorage *_storage;
};

Q_DECLARE_METATYPE(std::string)
