// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ARCHIVEDESCRIPTOR_ICE
#define ARCHIVEDESCRPITOR_ICE

#include <diamesh/types.ice>
module Hns
{
    module FileType
    {
        const int PLAIN_FOLDER = 1;
        const int COMPRESSED_FILE = 2;
    };
    struct FolderDescriptor
    {
        string shortName;
        string longName;
        string description;
        Diamesh::StringList tags;
        long id;
        long parentId; // 0 for root
    };
    struct EntityDescriptor
    {
        string type;
        string shortName;
        string longName;
        string description;
        string path;
        string uuid;
        int fileType;
        string fileLocation; //Optionnal, only if it is not a plain folder
        Diamesh::StringList tags;
        long parentId;
        string customGraphic;
    };
    struct TopologyDescriptor
    {
        string shortName;
        string longName;
        string description;
        string path;
        string uuid;
        Diamesh::StringList tags;
        Diamesh::StringList dependencies;
    };
    ["cpp:type:std::list<FolderDescriptor>"]
    sequence <FolderDescriptor> FolderDescriptorList;
    ["cpp:type:std::list<EntityDescriptor>"]
    sequence <EntityDescriptor> EntityDescriptorList;
    ["cpp:type:std::list<TopologyDescriptor>"]
    sequence <TopologyDescriptor> TopologyDescriptorList;
    dictionary <string, string> BaseEntityMap;

    class Descriptor
    {
    };
    
    class ArchiveDescriptor extends Descriptor
    {
        string name;
        long creationDateTime; //timestamp
        FolderDescriptorList folders;
        EntityDescriptorList entities;
        BaseEntityMap baseEntities;
        TopologyDescriptorList topologies;
        Diamesh::StringList customResources;
    };
    class EntityEntryDescriptor extends Descriptor
    {
        EntityDescriptor entity;
    };

};
#endif // ARCHIVEDESCRIPTOR_ICE
