#include "cloneutils.h"

#include "common/domainentry.h"

#include <QString>

namespace Hns {

bool canHandleLinkedClone(EntityEntryPtr entityEntry)
{
    if (entityEntry->isModel)
        return false;
    DomainEntryPtr domainEntry = DomainEntryPtr::dynamicCast(entityEntry);
    if (!domainEntry)
        return false;
    if (!domainEntry->baseUuid.empty())
        return false;
    QString domainType = QString::fromStdString(domainEntry->type);
    if (domainType != "kvm" && domainType != "qemu")
        return false;
    return true;
}

} // namespace Hns
