// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef CUSTOM_RESOURCE_MANAGER_ICE
#define CUSTOM_RESOURCE_MANAGER_ICE

#include <QtIce/qtice.ice>
#include <diamesh/types.ice>
#include "common/types.ice"

module Hns
{

["signal:void resourceAdded(QString)",
"signal:void resourceDeleted(QString)"]
interface CustomResourceManager extends QtIce::SignalEmitter
{
    Diamesh::StringList getResourceKeys();
    ByteArray getResource(string key);
    bool uploadResource(string key, ByteArray data);
    bool deleteResource(string key);
};

};

#endif // CUSTOM_RESOURCE_MANAGER_ICE
