// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef DOMAIN_ICE
#define DOMAIN_ICE

#include <common/entity.ice>

module Hns
{

["qtice:qiceobj:include:entityI.h",
"qtice:qiceobj:baseClass:Hns::EntityI",
"signal:void memoryDumpAdded(::Hns::MemoryDumpInfo)",
"signal:void memoryDumpDeleted(QString)"
]
interface Domain extends Entity 
{
    MemoryDumpInfoList getMemoryDumpInfoList();
    int createMemoryDumpJob(string name);
    void deleteMemoryDump(string fileName);
    void setMemoryDumpInfoList(Hns::MemoryDumpInfoList memoryDumpInfoList);
    Diamesh::FileTransfer *downloadMemoryDump(string fileName);
};

};

#endif // DOMAIN_ICE
