// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef DOMAIN_ENTRY_PROPERTIES_ICE
#define DOMAIN_ENTRY_PROPERTIES_ICE

#include <common/entityentryproperties.ice>
#include <diamesh/types.ice>

module Hns
{

const string USB_CONTROLLER_USB1 = "USB 1";
const string USB_CONTROLLER_USB2 = "USB 2";
const string USB_CONTROLLER_USB3 = "USB 3";

class DomainEntryProperties extends EntityEntryProperties
{
  int nbCpuMax;
  int memoryMax = 33554432; // TODO: add a setting for this
  int memoryMultiple = 4096; // Memory in kB must be a multiple of this value
  int nbNetworkCards;
  Diamesh::StringList networkCardsTypesList;
  Diamesh::StringList networkCardsModelsList;
  Diamesh::StringList archList;
  bool hasKeymap;
  Diamesh::StringList keymapList;
  bool hasStorageSettings;
  Diamesh::StringList storageBusTypesList;
  Diamesh::StringStringMap storageTargetMap;
  int nbDisksMax;
  Diamesh::StringList usbControllerTypesList;
  Diamesh::StringList videoModelTypesList;
};

};

#endif // DOMAIN_ENTRY_PROPERTIES_ICE

