// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef DYNAMIPS_ROUTER_ENTRY_ICE
#define DYNAMIPS_ROUTER_ENTRY_ICE

#include <common/entityentry.ice>

module Hns
{

struct DynamipsRouterModule
{
    string name;
    int interfaces;
    bool isMB = false;
};

dictionary<string, DynamipsRouterModule> ModuleMap;

struct DynamipsRouterChassis
{
    string name;
    int numSlots;
    ModuleMap availableModules;
};


dictionary<string, DynamipsRouterChassis> ChassisMap;
dictionary<int, DynamipsRouterModule> ModulePositionMap;

struct DataDynamipsRouter
{
    string name;
    bool needSetChassis;
    ChassisMap availableChassis;
    ModuleMap availableModules;
    int nvram;
};


class DynamipsRouterEntry extends EntityEntry
{
    string router;
    bool needSetChassis;
    string chassis;
    string macAddress;
    string idlePc;
    string imageDisk;
    ModulePositionMap modulesMap;
    Diamesh::StringStringMap mapOptions;
    int ram;
    int nvram;
    string configuration;
    bool applyOnBoot = false;
    bool autoExtract = true;
};

};

#endif // DYNAMIPS_ROUTER_ENTRY_ICE
