// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ENTITY_CATALOG_ICE
#define ENTITY_CATALOG_ICE

#include <QtIce/qtice.ice>
#include <common/catalog.ice>
#include <common/entityentry.ice>
#include <common/folder.ice>
#include <common/catalogimporter.ice>
#include <diamesh/types.ice>
[["cpp:include:list"]]

module Hns
{

dictionary<long, int> LongIntMap;

["signal:void folderChanged(Ice::Long)",
"signal:void folderRemoved(Ice::Long)",
"signal:void folderAdded(Ice::Long)",
"signal:void cloneJobStarted(Ice::Long, Ice::Int)",
"signal:void cloneJobSucceeded(Ice::Long, Ice::Int)",
"signal:void folderACLsChanged(Ice::Long, Diamesh::ACLList)",
"qtice:qiceobj:include:catalog/catalogI.h",
"qtice:qiceobj:baseClass:Hns::CatalogI",
"qtice:qiceobj:baseCtor:(const Ice::CommunicatorPtr &, Ice::ObjectAdapterPtr, const QString&)"]
interface EntityCatalog extends Catalog
{
    EntityEntry getEntityEntry(long entryId);
    int cloneEntityEntry(long entryId, int flags) throws HnsError;
    long buildModelFromEntityEntry(long entryId);
    bool discardSaveState(long entryId);

    LongIntMap getCloneJobs();    

    Diamesh::LongList getFolders(long parentId);
    Folder getFolder(long folderId);
    long addFolder(Folder f);
    bool deleteFolder(long folderId);
    bool updateFolder(Folder f);

};

};

#endif // ENTITY_CATALOG_ICE
