// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ENTITY_ENTRY_ICE
#define ENTITY_ENTRY_ICE

#include <QtIce/qtice.ice>
#include <diamesh/types.ice>
#include <common/entry.ice>

module Hns
{

enum EntityStatus
{
    ENTITY_STATUS_OK,
    ENTITY_STATUS_UUID_CONFLICT,
    ENTITY_STATUS_NOT_IN_FILE_STORAGE,
    ENTITY_STATUS_PROVISIONING
};

class EntityEntry extends Entry
{
    bool saved = false;
    bool isTemplate = false;
    bool isModel = false;
    bool hasResources = false;
    Diamesh::StringList restrictionList;
    string customGraphic;
};

};

#endif // ENTITY_ENTRY_ICE

