// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ENTITY_INFO_ICE
#define ENTITY_INFO_ICE

#include <common/entity.ice>

module Hns
{
    
    
struct EntityInfoData {
	string shortName;
	string longName;
    string type;
    string subtype;
};

["signal:void statusChanged(Ice::Int, Ice::Long)",
"signal:void entryChanged(::Hns::EntityInfoData)"]
interface EntityInfo extends QtIce::SignalEmitter
{
    idempotent Status getStatus();
    long entryId();
    idempotent EntityInfoData infoData();
};

};

#endif // ENTITY_INFO_ICE
