// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef IMPORTABLE_ICE
#define IMPORTABLE_ICE

#include <QtIce/qtice.ice>
#include <diamesh/accessrights.ice>
#include <common/entityentry.ice>
#include <common/archivedescriptor.ice>

module Hns
{

class Importable
{
    string path;
    long size;
};

class ImportableEntry extends Importable
{
    EntityEntry entry;
};

class ImportableArchive extends Importable
{
    ArchiveDescriptor archive;
};

module ImportOptionsFlags
{
    const int GENERATE_MAC_ADDRESSES = 0x1;
};

struct ImportOptions
{
    string newName;
    Diamesh::ACLList acls;
    int flags;
};

["cpp:type:std::list<Hns::ImportOptions>"]
sequence<ImportOptions> ImportOptionsList;

};

#endif // IMPORTABLE_ICE

