// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef JOB_ICE
#define JOB_ICE

#include <QtIce/qtice.ice>

module Hns {

["signal:void progressChanged(Ice::Int, Ice::Double)",
"signal:void finished(Ice::Int)",
"signal:void cancelled(Ice::Int)"]
interface Job extends QtIce::SignalEmitter
{
    void execute();
    double getProgress();
    bool cancel();
    bool isRunning();
    void destroy(); //see http://doc.zeroc.com/display/Ice34/Object+Destruction
};

};

#endif // JOB_ICE
