/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_JOB_H
#define HNS_JOB_H

// Generated hynesim headers
#include "common/qiceobj_job.h"

class QThread;

namespace Hns {

class JobI : public _Hns_Job
{
    Q_OBJECT

public:
    JobI();
    virtual ~JobI();

    virtual void execute(const ::Ice::Current &current = ::Ice::Current());
    virtual double getProgress(const ::Ice::Current &current = ::Ice::Current());
    virtual bool cancel(const ::Ice::Current &current = ::Ice::Current());
    virtual bool isRunning(const ::Ice::Current &current = ::Ice::Current());
    virtual void destroy(const Ice::Current &current = Ice::Current());

    void setId(int id);
    int id();
    void setIdentity(Ice::Identity identity);

signals:
    void terminateExecutionThreadRequested();

protected slots:
    void _moveToExecutionThread();
    virtual void _run();
    void _updateProgress(double);

protected:
    void _setAdapter(Ice::ObjectAdapterPtr adapter);
    QThread *executionThread();

private slots:
    void _terminateExecutionThread();

private:
    bool _canBeExecuted();

    int _id;
    double _progress;
    Ice::ObjectAdapterPtr _adapter;
    QThread *_executionThread;
    bool _cancelled;
    bool _running;
    Ice::Identity _identity;
    QReadWriteLock _progressLock;
    QReadWriteLock _stateLock;

};

} // namespace Hns

#endif // HNS_JOB_H
