// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************


#ifndef LAYOUT_ICE
#define LAYOUT_ICE

#include <QtIce/qtice.ice>
#include <diamesh/types.ice>

module Hns
{

enum LabelPolicy
{
    LabelPolicyDefault,
    LabelPolicyShow,
    LabelPolicyHide
};

class Layout
{
    int id = 0;
    LabelPolicy labelPolicyState = LabelPolicyDefault;
    string colorCode = "black"; //Can also be an HexCode, see QColor::setNamedColor documentation
};

class WireLayout extends Layout
{
    int x1 = 0;//To be renamed to fromX
    int y1 = 0;//To be renamed to fromY
    int x2 = 0;//To be renamed to toX
    int y2 = 0;//To be renamed to toY
    int numberAngles = 0;
};

class EntityLayout extends Layout
{
    int x = 0;
    int y = 0;
};

dictionary<long, EntityLayout > EntityLayoutMap; // entity id, layout
dictionary<long, WireLayout > WireLayoutMap; // wire id, layout

struct TopologyLayoutOptions
{
    int width = 1000;
    int height = 1000;
    string colorCode;
};

["cpp:comparable"]
struct TopologyLayout
{
    TopologyLayoutOptions layoutOptions;
    EntityLayoutMap entityLayouts;
    WireLayoutMap wireLayouts;
};
};

#endif //LAYOUT_ICE
