// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef _HNS_MASTER_ICE
#define _HNS_MASTER_ICE

#include <common/node.ice>
#include <diamesh/master.ice>
#include <common/entitycatalog.ice>
#include <common/topologycatalog.ice>
#include <common/tagmanager.ice>
#include <common/entityfactory.ice>
#include <common/topologymanager.ice>
#include <common/entrypropertiesmanager.ice>
#include <common/jobmanager.ice>
#include <common/macaddressmanager.ice>
#include <diamesh/info.ice>
#include <common/dynamipsrouterdb.ice>
#include <common/catalogimporter.ice>
#include <common/customresourcemanager.ice>
#include <common/nodeinfo.ice>

module Hns {

dictionary<string, NodeInfo*> NodeInfoMap;

interface Tracer;
["qtice:qiceobj:include:diamesh/masterI.h",
"qtice:qiceobj:baseClass:Diamesh::MasterI",
"signal:void refreshClassName(QString)"]
  interface Master extends Diamesh::Master
  {
    EntityCatalog* getEntityCatalog();
    TopologyCatalog* getTopologyCatalog();
    TagManager* getTagManager();
    EntityFactory* getEntityFactory();
    TopologyManager* getTopologyManager();
    EntryPropertiesManager* getEntryPropertiesManager();
    idempotent JobManager *getJobManager();
    idempotent MacAddressManager *getMacAddressManager();
    idempotent DynamipsRouterDB *getDynamipsRouterDB();
    idempotent Tracer *getTracer();
    idempotent bool getAdvancedMode();
    NodeInfoMap getEntryNodeInfoMap(EntityEntry e);
    idempotent Diamesh::VersionInfo getVersionInfo();
    idempotent CatalogImporter* getCatalogImporter();
    idempotent CustomResourceManager* getCustomResourceManager();
  };
};

#endif // _HNS_MASTER_ICE
