// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef HNS_MONITORDATA_ICE
#define HNS_MONITORDATA_ICE

module Hns {

struct CPUMonitoringData {
    double hostCPU = -1;
    double guestCPU = -1;
};

struct MemoryMonitoringData {
    long totalSize = -1;
    long used = -1;
    long available = -1;
};

struct NetworkMonitoringData {
    long rRate = 0;
    long tRate = 0;
    long received = 0;
    long transmitted = 0;
};

dictionary<string, NetworkMonitoringData> NetworkMonitoringDataMap;

struct IOMonitoringData {
    long rRate = 0;
    long wRate = 0;
    long rBytes = 0;
    long wBytes = 0;
};

dictionary<string, IOMonitoringData> IOMonitoringDataMap;

class MonitoringData
{
};

class EntityMonitoringData extends MonitoringData
{
	long entityId;
};

class DomainMonitoringData extends EntityMonitoringData
{
    CPUMonitoringData cpuData;
    MemoryMonitoringData memoryData;
    NetworkMonitoringDataMap networkDataMap;
    IOMonitoringDataMap ioDataMap;
};

dictionary<long, EntityMonitoringData> EntityMonitorDataMap;

};

#endif // HNS_MONITORDATA_ICE
