// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef _HNS_NODE_ICE
#define _HNS_NODE_ICE

#include <diamesh/node.ice>
#include <diamesh/info.ice>
#include <diamesh/types.ice>
#include <common/noderesourceinfo.ice>
#include <common/nodeentityfactory.ice>
#include <common/platforminfo.ice>
#include <common/nodelocalmonitor.ice>

module Hns
{

["qtice:qiceobj:include:diamesh/nodeI.h",
"qtice:qiceobj:baseClass:Diamesh::NodeI",
"signal:void refreshClassName(QString)",
"signal:void resourcesChanged(HnsNode::ResourceInfo)",
"signal:void addEntity(long)",
"signal:void removeEntity(long)",
"signal:void entityAdded(long, QString)",
"signal:void entityRemoved(long, QString)"]
interface Node extends Diamesh::Node
{
    HnsNode::EntityFactory* getEntityFactory();
    idempotent Diamesh::VersionInfo getVersionInfo();
    idempotent HnsNode::ResourceInfo getResourceInfo();
    PlatformInfoMap getPlatforms();
    HnsNode::NodeMonitor* getNodeMonitor();
};

};

#endif // _HNS_NODE_ICE
