// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************


#ifndef NODE_ENTITY_ICE
#define NODE_ENTITY_ICE

#include <QtIce/qtice.ice>
#include <diamesh/types.ice>
#include <common/entity.ice>
#include <common/nodecapturejob.ice>
#include <common/snapshot.ice>
#include <common/monitordata.ice>
module Hns
{

class EntityEntry;

};

module HnsNode
{

interface EntityPlug;

["signal:void statusChanged(Ice::Int , Ice::Long)",
"signal:void capturableInterfacesListChanged(::Diamesh::IntList)",
"signal:void monitoringDataUpdated(::Hns::EntityMonitoringDataPtr)"]
interface Entity extends QtIce::SignalEmitter
{
    Hns::EntityEntry getEntry();
    bool updateEntry(Hns::EntityEntry e);
    bool define();
    bool start();
    bool stop();
    bool save();
    bool restore();
    bool suspend();
    bool resume();
    bool undefine();
    bool createSnapshot(string xmlDesc);
    bool revertSnapshot(string snapshotName);
    bool deleteSnapshot(string snapshotName);
    Hns::Snapshot getSnapshot(string snapshotName);
    string getCurrentSnapshotName();
    EntityPlug *getPlug(int port);
    Diamesh::IntList getPlugs();
    string getHost();
    idempotent Hns::Status getStatus();
    CaptureJob *createCaptureJob(string captureJobPath);
    ::Diamesh::IntList getAvailablePlugsForCapture();
    void setAvailablePlugsForCapture(::Diamesh::IntList availableInterfaces);
    void removeInterfaceForCapture(int interfaceToRemove);
    void addInterfaceForCapture(int interfaceToAdd);
    idempotent Hns::RemoteDisplayInfo getRemoteDisplayInfo();
    void setId(long id);
    long getId();
};

};

#endif // NODE_ENTITY_ICE
