// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef NODE_ENTITY_FACTORY_ICE
#define NODE_ENTITY_FACTORY_ICE

#include <QtIce/qtice.ice>
#include <common/types.ice>
module Hns {

class EntityEntry;

};

module HnsNode
{
interface Entity;

interface EntityFactory extends QtIce::SignalEmitter
{
    Entity *createEntity(Hns::EntityEntry e, long entityId);
    Entity *createEntityFromId(long entryId, long entityId);
    bool destroyEntity(Entity *e);
    bool canBuild(Hns::EntityEntry e);
    bool canBuildAll(Hns::EntityEntry e, Hns::EntityEntryList alreadyDefinedEntities);
};

};

#endif // NODE_ENTITY_FACTORY_ICE
