// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef HNS_NODEINFO_ICE
#define HNS_NODEINFO_ICE

#include <diamesh/nodeinfo.ice>
#include <diamesh/types.ice>
#include <diamesh/info.ice>
#include <common/noderesourceinfo.ice>
#include <common/platforminfo.ice>
#include <common/types.ice>
#include <common/nodemonitor.ice>
module Hns {


class EntityEntry;

["qtice:qiceobj:include:diamesh/nodeinfoI.h",
"qtice:qiceobj:baseClass:Diamesh::NodeInfoI",
"qtice:qiceobj:baseCtor:(const QString &, const Diamesh::NodePrx &)",
"signal:void resourcesChanged(HnsNode::ResourceInfo)",
"signal:void addEntity(long)",
"signal:void removeEntity(long)"]
interface NodeInfo extends Diamesh::NodeInfo
{
    bool canBuild(EntityEntry entry);
    bool canBuildAll(EntityEntry entry, EntityEntryList alreadyComputedEntries);
    idempotent Diamesh::VersionInfo getVersionInfo();
    idempotent HnsNode::ResourceInfo getResourceInfo();
    PlatformInfoMap getPlatforms();
    Diamesh::LongList getEntityDefineIds();
    NodeMonitor* getNodeMonitor();
};

};

#endif // HNS_NODEINFO_ICE
