// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef SWITCH_ENTRY_ICE
#define SWITCH_ENTRY_ICE

#include <common/entityentry.ice>

module Hns
{

enum PortTag { Untagged, Tagged };

dictionary<int, PortTag> PortTagMap;

["cpp:comparable"]
struct Vlan
{
    int tag;
    PortTagMap portsMap;    
    string name;
    string description;
};

dictionary<int, Vlan> VlanMap;

class SwitchEntry extends EntityEntry
{
    string type;
    int ports;
    bool isHub;
    VlanMap vlans;
    bool stpEnabled;
    int portMirroring;
};

};

#endif // SWITCH_ENTRY_ICE
