// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef TOPOLOGY_CATALOG_ICE
#define TOPOLOGY_CATALOG_ICE

#include <QtIce/qtice.ice>
#include <common/catalog.ice>
#include <common/topologyentry.ice>
#include <common/types.ice>
#include <diamesh/types.ice>

module Hns
{

["signal:void screenshotUpdated(Ice::Long)",
"qtice:qiceobj:include:catalog/catalogI.h",
"qtice:qiceobj:baseClass:Hns::CatalogI",
"qtice:qiceobj:baseCtor:(const Ice::CommunicatorPtr &, Ice::ObjectAdapterPtr, const QString&)"]
interface TopologyCatalog extends Catalog
{
    TopologyEntry getTopologyEntry(long entryId);
    ByteArray getScreenshot(long entryId);
    bool setScreenshot(long entryId, ByteArray data);
    bool fixTopologyEntry(TopologyEntry e);
    int cloneTopology(long topologyId, int flags, string newName) throws HnsError;
};

};

#endif // TOPOLOGY_CATALOG_ICE
