// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef TOPOLOGY_ENTRY_ICE
#define TOPOLOGY_ENTRY_ICE

#include <QtIce/qtice.ice>
#include <diamesh/types.ice>
#include <common/entry.ice>
#include <common/entityentry.ice>
#include <common/wireentry.ice>
#include <common/types.ice>
#include <common/topologylink.ice>

[["cpp:include:map"]]

module Hns
{

enum TopologyStatus
{
    TOPOLOGY_STATUS_OK,
    TOPOLOGY_CONTAINS_ENTITY_WITH_UUID_CONFLICT,
    TOPOLOGY_UUID_CONFLICT,
    TOPOLOGY_LOADING_ERROR,
    TOPOLOGY_BUSY_EXPORTING
};

dictionary<int, EntityEntry> EntityEntryMap;
dictionary<int, WireEntry> WireEntryMap;
dictionary<int, PcapInfoList> PcapMap;
dictionary<int, MemoryDumpInfoList> MemoryDumpMap;

class TopologyEntry extends Entry
{
    EntityEntryMap entitiesMap;
    WireEntryMap wiresMap;
    PcapMap pcapInfoMap;
    MemoryDumpMap memoryDumpInfoMap;
    TopologyLinkList topologyLinks;
    bool isModel = false;
    bool isPersistent = false;
};

};

#endif // TOPOLOGY_ENTRY_ICE

