// ****************************************************************************
//
// Copyright (C) 2003-2012 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef HYNESIM_TYPES_ICE
#define HYNESIM_TYPES_ICE
[["cpp:include:list"]]
#include<common/entityentry.ice>
module Hns
{
    dictionary<string, bool> MacAddressMap;

    struct PcapInfo
    {
        string path;
        int interfaces;
        int timeLimit; //msec
        int packetsLimit;
        int packetsNumber;
        long size;
        long startDateTime; //timestamp
        long endDateTime; //timestamp
        string filters;
    };

    ["cpp:type:std::list<Hns::PcapInfo>"]
    sequence<PcapInfo> PcapInfoList;

    struct MemoryDumpInfo
    {
        string fileName;
        string name;
        long dateTime;
        long size;
    };

    ["cpp:type:std::list<Hns::MemoryDumpInfo>"]
    sequence<MemoryDumpInfo> MemoryDumpInfoList;

  sequence<byte> ByteArray;
  
  exception HnsError {
    string message = "generic hns error";
  };
  exception RightError extends HnsError {
  };

  ["cpp:type:std::list<Hns::EntityEntryPtr>"]
  sequence<EntityEntry> EntityEntryList;

  dictionary<int, int> IntIntMap;
};

#endif // HYNESIM_TYPES_ICE
