#ifndef HYNESIM_VERSION_H
#define HYNESIM_VERSION_H

namespace Diamesh {

struct VersionInfo;

} // namespace Diamesh

namespace Hns {

#define STRINGIFY_INTERNAL(x) #x
#define STRINGIFY(x) STRINGIFY_INTERNAL(x)

#cmakedefine HYNESIM_VERSION_MAJOR ${HYNESIM_VERSION_MAJOR}
#ifndef HYNESIM_VERSION_MAJOR
#  define HYNESIM_VERSION_MAJOR 0
#endif

#cmakedefine HYNESIM_VERSION_MINOR ${HYNESIM_VERSION_MINOR}
#ifndef HYNESIM_VERSION_MINOR
#  define HYNESIM_VERSION_MINOR 0
#endif

#cmakedefine HYNESIM_VERSION_RELEASE ${HYNESIM_VERSION_RELEASE}
#ifndef HYNESIM_VERSION_RELEASE
#  define HYNESIM_VERSION_RELEASE 0
#endif

#define HYNESIM_VERSION STRINGIFY(HYNESIM_VERSION_MAJOR) \
    "." STRINGIFY(HYNESIM_VERSION_MINOR) \
    "." STRINGIFY(HYNESIM_VERSION_RELEASE)

const char * const HYNESIM_VERSION_STR = HYNESIM_VERSION;

#cmakedefine HYNESIM_VERSION_DESCRIPTION ${HYNESIM_VERSION_DESCRIPTION}
#ifdef HYNESIM_VERSION_DESCRIPTION
const char * const HYNESIM_VERSION_DESCRIPTION_STR = STRINGIFY(HYNESIM_VERSION_DESCRIPTION);
#else
const char * const HYNESIM_VERSION_DESCRIPTION_STR = "";
#endif

#cmakedefine HYNESIM_REVISION ${HYNESIM_REVISION}
#ifdef HYNESIM_REVISION
const char * const HYNESIM_REVISION_STR = STRINGIFY(HYNESIM_REVISION);
#else
const char * const HYNESIM_REVISION_STR = "";
#endif

#undef HYNESIM_VERSION
#undef STRINGIFY
#undef STRINGIFY_INTERNAL

const char * buildDate();
const char * buildTime();
const Diamesh::VersionInfo &versionInfo();

} // namespace Hns

#endif /* HYNESIM_VERSION_H */
