import sys
import syslog

class HnsLogger():

    use_syslog = False

    @staticmethod
    def loadLogger(syslog_ident, use_syslog = False):
        HnsLogger.use_syslog = use_syslog
        HnsLogger.syslog_ident = syslog_ident
        if HnsLogger.use_syslog:
            HnsLogger._open_syslog()

    @staticmethod
    def unloadLogger():
        if HnsLogger.use_syslog:
            HnsLogger._close_syslog()

    @staticmethod
    def _open_syslog():
        syslog.openlog(HnsLogger.syslog_ident, syslog.LOG_PID)

    @staticmethod
    def _close_syslog():
        syslog.closelog()

    @staticmethod
    def _log_syslog(message):
        msg = "[config] " + message
        syslog.syslog(msg)

    @staticmethod
    def _log_error(message):
        if HnsLogger.use_syslog:
            HnsLogger._log_syslog(message)
        else:
            print >> sys.stderr, message

    @staticmethod
    def _log_msg(message):
        if HnsLogger.use_syslog:
            HnsLogger._log_syslog(message)
        else:
            print message

    @staticmethod
    def log_error(message):
        msg = "ERROR: " + message
        HnsLogger._log_error(msg)

    @staticmethod
    def log_warning(message):
        msg = "WARNING: " + message
        HnsLogger._log_error(msg)

    @staticmethod
    def log_msg_stderr(message):
        HnsLogger._log_error(message)

    @staticmethod
    def log_msg(message):
        HnsLogger._log_msg(message)
