#!/bin/bash
#
# Copyright (C) 2011 diateam. All rights reserved.
#
# This file is part of hynesim.
#
# Hynesim is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Hynesim is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
##################################################################################################################################################
################################################################### PARAMETERS ###################################################################
##################################################################################################################################################

# Parameters count
if [ $# -lt 1 ]
then
    echo "Missing parameters : removeIface.sh <interface>"
    exit 1
fi

# Extraction
iface="$1"

##################################################################################################################################################
############################################################# INTERFACE MANIPULATION #############################################################
##################################################################################################################################################

# Interface name
ifaceConf=/tmp/hnsWifiAPConf/$iface.conf

# We remove the interface
iw dev $iface del ||
{
    echo "Failed to remove interface '$iface'"
    exit 1
}

# We remove the configuration file if it exists (not a call from a bugging addSsid.sh)
rm -f $ifaceConf

echo "Interface '$iface' successfully removed"
