#!/bin/bash
#
# Copyright (C) 2011 diateam. All rights reserved.
#
# This file is part of hynesim.
#
# Hynesim is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Hynesim is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
##################################################################################################################################################
################################################################### PARAMETERS ###################################################################
##################################################################################################################################################

# Parameters count
if [ $# -lt 1 ]
then
    echo "Missing parameters : stopIface.sh <interface>"
    exit 1
fi

# Extraction
iface="$1"

##################################################################################################################################################
############################################################# INTERFACE MANIPULATION #############################################################
##################################################################################################################################################

start-stop-daemon --stop -p /var/run/hostapd.$iface.pid --oknodo --retry 5 ||
{
    echo "Failed to stop interface '$iface'"
    exit 1
}

echo "Interface '$iface' successfully stopped"
