#
# Copyright (C) 2011 diateam. All rights reserved.
#
# This file is part of hynesim.
#
# Hynesim is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Hynesim is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:$PATH

LOG_FILE=/var/log/hynesim.log

function log
{
  name=$(basename $0)
  msg=$1
  date=$(date +"%x %X")
  logMsg="$date $name : $msg"
  echo $logMsg >> $LOG_FILE
  if [[ $logToConsole ]]
  then
  	echo $logMsg
  fi
}

function log_echo
{
  log $1
  echo $logMsg
}

function iptables_handle_chain
{
  hynesim_chain="HYNESIM_$3"
  result=`$1 -t $2 -L | grep $hynesim_chain`
  if [[ ! $result ]]
  then
    $1 -t $2 -N $hynesim_chain
    $1 -t $2 -A $3 -j $hynesim_chain
  fi
}

#$1: execName
#$2: table
#$3: -A or -D
#$4: original chain
#$5: rule
function iptables_handle_rule
{
  execName=$1
  table=$2
  hynesim_chain="HYNESIM_$4"
  rule=$5
  iptables_handle_chain $1 $2 $4
  $1 -w -t $2 $3 $hynesim_chain $rule
}
