import hashlib
import sqlite3
import uuid

from __main__ import SqlMigrationError
from __main__ import Migration

ELEMENTS_TABLE = "elements"
ELEMENTS_ID = "id"
ELEMENTS_TYPE= "type"
ELEMENTS_SHORTNAME = "shortName"
ELEMENTS_LONGNAME = "longName"
ELEMENTS_DESCRIPTION = "description"
ELEMENTS_OWNER_ID = "ownerId"
ELEMENTS_GROUP_ID = "groupId"
ELEMENTS_PERMS = "perms"
ELEMENTS_UUID = "uuid"
ELEMENTS_CREATION_DATE_TIME = "creationDateTime"
ELEMENTS_LAST_MODIFICATION = "lastModificationDateTime"
ELEMENTS_STATUS = "status"
ELEMENTS_PATH = "path"
ELEMENTS_PARENT_ID = "parentId"
ELEMENTS_HSETID = "hsetid"

ELEMENTS_TABLE_TEMP = "elements_temp"

class EntityEntryMigrationForAcls(Migration):

    def migrate_impl(self):
        db_path = self.db_name_path_dict['Hynesim/catalog/dbName']

        conn = sqlite3.connect(db_path)
        conn.row_factory = sqlite3.Row

        ###Workaround because SQLite does not support DROP COLUMN, see https://www.sqlite.org/faq.html#q11
        conn.execute("CREATE TEMPORARY TABLE %s (%s integer primary key autoincrement, %s integer, %s text, %s text, %s text, %s text, %s datetime, %s datetime, %s integer, %s text, %s integer)" % (ELEMENTS_TABLE_TEMP, ELEMENTS_ID, ELEMENTS_TYPE, ELEMENTS_SHORTNAME, ELEMENTS_LONGNAME, ELEMENTS_DESCRIPTION, ELEMENTS_UUID, ELEMENTS_CREATION_DATE_TIME, ELEMENTS_LAST_MODIFICATION, ELEMENTS_STATUS, ELEMENTS_PATH, ELEMENTS_PARENT_ID))
        conn.execute("INSERT INTO %s SELECT %s, %s, %s, %s, %s, %s, %s , %s, %s, %s, %s FROM %s" % (ELEMENTS_TABLE_TEMP, ELEMENTS_ID, ELEMENTS_TYPE, ELEMENTS_SHORTNAME, ELEMENTS_LONGNAME, ELEMENTS_DESCRIPTION, ELEMENTS_UUID, ELEMENTS_CREATION_DATE_TIME, ELEMENTS_LAST_MODIFICATION, ELEMENTS_STATUS, ELEMENTS_PATH, ELEMENTS_PARENT_ID, ELEMENTS_TABLE))
        conn.execute("DROP TABLE %s" % ELEMENTS_TABLE)

        conn.execute("CREATE TABLE %s (%s integer primary key autoincrement, %s integer, %s text, %s text, %s text, %s text, %s datetime, %s datetime, %s integer, %s text, %s integer)" % (ELEMENTS_TABLE, ELEMENTS_ID, ELEMENTS_TYPE, ELEMENTS_SHORTNAME, ELEMENTS_LONGNAME, ELEMENTS_DESCRIPTION, ELEMENTS_UUID, ELEMENTS_CREATION_DATE_TIME, ELEMENTS_LAST_MODIFICATION, ELEMENTS_STATUS, ELEMENTS_PATH, ELEMENTS_PARENT_ID))
        conn.execute("INSERT INTO %s SELECT %s, %s, %s, %s, %s, %s, %s , %s, %s, %s, %s FROM %s" % (ELEMENTS_TABLE, ELEMENTS_ID, ELEMENTS_TYPE, ELEMENTS_SHORTNAME, ELEMENTS_LONGNAME, ELEMENTS_DESCRIPTION, ELEMENTS_UUID, ELEMENTS_CREATION_DATE_TIME, ELEMENTS_LAST_MODIFICATION, ELEMENTS_STATUS, ELEMENTS_PATH, ELEMENTS_PARENT_ID, ELEMENTS_TABLE_TEMP))
        conn.execute("DROP TABLE %s" % ELEMENTS_TABLE_TEMP)

        conn.commit()
        
        conn.execute("ALTER TABLE %s ADD %s integer" % (ELEMENTS_TABLE, ELEMENTS_HSETID))
        for row in conn.execute("SELECT * FROM %s" % ELEMENTS_TABLE):
            hsetid = 1
            queryValues = (hsetid, )
            query = "UPDATE %s SET %s = ?" % (ELEMENTS_TABLE, ELEMENTS_HSETID)
            conn.execute(query, queryValues)

        conn.commit()
        conn.close()
            
        
