import binascii
import hashlib
import os
import sqlite3

from __main__ import Migration

AUTH_TABLE = "auth"
PWD_COLUMN = "password"
SALT_COLUMN = "salt"
USER_COLUMN = "userName"

class HashPasswords(Migration):

    def migrate_impl(self):
        db_path = self.db_name_path_dict['Diamesh/authDBName']

        conn = sqlite3.connect(db_path)
        conn.row_factory = sqlite3.Row

        conn.execute("ALTER TABLE auth ADD salt text")

        rows = conn.execute("SELECT * FROM %s" % AUTH_TABLE).fetchall()
        for row in rows:
            userName = row[USER_COLUMN]
            password = row[PWD_COLUMN]
            salt = binascii.b2a_hex(os.urandom(20))
            password = hashlib.sha1(salt + password).hexdigest()
            values = (password, salt, userName)
            conn.execute("UPDATE %s SET %s = ?, %s = ? WHERE %s = ?" % (AUTH_TABLE, PWD_COLUMN, SALT_COLUMN, USER_COLUMN), values)

        conn.commit()
        conn.close()
