import sqlite3

from __main__ import Migration


class RemoveJoinTable(Migration):

    def migrate_impl(self):
        db_path = self.db_name_path_dict['Hynesim/catalog/dbName']

        conn = sqlite3.connect(db_path)
        for row in conn.execute("SELECT entryId, folderId FROM join_entries_folders GROUP BY entryId HAVING COUNT(entryId) = 1"):
            entryId = row[0]
            folderId = row[1]
            query = "UPDATE elements SET parentId = ? WHERE id = ?"
            queryValues = (folderId, entryId)
            conn.execute(query, queryValues)
        conn.execute("DROP TABLE join_entries_folders")
        conn.commit()
        conn.close()
