/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNV_HELPCONTENTWIDGET_H
#define HNV_HELPCONTENTWIDGET_H

// Project headers
#include "sidebar.h"

class QHelpContentModel;

namespace Hnv {

class HelpModeWidget;

/*******************************************************************************
* HelpContentWidget
*******************************************************************************/
class HelpContentWidget : public SideBarTreeWidget
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit HelpContentWidget(QWidget *parent = 0);
    ~HelpContentWidget();

    static QString title();
    static QString sideBarId();

protected:
    virtual void _indexClicked(const QModelIndex &index);
    virtual void _indexDoubleClicked(const QModelIndex &index);
    virtual void _contextMenuRequested(const QModelIndex &index, const QPoint &position);

protected slots:
    void _viewActivatedSlot(QModelIndex index);

private:
    HelpModeWidget * _helpModeWidget;
    QHelpContentModel * _model;
};

} // namespace Hnv

#endif // HNV_HELPCONTENTWIDGET_H
