/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HELPMODEWIDGET_H
#define HELPMODEWIDGET_H

// Project headers
#include "hnvplugins.h"
#include "modebrowserwidget.h"

// Qt headers
#include <QUrl>

class QHelpEngine;

namespace Hnv {

class HelpBrowserWidget;

/*******************************************************************************
 * HelpModePlugin
 ******************************************************************************/
class HelpModePlugin : public ModePlugin
{
    Q_OBJECT
    Q_INTERFACES(Hnv::ModePlugin)
public:
    HelpModePlugin(QObject *parent = 0);
    QString name() const;
    QString description() const;
protected:
    void _initModeWidget(QWidget *parent);
};

/*******************************************************************************
* HelpModeWidget
*/
class HelpModeWidget : public ModeWidget
{
    Q_OBJECT
public:
    explicit HelpModeWidget(QWidget *parent = 0);
    ~HelpModeWidget();
    QHelpEngine * helpEngine();

    virtual bool hasSideBar();
    virtual bool hasRightSideBar();
public slots:
    void activateLink(QUrl link);

protected:
    void _initModeAction();

private:
    QHelpEngine * _helpEngine;
    HelpBrowserWidget * _browser;
};

} // namespace Hnv

#endif // HELPMODEWIDGET_H
