/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNV_ENTITYINFOLISTWIDGET_H
#define HNV_ENTITYINFOLISTWIDGET_H

// Project headers
#include "sidebar.h"

class QAction;

namespace Hnv {

class EntityInfoModel;

/*******************************************************************************
* SessionListWidget
*******************************************************************************/
class EntityInfoListWidget : public SideBarTreeWidget
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit EntityInfoListWidget(QWidget  * parent = 0);
    ~EntityInfoListWidget();

    static QString title();
    static QString sideBarId();

protected slots:
    void _action_ExpandAllSlot();
    void _action_CollapseAllSlot();

protected:
    virtual void _indexClicked(const QModelIndex &index);
    virtual void _indexDoubleClicked(const QModelIndex &index);
    virtual void _contextMenuRequested(const QModelIndex &index, const QPoint &position);
    EntityInfoModel * _entityInfoListModel;
    QAction * _actionExpandAll;
    QAction * _actionCollapseAll;
    QMenu * _contextMenu;
};

} // namespace Hnv
#endif // HNV_ENTITYINFOLISTWIDGET_H
