/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "generalinformationwidget.h"
#include "ui_generalinformationwidget.h"
#include "platformmonitormodel.h"

namespace Hnv {

/*******************************************************************************
* GeneralInformationWidget
*******************************************************************************/
GeneralInformationWidget::GeneralInformationWidget(QWidget *parent)
    : MonitorWidget(parent)
    , ui(new Ui::GeneralInformationWidget)
{
    ui->setupUi(this);
}

GeneralInformationWidget::~GeneralInformationWidget()
{
    delete ui;
}

void GeneralInformationWidget::setMonitorItem(MonitorItem *item)
{
    if (item) {
        _setLabelText(ui->nameLabel, item->getName());
        _setLabelText(ui->versionLabel, item->getVersion());
        _setLabelText(ui->capabilitiesLabel, item->getServiceCapabilities());
        _setLabelText(ui->serviceAddressLabel, item->getServiceHost());
    } else {
        _clearLabel(ui->nameLabel);
        _clearLabel(ui->versionLabel);
        _clearLabel(ui->capabilitiesLabel);
        _clearLabel(ui->serviceAddressLabel);
    }
}

} // namespace Hnv
