/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "hardwaremonitoringwidget.h"
#include "ui_hardwaremonitoringwidget.h"
#include "platformmonitormodel.h"

namespace Hnv {

/*******************************************************************************
* HardwareMonitoringWidget
*******************************************************************************/
HardwareMonitoringWidget::HardwareMonitoringWidget(QWidget *parent)
    : MonitorWidget(parent)
    , ui(new Ui::HardwareMonitoringWidget)
{
    ui->setupUi(this);
}

HardwareMonitoringWidget::~HardwareMonitoringWidget()
{
    delete ui;
}

void HardwareMonitoringWidget::setMonitorItem(MonitorItem *item)
{
    if (item) {
        _setLabelText(ui->uptimeLabel, item->getSystemUptime());
        _setLabelText(ui->cpuLabel, item->getSystemCpuLoad());
        _setLabelText(ui->memoryLabel, item->getSystemMemoryLoad());
        _setLabelText(ui->swapLabel, item->getSystemSwapLoad());
        _setLabelText(ui->disksLabel, item->getDisksStatus());
    } else {
        _clearLabel(ui->uptimeLabel);
        _clearLabel(ui->cpuLabel);
        _clearLabel(ui->memoryLabel);
        _clearLabel(ui->swapLabel);
        _clearLabel(ui->disksLabel);
    }
}

} // namespace Hnv
