/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "hynesimmonitoringwidget.h"
#include "ui_hynesimmonitoringwidget.h"
#include "platformmonitormodel.h"

namespace Hnv {

/*******************************************************************************
* HynesimMonitoringWidget
*******************************************************************************/
HynesimMonitoringWidget::HynesimMonitoringWidget(QWidget *parent)
    : MonitorWidget(parent)
    , ui(new Ui::HynesimMonitoringWidget)
{
    ui->setupUi(this);
}

HynesimMonitoringWidget::~HynesimMonitoringWidget()
{
    delete ui;
}

void HynesimMonitoringWidget::setMonitorItem(MonitorItem *item)
{
    if (item) {
        _setLabelText(ui->uptimeLabel, item->getServiceUptime());
        _setLabelText(ui->processorsLabel, item->getHnsCpuUsage());
        _setLabelText(ui->memoryLabel, item->getHnsMemoryUsage());
        _setLabelText(ui->entitiesLabel, item->getHnsDefinedEntities());
        _setLabelText(ui->netcardLabel, item->getHnsNetcards());
    } else {
        _clearLabel(ui->uptimeLabel);
        _clearLabel(ui->processorsLabel);
        _clearLabel(ui->memoryLabel);
        _clearLabel(ui->entitiesLabel);
        _clearLabel(ui->netcardLabel);
    }
}

} // namespace Hnv
