/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "hynesimsettingswidget.h"
#include "ui_hynesimsettingswidget.h"
#include "platformmonitormodel.h"

namespace Hnv {

/*******************************************************************************
* HynesimSettingsWidget
*******************************************************************************/
HynesimSettingsWidget::HynesimSettingsWidget(QWidget *parent)
    : MonitorWidget(parent)
    , ui(new Ui::HynesimSettingsWidget)
{
    ui->setupUi(this);
}

HynesimSettingsWidget::~HynesimSettingsWidget()
{
    delete ui;
}

void HynesimSettingsWidget::setMonitorItem(MonitorItem *item)
{
    if (item) {
        _setLabelText(ui->maxthreadLabel, item->getHnsMaxThread());
        _setLabelText(ui->maxcpuLabel, item->getHnsMaxProcessors());
        _setLabelText(ui->maxmemoryLabel, item->getHnsMaxMemory());
    } else {
        _clearLabel(ui->maxthreadLabel);
        _clearLabel(ui->maxcpuLabel);
        _clearLabel(ui->maxmemoryLabel);
    }
}

} // namespace Hnv
