/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PLATFORMMONITORMODEWIDGET_H
#define PLATFORMMONITORMODEWIDGET_H

// Project headers
#include "hnvplugins.h"
#include "modebrowserwidget.h"

namespace Hnv {

/*******************************************************************************
* PlatformMonitorModeWidget
*/
class PlatformMonitorModeWidget : public ModeWidget
{
    Q_OBJECT
public:
    explicit PlatformMonitorModeWidget(QWidget *parent = 0);
    virtual bool hasSideBar();
    virtual bool hasRightSideBar();

protected:
    void _initModeAction();
};

/*******************************************************************************
* PlatformMonitorModePlugin
*/
class PlatformMonitorModePlugin : public ModePlugin
{
    Q_OBJECT
    Q_INTERFACES(Hnv::ModePlugin)
public:
    PlatformMonitorModePlugin(QObject * parent = 0);
    QString name() const;
    QString description() const;

protected:
    virtual void _initModeWidget(QWidget * parent);
};

} // namespace Hnv
#endif // PLATFORMMONITORMODEWIDGET_H
