/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNV_SESSIONLISTWIDGET_H
#define HNV_SESSIONLISTWIDGET_H

// Project headers
#include "sidebar.h"

// Qt headers
#include <QProcess>

class QAction;

namespace Hnv {

/*******************************************************************************
* SessionListWidget
*******************************************************************************/
class SessionListWidget : public SideBarListWidget
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit SessionListWidget(QWidget  * parent = 0);
    ~SessionListWidget();

    static QString title();
    static QString sideBarId();

protected slots:
    void _action_RemoteDisplaySlot();
    void _remoteDisplayFinished(int exitCode, QProcess::ExitStatus exitStatus);
    void _remoteDisplayError(QProcess::ProcessError error);

protected:
    virtual void _indexClicked(const QModelIndex &index);
    virtual void _indexDoubleClicked(const QModelIndex &index);
    virtual void _contextMenuRequested(const QModelIndex &index, const QPoint &position);
    void _startRemoteDisplay(QString target, QString title);
    void _destroyRemoteProcess(QProcess * process);

    QAction * _actionRemoteDisplay;
    QHash<QString, QProcess *> _processHash;
};

} // namespace Hnv
#endif // HNV_SESSIONLISTWIDGET_H
