/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "systeminformationwidget.h"
#include "ui_systeminformationwidget.h"
#include "platformmonitormodel.h"

namespace Hnv {

/*******************************************************************************
* SystemInformationWidget
*******************************************************************************/
SystemInformationWidget::SystemInformationWidget(QWidget *parent)
    : MonitorWidget(parent)
    , ui(new Ui::SystemInformationWidget)
{
    ui->setupUi(this);
}

SystemInformationWidget::~SystemInformationWidget()
{
    delete ui;
}

void SystemInformationWidget::setMonitorItem(MonitorItem *item)
{
    if (item) {
        _setLabelText(ui->kernelLabel, item->getSystemKernel());
        _setLabelText(ui->processorLabel, item->getSystemProcessor());
        _setLabelText(ui->memoryLabel, item->getSystemMemory());
        _setLabelText(ui->swapLabel, item->getSystemSwap());
    } else {
        _clearLabel(ui->kernelLabel);
        _clearLabel(ui->processorLabel);
        _clearLabel(ui->memoryLabel);
        _clearLabel(ui->swapLabel);
    }

}
} // namespace Hnv
