/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "rdpworkerplugin.h"
#include "worker.h"
#include "rdpworker.h"

// Qt headers
#include <QtPlugin>

namespace RemoteAccess {

RdpWorkerPlugin::RdpWorkerPlugin(QObject *parent)
    : RemoteWorkerPlugin(parent)
{
}

Worker* RdpWorkerPlugin::worker()
{
    RdpWorker *worker = new RdpWorker();
    return worker;
}

QString RdpWorkerPlugin::name() const
{
    return tr("Rdp Worker");
}

QString RdpWorkerPlugin::description() const
{
    return tr("Rdp Worker Plugin");
}

Hns::RemoteDisplayType RdpWorkerPlugin::type()
{
    return Hns::RdpViewer;
}

} // namespace RemoteAccess

Q_EXPORT_PLUGIN2(remoteWorker_rdp, RemoteAccess::RdpWorkerPlugin)
