/******************************************************************************
**
** Copyright (C) 2003-2017 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SPICEUSBMANAGER_H
#define SPICEUSBMANAGER_H

#include <spice-client-glib-2.0/usb-device-manager.h>

#include "usbmanager.h"

#include <QObject>

namespace RemoteAccess {

class SpiceUsbManager : public UsbManager
{
public:
    SpiceUsbManager(QObject *parent = 0);
    void setSpiceUsbDeviceManager(SpiceUsbDeviceManager *manager);

    static void usbDeviceErrorCb(SpiceUsbDeviceManager *manager, SpiceUsbDevice *device, GError *err, void *data);
    static void usbDeviceAddedCb(SpiceUsbDeviceManager *manager, SpiceUsbDevice *usbDevice, void *data);
    static void usbDeviceRemovedCb(SpiceUsbDeviceManager *manager, SpiceUsbDevice *usbDevice, void *data);
    static void usbConnectAsyncCb(GObject *gobject, GAsyncResult *res, gpointer user_data);

    void resetUsbDevicesList();

    void connectUsbDevice(UsbDevice dev);
    void disconnectUsbDevice(UsbDevice dev);
    void disconnectAllUsbDevices();
    bool hasDeviceConnected();

private:
    UsbDevice _createUsbDevice(const QString &desc);

    SpiceUsbDeviceManager *_spiceManager;
};

} //RemoteAccess

#endif // SPICEUSBMANAGER_H
