/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "spiceworker.h" // Must be included before Qt because signals collides with GLIB symbols
#include "spiceworkerplugin.h"
#include "worker.h"

// Qt headers
#include <QtPlugin>

namespace RemoteAccess {

SpiceWorkerPlugin::SpiceWorkerPlugin(QObject *parent)
    : RemoteWorkerPlugin(parent)
{
}

Worker* SpiceWorkerPlugin::worker()
{
    SpiceWorker *worker = new SpiceWorker();
    return worker;
}

QString SpiceWorkerPlugin::name() const
{
    return tr("Spice Worker");
}

QString SpiceWorkerPlugin::description() const
{
    return tr("Spice Worker Plugin");
}

Hns::RemoteDisplayType SpiceWorkerPlugin::type()
{
    return Hns::SpiceViewer;
}

} // namespace RemoteAccess

Q_EXPORT_PLUGIN2(remoteWorker_spice, RemoteAccess::SpiceWorkerPlugin)
