/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TELNETWORKER_H
#define TELNETWORKER_H

// Project headers
#include "worker.h"

class QX11EmbedContainer;
class QProcess;

namespace RemoteAccess {

class Display;

class TelnetWorker : public Worker
{
    Q_OBJECT
public:
    TelnetWorker(QObject *parent = 0);
    ~TelnetWorker();
    virtual void openConnection();
    virtual void closeConnection();
    virtual Display* createDisplay();

private:
    QX11EmbedContainer *_container;
    QProcess *_process;
    QWidget *_widget;
};

} // namespace RemoteAccess
#endif // TELNETWORKER_H
