/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "telnetworkerplugin.h"
#include "worker.h"
#include "telnetworker.h"

// Qt headers
#include <QtPlugin>

namespace RemoteAccess {

TelnetWorkerPlugin::TelnetWorkerPlugin(QObject *parent)
    : RemoteWorkerPlugin(parent)
{
}

Worker* TelnetWorkerPlugin::worker()
{
    TelnetWorker *worker = new TelnetWorker();
    return worker;
}

QString TelnetWorkerPlugin::name() const
{
    return tr("Telnet Worker");
}

QString TelnetWorkerPlugin::description() const
{
    return tr("Telnet Worker Plugin");
}

Hns::RemoteDisplayType TelnetWorkerPlugin::type()
{
    return Hns::TelnetViewer;
}

} // namespace RemoteAccess

Q_EXPORT_PLUGIN2(remoteWorker_telnet, RemoteAccess::TelnetWorkerPlugin)
