/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "vncworkerplugin.h"
#include "worker.h"
#include "vncworker.h"

// Qt headers
#include <QtPlugin>

namespace RemoteAccess {

VncWorkerPlugin::VncWorkerPlugin(QObject *parent)
    : RemoteWorkerPlugin(parent)
{
}

Worker* VncWorkerPlugin::worker()
{
    VncWorker *worker = new VncWorker();
    return worker;
}

QString VncWorkerPlugin::name() const
{
    return tr("Vnc Worker");
}

QString VncWorkerPlugin::description() const
{
    return tr("Vnc Worker Plugin");
}

Hns::RemoteDisplayType VncWorkerPlugin::type()
{
    return Hns::VncViewer;
}

} // namespace RemoteAccess

Q_EXPORT_PLUGIN2(remoteWorker_vnc, RemoteAccess::VncWorkerPlugin)
