/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "hnvplugins.h"
#include "worker.h"
#include "modebrowserwidget.h"

// hynesim common headers
#include "common/constants.h"

// Qt headers
#include <QSettings>

namespace Hnv {
    
/*******************************************************************************
* Plugin
*******************************************************************************/
Plugin::Plugin(QObject* parent)
    : Hns::Plugin(parent)
{
}

void Plugin::setDisabledByDefault(const QString &settingsKey)
{
    QSettings settings;
    settings.beginGroup(Hns::Constants::SETTINGS_PLUGINS_GROUP);
    settings.beginGroup(settingsKey);
    setEnabled(settings.value(Hns::Constants::SETTINGS_PLUGINS_ENABLED).toBool());
}

/*******************************************************************************
* ModePlugin
*******************************************************************************/
ModePlugin::ModePlugin(QObject *parent)
    : Plugin(parent)
    , _modeWidgetSingleton(0)
{
}

ModeWidget * ModePlugin::modeWidget(QWidget * parent)
{
    if (_modeWidgetSingleton == 0)
        _initModeWidget(parent);
    return _modeWidgetSingleton;
}

} // namespace Hnv

/*******************************************************************************
* RemoteWorkerPlugin
*******************************************************************************/
namespace RemoteAccess {

RemoteWorkerPlugin::RemoteWorkerPlugin(QObject *parent)
    : Plugin(parent)
{
}

} // namespace RemoteAccess
