/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PLUGINSI_H
#define PLUGINSI_H

// hynesim common headers
#include "common/pluginmanager.h"

// Generated hynesim headers
#include "common/entity.h"

namespace Hnv {
class ModeWidget;
} // namespace Hnv

namespace RemoteAccess {
class Worker;
} // namespace RemoteAccess

namespace Hnv {

/*******************************************************************************
* Plugin
*******************************************************************************/
class Plugin : public Hns::Plugin
{
    Q_OBJECT
    Q_INTERFACES(Hns::Plugin)
public:
    Plugin(QObject * parent = 0);

protected:
    void setDisabledByDefault(const QString &settingsKey);
};

} // namespace Hnv
Q_DECLARE_INTERFACE(Hnv::Plugin, "org.hynesim.hnvPlugin")

namespace Hnv {
/*******************************************************************************
* ModePlugin
*******************************************************************************/
class ModePlugin : public Plugin
{
    Q_OBJECT
    Q_INTERFACES(Hnv::Plugin)
public:
    ModePlugin(QObject * parent = 0);
    ModeWidget * modeWidget(QWidget * parent);
protected:
    virtual void _initModeWidget(QWidget * parent) = 0;
    ModeWidget * _modeWidgetSingleton;
};

} // namespace Hnv

namespace RemoteAccess {

/*******************************************************************************
* RemoteWorkerPlugin
*******************************************************************************/
class RemoteWorkerPlugin : public Hnv::Plugin
{
    Q_OBJECT
    Q_INTERFACES(Hnv::Plugin)
public:
    RemoteWorkerPlugin(QObject * parent = 0);
    virtual Worker *worker() = 0;
    virtual Hns::RemoteDisplayType type() = 0;
};

} // namespace RemoteAccess

Q_DECLARE_INTERFACE(Hnv::ModePlugin, "org.hynesim.ModePlugin")
Q_DECLARE_INTERFACE(RemoteAccess::RemoteWorkerPlugin, "org.hynesim.RemoteWorkerPlugin")

#endif // PLUGINSI_H
