/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "hnvutility.h"

// Qt headers
#include <QObject>

namespace Hnv {

/*******************************************************************************
* Utility
*******************************************************************************/
QString Utility::makeSizeReadable(const qlonglong size)
{
    double finalSize = size;
    if (finalSize == -1)
        return QObject::tr("-");
    QList<QString> sizeUnit;
    sizeUnit.append(QObject::tr("B"));
    sizeUnit.append(QObject::tr("kB"));
    sizeUnit.append(QObject::tr("MB"));
    sizeUnit.append(QObject::tr("GB"));
    sizeUnit.append(QObject::tr("TB"));
    int unitIndex = 0;
    while (finalSize >= 1000 && unitIndex < sizeUnit.count()) {
        finalSize = finalSize / 1000;
        unitIndex++;
    }
    return QString("%1 %2").arg(QString::number(finalSize, 'f', 2)).arg(sizeUnit.at(unitIndex));
}

} // namespace Hnv
