/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
#ifndef DYNAMICFILTERSORTMODEL_H
#define DYNAMICFILTERSORTMODEL_H

// Qt headers
#include <QSortFilterProxyModel>
#include <QStringList>

namespace Hnv {

class DynamicFilterSortModel : public QSortFilterProxyModel
{
    Q_OBJECT
public:
    explicit DynamicFilterSortModel(QObject *parent = 0);
    void setFilter(int column, const QStringList &filters);

protected:
    bool filterAcceptsRow(int source_row, const QModelIndex &source_parent) const;

private:
    QHash<int, QStringList> _filters;
};

} // namespace Hnv

#endif // DYNAMICFILTERSORTMODEL_H
