/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef REMOTECLIENT_H
#define REMOTECLIENT_H

// Generated hynesim headers
#include "common/entity.h"

// Qt headers
#include <QObject>

class QImage;

namespace RemoteAccess {

class Worker;
class Display;
class UsbManager;

class RemoteClient : public QObject
{
    Q_OBJECT
public:
    explicit RemoteClient(Hns::RemoteDisplayInfo info, QObject *parent = 0);
    ~RemoteClient();
    void openConnection();
    void closeConnection();
    int id();
    void setId(int id);
    Display* display();
    Hns::RemoteDisplayInfo info();
    QImage getScreenShot();
    UsbManager *usbManager();
    bool canRedirectUsb();

signals:
    void connectionEnded(int id);
    void connectionError(int id, QString message);
    bool canRedirectUsbChanged();
public slots:
    void connectionEnd();
    void connectionErrorSlot(QString message);
private:
   Display *_display;
   Hns::RemoteDisplayInfo _info;
   Worker *_worker;
   int _id;
   bool _isRunning;
};

} // namespace RemoteAccess
#endif // CLIENT_H
