/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef REMOTEVIEWFACTORY_H
#define REMOTEVIEWFACTORY_H

// Qt headers
#include <QObject>
#include <QHash>

namespace RemoteAccess {

class Display;
class RemoteView;

class RemoteViewFactory : public QObject
{
    Q_OBJECT
public:
    explicit RemoteViewFactory(QObject *parent = 0);
    RemoteView* createRemoteView(Display *display);
    template <typename T1, typename T2> void registerMetaObject()
    {
        _factoryHash.insert(QString(T1::staticMetaObject.className()), T2::staticMetaObject);
    }

private:
    QHash<QString, QMetaObject> _factoryHash;
};

} // namespace RemoteAccess
#endif // REMOTEVIEWFACTORY_H
