/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WORKER_H
#define WORKER_H

// Generated hynesim headers
#include "common/entity.h"

// Qt headers
#include <QObject>

namespace RemoteAccess {
class Display;
class UsbManager;

class Worker : public QObject
{
    Q_OBJECT
public:
    explicit Worker(QObject *parent = 0);
    virtual void openConnection() = 0;
    virtual void closeConnection() = 0;
    virtual Display* createDisplay() = 0;
    void setInfo(Hns::RemoteDisplayInfo info);
    virtual UsbManager *usbManager();
    virtual bool canRedirectUsb();
signals:
    void connectionEnded();
    void connectionError(QString message);
    void canRedirectUsbChanged();
public slots:

protected:
    Hns::RemoteDisplayInfo _info;
};

} // namespace RemoteAccess
#endif // WORKER_H
