/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TREESORTFILTERPROXYMODEL_H
#define TREESORTFILTERPROXYMODEL_H

// Qt headers
#include <QSortFilterProxyModel>

namespace Hnv {

/*******************************************************************************
* TreeSortFilterProxyModel
*******************************************************************************/
class TreeSortFilterProxyModel : public QSortFilterProxyModel
{
    Q_OBJECT
public:
    TreeSortFilterProxyModel(QObject * parent = 0);
    void setFilterColumnsList(QList<int> columns);
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;

protected:
    bool filterAcceptsRow(int source_row, const QModelIndex &source_parent) const;

private:
    bool _isItemValid(QModelIndex rowIndex, bool recursive = true) const;
    bool _hasValidChild(QModelIndex parent) const;

    QList<int> _filterColumns;
};

} // namespace Hnv
#endif // TREESORTFILTERPROXYMODEL_H
