/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "uniqueproxymodel.h"

namespace Hnv {

/*******************************************************************************
* UniqueProxyModel
*******************************************************************************/
void UniqueProxyModel::setSourceModel(QAbstractItemModel *sourceModel)
{
    connect(sourceModel, SIGNAL(modelReset()), this, SLOT(_clearCache()));
    QSortFilterProxyModel::setSourceModel(sourceModel);
}

/*******************************************************************************
* UniqueProxyModel - Protected
*/
bool UniqueProxyModel::filterAcceptsRow(int source_row, const QModelIndex &source_parent) const
{
    QModelIndex index = sourceModel()->index(source_row, _column, source_parent);
    const QString &text = sourceModel()->data(index).toString();
    if (_cache.contains(text))
        return false;
    _cache << text;
    return true;
}

} // namespace Hnv
