/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef UNIQUEPROXYMODEL_H
#define UNIQUEPROXYMODEL_H

// Qt headers
#include <QSet>
#include <QSortFilterProxyModel>

namespace Hnv {

/*******************************************************************************
* UniqueProxyModel
*******************************************************************************/
class UniqueProxyModel : public QSortFilterProxyModel
{
    Q_OBJECT
public:
    explicit UniqueProxyModel(int column, QObject *parent = 0) :
            QSortFilterProxyModel(parent), _column(column) {}
    void setSourceModel(QAbstractItemModel *sourceModel);

protected:
    bool filterAcceptsRow(int source_row, const QModelIndex &source_parent) const;

private slots:
    void _clearCache() { _cache.clear(); }

private:
    const int _column;
    mutable QSet<QString> _cache;
};

} // namespace Hnv
#endif // UNIQUEPROXYMODEL_H
