/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNV_SESSIONSMODEL_H
#define HNV_SESSIONSMODEL_H

// Qt headers
#include <QAbstractTableModel>
#include <QStringList>

namespace HnsClient {
class UserManager;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
* SessionsModel
*******************************************************************************/
class SessionsModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    explicit SessionsModel(QObject *parent = 0);
    void initModel(HnsClient::UserManager *manager);
    void resetModel();
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;
    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;

private slots:        
    void _sessionAdded(QString sessionID);
    void _sessionRemoved(QString sessionID);

private:
    void _refreshData();
    HnsClient::UserManager *_manager;
    QStringList _sessionIDList;
};

} // namespace Hnv
#endif // HNV_SESSIONSMODEL_H
