import QtQuick 1.0

Rectangle {
    id: main
    width: anchor.width
    height: anchor.height
    color: anchor.color

    signal qmlSignalClicked(int id)

    //view
    GridView {
        anchors.fill: parent
        width: parent.width; height: parent.height
        cellWidth: 300; cellHeight: 300

        model: screenshotModel
        delegate: Item {
            id: delegate

            Image {
                id: image
                fillMode: Image.PreserveAspectFit
                source: roleImage
                width: 200 ; height : 200
            }
            Text {
                id: text
                text: roleInformation
                anchors.horizontalCenter: image.horizontalCenter
                anchors.top: image.bottom
            }
            MouseArea {
                anchors.fill: image
                hoverEnabled: true
                onEntered: {
                    parent.state = "move"
                }
                onExited: {
                    parent.state = "unmove"
                }
                onClicked: {
                    main.qmlSignalClicked(roleId)
                }
            }
            states: [
                State {
                    name: "move"
                    PropertyChanges { target: image; width: 640; height: 480}
                    PropertyChanges { target: delegate ; z : 10 }
                },
                State {
                    name: "unmove"
                    PropertyChanges { target: image; width: 200; height: 200}
                    PropertyChanges { target : delegate ; z: 1 }
                }
            ]
            transitions: [
                Transition {
                    NumberAnimation { properties: "width,height,z"; duration : 500}
                }
            ]
        }

    }
}
