/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef RESSOURCES_H
#define RESSOURCES_H

// Generated hynesim headers
#include "common/entity.h"

// Qt headers
#include <QString>
#include <QHash>
#include <QPixmap>

class QGraphicsSvgItem;
class QGraphicsItem;
class QSvgRenderer;

namespace HnsClient {
class CatalogItem;
class GenericEntity;
} // namespace HnsClient

namespace Hnv {

namespace Constants {
    const char * const SETTINGS_GROUP_GLOBAL        = "Global";
    const char * const SETTINGS_KEY_THEME           = "Theme";
    const char * const SETTINGS_DEFAULT_THEME       = "hynesim";

    const char * const SETTINGS_LANGUAGE_DEFAULT    = "";


    const char * const ICON_WELCOME = "icons/welcomemode.png";

    enum modeBrowserState{
        ModeBrowserFull
        , ModeBrowserIcon
        , ModeBrowserMini};

//    **********************************CSS************************************

    const char * const ICON_BACKGROUND = "icons/welcome-background.png";

//    *************************************************************************

    const char * const ICON_LOGO = "icons/logoHynesim_98x200.png";

//    ********************************CSS**************************************

//    const char * const ICON_ARROW_DOWN = "icons/arrow-down.png";
//    const char * const ICON_ARROW_DOWN_MENU = "icons/arrow-down-menu.png";
//    const char * const ICON_ARROW_LEFT = "icons/arrow-left.png";
//    const char * const ICON_ARROW_RIGHT = "icons/arrow-right.png";
//    const char * const ICON_ARROW_UP = "icons/arrow-up.png";
//    const char * const ICON_SPIN_ARROW_DOWN = "icons/spin-arrow-down.png";
//    const char * const ICON_SPIN_ARROW_UP = "icons/spin-arrow-up.png";
//    const char * const ICON_COMBOBOX_ARROW = "icons/combobox-arrow.png";

//    **************************************************************************

    const char * const ICON_CLOSE_BUTTON = "icons/close_button.png";
    const char * const ICON_CONNECT = "icons/connect.png";
    const char * const ICON_DARK_CLOSE_BUTTON = "icons/darkclosebutton.png";
    const char * const ICON_DISCONNECT = "icons/disconnect.png";
    const char * const ICON_EDIT_SELECT = "icons/edit_select.png";
    const char * const ICON_HIDE_SIDEBAR = "icons/hide-sidebar.png";
    const char * const ICON_HIDE_SIDEBAR_RIGHT = "icons/hide-sidebar-right.png";
    const char * const ICON_MESSAGES = "icons/messages.png";
    const char * const ICON_QUICK_CONNECT = "icons/quick-connect.png";
    const char * const ICON_SPLIT_BUTTON = "icons/split-button.png";
    const char * const ICON_TOGGLE_LABEL = "icons/toggleLabel.png";
    const char * const ICON_WIRE = "icons/wire.png";
    const char * const ICON_WIRE_1_ANGLE = "icons/wire-1-angle.png";
    const char * const ICON_WIRE_2_ANGLE = "icons/wire-2-angle.png";

    const char * const CHANGE_TO_0_ANGLE = "icons/wire.png";
    const char * const CHANGE_TO_1_ANGLE = "icons/wire-1-angle.png";
    const char * const CHANGE_TO_2_ANGLES = "icons/wire-2-angle.png";

    const char * const ICON_WIRE_LR = "icons/wire_LR.png";
    const char * const ICON_WIRE_RL = "icons/wire_RL.png";

    const char * const ICON_CONNECTED_PEERS = "icons/wifiApConnected.png";

    const char * const ICON_DATABASE = "icons/server-database.png";
    const char * const ICON_CREATE_CATEGORY = "icons/create_category.png";
    const char * const ICON_CLONE_ENTITY = "icons/clone_entity.png";
    const char * const ICON_DETAILS = "icons/details.png";
    const char * const ICON_ENTRY = "icons/entry.png";
    const char * const ICON_FOLDER = "icons/folder.png";
    const char * const ICON_PERMISSION = "icons/permission.png";
    const char * const ICON_PERM_MISSING = "icons/perm-missing.png";
    const char * const ICON_PROPERTIES = "icons/properties.png";
    const char * const ICON_SYSTEM_SETTINGS = "icons/system-settings.png";
    const char * const ICON_WORKING = "icons/working-animation.png";

    const char * const ICON_MESH = "icons/mesh.png";
    const char * const ICON_MASTER = "icons/master.png";
    const char * const ICON_NODE = "icons/node.png";
    const char * const ICON_PLATFORM_MONITOR =  "icons/platform_monitor.png";

    const char * const ICON_COPY = "icons/copy.png";
    const char * const ICON_DELETE = "icons/delete.png";
    const char * const ICON_DELETE_DISABLED = "icons/delete_disabled.png";
    const char * const ICON_REMOVE = "icons/remove_to_folder.png";
    const char * const ICON_REMOVE_ALL = "icons/remove_to_all_folder.png";
    const char * const ICON_EXIT = "icons/exit.png";
    const char * const ICON_NEW = "icons/new.png";
    const char * const ICON_OPEN = "icons/open.png";
    const char * const ICON_PASTE = "icons/paste.png";
    const char * const ICON_SAVE = "icons/save.png";
    const char * const ICON_SAVE_AS = "icons/saveas.png";
    const char * const ICON_BUILD_TOPOLOGY = "icons/create_from_model.png";
    const char * const ICON_BUILD_MODEL = "icons/save_to_model.png";
    const char * const ICON_SELECTOR = "icons/edit-select.png";
    const char * const ICON_DISPLAY_GRID= "icons/view-grid.png";
    const char * const ICON_REFRESH = "icons/refresh.svg";
    const char * const ICON_RESIZE_SCENE = "icons/resize_view.png";
    const char * const ICON_PRINT_TOPOLOGY  ="icons/print.png";
    const char * const ICON_PRINT_SELECTION  ="icons/print.png";
    const char * const ICON_PRINT_VIEW  ="icons/print.png";
    const char * const ICON_SNAPSHOT_TOPOLOGY  ="icons/snapshot.png";
    const char * const ICON_SNAPSHOT_SELECTION  ="icons/snapshot.png";
    const char * const ICON_SNAPSHOT_VIEW  ="icons/snapshot.png";
    const char * const ICON_PAUSE = "icons/pause.png";
    const char * const ICON_START = "icons/start.png";
    const char * const ICON_STOP = "icons/stop.png";
    const char * const ICON_DEFINE = "icons/target.png";
    const char * const ICON_UNDEFINE = "icons/undefine.png";
    const char * const ICON_GENERATE_MAC_ADRESS = "icons/generateMacAdress.png";
    const char * const ICON_UNLOAD_TOPOLOGY = "icons/unloadTopology.png";
    const char * const ICON_FIX_TOPOLOGY = "icons/fixTopology.png";

    const char * const ICON_CLEAR = "icons/clear.png";
    const char * const ICON_SEARCH = "icons/search.png";

    const char * const ICON_HELP = "icons/help.png";
    const char * const ICON_HELP_HOME = "icons/go-home.png";
    const char * const ICON_HELP_NEXT = "icons/go-next.png";
    const char * const ICON_HELP_PREVIOUS = "icons/go-previous.png";

    const char * const ICON_CLEAR_MESSAGES = "icons/clear_messages.png";
    const char * const ICON_DEBUG = "icons/debug.png";
    const char * const ICON_ERROR = "icons/error.png";
    const char * const ICON_TRACE = "icons/trace.png";
    const char * const ICON_WARNING = "icons/warning.png";
    const char * const ICON_DIALOG_WARNING = "icons/dialog-warning.png";
    const char * const ICON_CHECK = "icons/valid_dialog.png";
    const char * const ICON_CHECK_INDICATOR = "icons/check.png";
    const char * const ICON_CANCEL = "icons/cancel.png";

    const char * const ICON_PERM_EXEC = "icons/perm-exec.png";
    const char * const ICON_PERM_READ = "icons/perm-read.png";
    const char * const ICON_PERM_WRITE = "icons/perm-write.png";
    const char * const ICON_EXPAND = "icons/expand.png";
    const char * const ICON_COLLAPSE = "icons/collapse.png";
    const char * const ICON_PREFERENCE_MAIN = "icons/preference_main.png";
    const char * const ICON_PREFERENCE_SETTINGS = "icons/preference_settings.png";
    const char * const ICON_PREFERENCE_DESKTOP = "icons/preferences-desktop.png";
    const char * const ICON_PREFERENCE_VIEWER = "icons/preference-viewer.png";
    const char * const ICON_REMOTE_DISPLAY = "icons/remote_display.png";
    const char * const ICON_USB_REDIRECTION = "icons/usb-redirection.png";
    const char * const ICON_SIMULATION = "icons/simulation.png";

    const char * const ICON_STATUS_ERROR = "icons/status-error.png";
    const char * const ICON_STATUS_OFFLINE = "icons/status-offline.png";
    const char * const ICON_STATUS_ONLINE = "icons/status-online.png";
    const char * const ICON_STATUS_WORKING = "icons/status-working.png";

    const char * const ICON_GROUP = "icons/group.png";
    const char * const ICON_USER = "icons/user.png";

    const char * const ICON_PREFIX_ADMIN = "icons/admin_";
    const char * const ICON_PREFIX_USER = "icons/user_";
    const char * const ICON_SUFFIX_CONNECTED = "connected.png";
    const char * const ICON_SUFFIX_DISABLED = "disabled.png";
    const char * const ICON_SUFFIX_ENABLED = "enabled.png";

    const char * const ICON_ADMIN_CONNECTED = "icons/admin_connected.png";
    const char * const ICON_ADMIN_DISABLED = "icons/admin_disabled.png";
    const char * const ICON_ADMIN_ENABLED = "icons/admin_enabled.png";
    const char * const ICON_USER_CONNECTED = "icons/user_connected.png";
    const char * const ICON_USER_DISABLED = "icons/user_disabled.png";
    const char * const ICON_USER_ENABLED = "icons/user_enabled.png";
    const char * const ICON_USER_ADD = "icons/user_add.png";
    const char * const ICON_USER_CLONE = "icons/user_clone.png";
    const char * const ICON_USER_EDIT = "icons/user_edit.png";
    const char * const ICON_GROUP_EDIT = "icons/group_edit.png";
    const char * const ICON_GROUP_ADD = "icons/group_add.png";
    const char * const ICON_FILTER = "icons/filtericon.png";
    const char * const ICON_PSW_GENERATOR = "icons/psw_generator.png";
    const char * const ICON_CREATE_NETCARD = "icons/create.png";
    const char * const ICON_COLORIZE = "icons/colorize.png";
    const char * const ICON_LANDSCAPE = "icons/landscape.png";
    const char * const ICON_PORTRAIT = "icons/portrait.png";

    const char * const ICON_SETTINGS = "icons/settings.png";
    const char * const ICON_SERVER = "icons/server.png";
    const char * const ICON_LOAD_BALANCING = "icons/loadbalancing.png";
    const char * const ICON_GENERIC_TYPE = "icons/type_generic.png";
    const char * const ICON_PREFIX_TYPE = "icons/type_";
    const char * const ICON_KVM = "kvm.png";
    const char * const ICON_OPENVZ = "openvz.png";
    const char * const ICON_VBOX = "vbox.png";
    const char * const ICON_VMWARE = "vmware.png";
    const char * const ICON_QEMU = "qemu.png";
    const char * const ICON_LXC = "lxc.png";

    const char * const ICON_TEMPLATE = "icons/template_overlay.png";
    const char * const ICON_MODEL = "icons/model_overlay.png";
    const char * const ICON_CAPTURE_JOB = "icons/capturejob.png";

    const char * const ICON_IMPORT = "icons/import.png";
    const char * const ICON_EXPORT = "icons/topology-export.png";
    const char * const ICON_SHOW_TOPOLOGY_DETAILS = "icons/edit_header.png";

    const char * const ICON_CREATE_SNAPSHOT = "icons/createSnapshot.png";
    const char * const ICON_REVERT_SNAPSHOT = "icons/revertSnapshot.png";
    const char * const ICON_DELETE_SNAPSHOT = "icons/deleteSnapshot.png";

    const char * const ICON_ENTITY_UUID_CONFLICT = "icons/uuidConflict.png";
    const char * const ICON_TRASH = "icons/trash.png";
    const char * const ICON_VLAN = "icons/icon_vlan.svg";
    const char * const ICON_EDIT_VLAN = "icons/edit.png";
    const char * const ICON_EDIT_VLAN_HEADER = "icons/edit_header.png";
    const char * const ICON_HARDWARE =  "icons/hardware.png";
    const char * const ICON_MEMORY_DUMP = "icons/memorydump.png";

    const char * const GRAPHIC_UNKNOWN_ENTITY = "graphics/unknownEntity.svg";
    const char * const GRAPHIC_UNKNOWN_ENTITY_GRAY = "graphics/unknownEntity.svg";
    const char * const GRAPHIC_DESKTOP = "graphics/computerDesktop.svg";
    const char * const GRAPHIC_DESKTOP_GRAY = "graphics/computerDesktop_gray.svg";
    const char * const GRAPHIC_SWITCH = "graphics/switch.svg";
    const char * const GRAPHIC_SWITCH_GRAY = "graphics/switch_gray.svg";
    const char * const GRAPHIC_BUSY = "graphics/busy.svg";
    const char * const GRAPHIC_CREATED = "graphics/created.svg";
    const char * const GRAPHIC_PAUSED = "graphics/paused.svg";
    const char * const GRAPHIC_STARTED= "graphics/started.svg";
    const char * const GRAPHIC_STOPPED = "graphics/stopped.svg";
    const char * const GRAPHIC_SUSPENDED = "graphics/suspended.svg";
    const char * const GRAPHIC_SUSPENDED_UNDEFINED = "graphics/suspended_undefine.svg";
    const char * const GRAPHIC_UNDEFINE = "graphics/undefine.svg";
    const char * const GRAPHIC_UNKNOWN = "graphics/unknown.svg";
    const char * const GRAPHIC_UNIMPLEMENTED = "graphics/unimplemented.svg";
    const char * const GRAPHIC_IMMUTABLE = "graphics/immutable.svg";
    const char * const GRAPHIC_USB = "graphics/usb.svg";
    const char * const GRAPHIC_HYBRID = "graphics/hybridGate.svg";
    const char * const GRAPHIC_HYBRID_GRAY = "graphics/hybridGate_gray.svg";
    const char * const GRAPHIC_WIFIAP = "graphics/wifiAP.svg";
    const char * const GRAPHIC_WIFIAP_GRAY = "graphics/wifiAP_gray.svg";
    const char * const GRAPHIC_DYNAMIPSROUTER = "graphics/dynamipsrouter.svg";
    const char * const GRAPHIC_DYNAMIPSROUTER_GRAY = "graphics/dynamipsrouter_gray.svg";
    const char * const GRAPHIC_TOPOLOGY_GATE = "graphics/topologyGate.svg";
    const char * const GRAPHIC_TOPOLOGY_GATE_GRAY = "graphics/topologyGate_gray.svg";
    const char * const GRAPHIC_WIRE = "graphics/wire.svg";

    const char * const GRAPHIC_INFO_SATELLITE_ACTIVE = "graphics/infoSatelliteActive.svg";
    const char * const GRAPHIC_INFO_SATELLITE_INACTIVE = "graphics/infoSatelliteInactive.svg";
    const char * const GRAPHIC_MODEL = "graphics/model.png";
    const char * const GRAPHIC_LINKED = "graphics/linked_base.svg";
    const char * const GRAPHIC_CAPTURE = "graphics/capture.svg";

    const char * const DEFAULT_PREVIEW = "icons/defaultPreviewBackground.png";
    const char * const TOPOLOGY_WITH_PROBLEM= "icons/topologyWithProblem.png";
    const char * const ICON_TOPOLOGY = "icons/welcomemode.png";

    const int DEFAULT_IMPRESSION_RESOLUTION = 300;      //DPI (Dot per inch)
    const double INCH_IN_MILLIMETER = 25.4;

    const int WIDTH_PREVIEW = 225;
    const int HEIGHT_PREVIEW = 140;
    const int QUALITY_PREVIEW = 50;
    const int PREVIEW_STATUS_ICON_SIZE = 32;
    const char * const FORMAT_PREVIEW = "png";
    const int WIDTH_LIST_ICON_PREVIEW = 149;
    const int HEIGHT_LIST_ICON_PREVIEW = 93;
    const int PASSWORD_LENGTH = 10;
    const int WPA_SIZE_MIN = 8;
    const int WPA_SIZE_MAX = 63;
    const int WPA_SIZE_HEXA = 64;
    const int WEP_SIZE_HEXA_40_BITS = 10;
    const int WEP_SIZE_HEXA_128_BITS = 26;
    const int WEP_SIZE_HEXA_152_BITS = 32;
    const int WEP_SIZE_DEC_40_BITS = 5;
    const int WEP_SIZE_DEC_128_BITS = 13;
    const int WEP_SIZE_DEC_152_BITS = 16;
    const int WIRE_SPACING = 8;
    const int TOOLBAR_ICON_SIZE_WIDTH = 16;
    const int TOOLBAR_ICON_SIZE_HEIGHT = 16;
    const int MODE_BUTTON_ICON_SIZE_WIDTH = 48;
    const int MODE_BUTTON_ICON_SIZE_HEIGHT = 48;
    const int BROSWER_TOOLBUTTON_ICON_SIZE_WIDTH = 24;
    const int BROSWER_TOOLBUTTON_ICON_SIZE_HEIGHT = 24;
    const int RIGHTS_ICON_SIZE_WIDTH = 24;
    const int RIGHTS_ICON_SIZE_HEIGHT = 24;
    const int DEFAULT_TOPOLOGY_SIZE = 1000;

    const char * const PASSWORD_SETTINGS_GROUP = "password";
    const char * const PASSWORD_ALLOWED_CHARACTERS = "allowedCharacters";
    const char * const PASSWORD_ALLOWED_CHARACTERS_LIST = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    const char * const PASSWORD_LENGTH_KEY = "length";
    const char * const MAIN_WINDOW_SETTINGS = "mainWindowSettings";
    const char * const MAIN_WINDOW_GEOMETRY = "mainWindowGeometry";
    const char * const MAIN_WINDOW_SIZE_IS_SAVED = "mainWindowSizeIsSaved";
    const char * const MODEBROWSERBAR_KEY = "modeBrowserBarSettings";
    const int MODEBROWSERBAR_DEFAULT_STATE = ModeBrowserFull;
    const char * const LOG_MESSAGE_SETTINGS = "logMessageSettings";
    const char * const LOG_MESSAGE_STATE_IS_SAVED = "logMessageStateIsSaved";
    const char * const LOG_MESSAGE_IS_DISPLAY = "logMessageIsDisplay";
    const char * const DETACHED_TAB_OPTION = "detachedTabOption";
    const char * const REMOTEDISPLAY_RESOLUTION_OPTION = "remoteDisplayResolutionOption";
    const char * const REMOTEDISPLAY_DEFAULT_RESOLUTION_OPTION = "1024x768";
    const char * const VNC_VIEWER_COMMAND_KEY = "vncViewer";
    const char * const VNC_VIEWER_DEFAULT_COMMAND = "vncviewer -title %TITLE%";
    const char * const WIRES_SETTINGS = "Wires";
    const char * const WIRE_ORIGIN_MODE = "wireOriginMode";
    const char * const WIRE_DEFAULT_COLOR = "WireDefaultColor";
    const char * const SIDEBAR_SETTINGS = "SidebarSettings";
    const char * const SIDEBAR_STATE_IS_SAVED = "sidebarStateIsSaved";
    const char * const SIDEBAR_IS_VISIBLE = "sidebarIsVisible";
    const char * const OPENED_WIDGETS = "openedWidgets";
    const char * const SNAPSHOT_SETTINGS = "SnapshotSettings";
    const char * const SNAPSHOT_FOLDER = "snapshotFolder";
    const char * const SNAPSHOT_FILE_FORMAT = "fileFormat";
    const char * const SNAPSHOT_ORIGINAL_SIZE =  "snapshotOriginalSize";
    const char * const SNAPSHOT_WIDTH = "snapshotWidth";
    const char * const SNAPSHOT_HEIGHT = "snapshotHeight";
    const char * const SNAPSHOT_QUALITY = "snapshotQuality";
    const char * const TOPOLOGY_SETTINGS = "Topology";
    const char * const TOPOLOGY_DEFAULT_FORMAT = "DefaultFormat";
    const char * const TOPOLOGY_DEFAULT_BACKGROUND_COLOR_KEY = "DefaultBackgroundColor";
    const char * const TOPOLOGY_DEFAULT_BACKGROUND_COLOR = "787878";
    const char * const TOPOLOGY_DEFAULT_MODEL_BACKGROUND_COLOR_KEY = "DefaultModelBackgroundColor";
    const char * const RADIUS_FOR_DROPING_ENTITIES_KEY = "RadiusForDropingEntities";
    const char * const ANGLE_FOR_DROPING_ENTITIES_KEY = "AngleForDropingEntities";
    const char * const TOPOLOGY_DEFAULT_MODEL_BACKGROUND_COLOR = "787878";
    const char * const TOPOLOGY_DEFAULT_SIZE_UNIT = "DefaultSizeUnit";
    const char * const TOPOLOGY_ENABLED_FORMAT = "EnabledFormat";
    const char * const TOPOLOGY_ID_KEY = "id";
    const char * const TOPOLOGY_DESCRIPTION = "description";
    const char * const TOPOLOGY_WIDTH = "width";
    const char * const TOPOLOGY_HEIGHT = "height";
    const char * const TOPOLOGY_DEFAULT_DISPLAY_GRID = "DisplayGrid";
    const char * const TOPOLOGY_ALIGN_ON_GRID = "AlignOnGrid";
    const char * const TOPOLOGY_STATUS_ICON = "DisplayStatusIcons";
    const char * const HYNESIM = "hynesim";
    const char * const ELIDE_MODE_KEY = "ElideMode";
    const char * const TOPOLOGY_QML = "qrc:/qml/remotedisplayscreenshotview.qml";

    const bool MAIN_WINDOW_DEFAULT_STATE_SAVE = true;
    const bool LOG_MESSAGE_DEFAULT_STATE_SAVE = true;
    const bool SIDEBAR_DEFAULT_STATE_SAVE = true;

} // Constants

class Ressources
{
public:
    static QHash<QString, QString> *entryPixmapPathHash();
    static QString themedPath(const QString &filename);

    static bool hasClassNamePixmap(const QString &className);
    static QPixmap getClassNamePixmap(QString className, bool isTemplate = false, bool isModel = false, QVector<std::string> parentClasses = QVector<std::string>());
    static QPixmap getEntryPixmap(HnsClient::CatalogItem *catalogItem);
    static QPixmap getTypeIcon(const QString &type);
    static QPixmap getStatusPixmap(const Hns::Status &status);
    static QGraphicsSvgItem *getStatusSVGItem(Hns::Status status, QGraphicsItem *parentItem);
    static bool registerSvgRenderer(const QString &filename);
    static bool registerSvgRenderer(const QString &filename, QSvgRenderer *renderer);
    static QSvgRenderer *getRenderer(const QString &filename);
    static QString getToolTip(HnsClient::GenericEntity *genericEntity); //TODO: refactor this method
protected:
    static QString _formatPath(const QString &filename, QString theme = Constants::SETTINGS_DEFAULT_THEME);
    static QPixmap _finalizePixmap(QPixmap pixmap, bool isModel, bool isTemplate);
};

} // namespace Hnv


#endif // RESSOURCES_H
