/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef ACCOUNTDIALOG_H
#define ACCOUNTDIALOG_H

// Generated hynesim headers
#include "common/usermanager.h"

// Qt headers
#include <QDialog>

class QLabel;

namespace Ui {
class AccountDialog;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* AccountDialog
*******************************************************************************/
class AccountDialog : public QDialog
{
    Q_OBJECT
public:
    explicit AccountDialog(QWidget *parent = 0);
    ~AccountDialog();

private slots:
    void on_action_Generate_password_triggered();
    void on_lePassword_textEdited(const QString &arg1);
    void on_leConfirmPassword_textEdited(const QString &arg1);
    void on_buttonBox_accepted();

private:
    bool isNotEmpty(QLabel *targetLabel, QString &text);
    void setLabelValidationStyle(QLabel *targetLabel, bool isValid);
    Ui::AccountDialog *ui;
    Hns::UserPtr _user;
    QPushButton * _advancedButton;
};

} // namespace Hnv
#endif // ACCOUNTDIALOG_H
