/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef APPLICATIONSETTINGSDIALOG_H
#define APPLICATIONSETTINGSDIALOG_H

// Qt headers
#include <QHash>
#include <QDialog>

class QToolButton;

namespace Ui {
class ApplicationSettingsDialog;
} // namespace Ui

namespace Hnv {

class ApplicationSettingsInterfacePage;

class ApplicationSettingsDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ApplicationSettingsDialog(QWidget *parent = 0);
    ~ApplicationSettingsDialog();

    void addPageToSettings(ApplicationSettingsInterfacePage *page);

private slots:
    void on_buttonBox_accepted();
    void on_buttonBox_rejected();

private:
    Ui::ApplicationSettingsDialog *ui;
    QHash<QToolButton *, ApplicationSettingsInterfacePage *> _pageContainer;
};

} // namespace Hnv

#endif // APPLICATIONSETTINGSDIALOG_H
