/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "applicationsettingsinterfacepage.h"

// Qt headers
#include <QToolButton>

namespace Hnv {

ApplicationSettingsInterfacePage::ApplicationSettingsInterfacePage(QWidget *parent)
    : QWidget(parent)
{
}

QToolButton *ApplicationSettingsInterfacePage::button()
{
    return _toolButton;
}

void ApplicationSettingsInterfacePage::_setButton(QToolButton *button)
{
    _toolButton = button;
}

QToolButton *ApplicationSettingsInterfacePage::_generateButton(const QString &title, const QIcon &icon)
{
    QToolButton *button = new QToolButton(this);
    button->setText(title);
    button->setIcon(icon);
    button->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
    button->setCheckable(true);
    button->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Maximum);
    return button;
}

} // namespace Hnv
