/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef APPLICATIONSETTINGSTEMPLATEPAGE_H
#define APPLICATIONSETTINGSTEMPLATEPAGE_H

// Qt headers
#include <QWidget>

class QToolButton;

namespace Hnv {

class ApplicationSettingsInterfacePage : public QWidget
{
public:
    ApplicationSettingsInterfacePage(QWidget *parent);

    virtual void reload() = 0;
    virtual void validation(bool *check) = 0;
    virtual void save() = 0;

    virtual QToolButton* button();

protected:
    virtual void _setButton(QToolButton* button);
    QToolButton *_generateButton(const QString &title, const QIcon &icon);

private:
    QToolButton *_toolButton;

};

} // namespace Hnv

#endif // APPLICATIONSETTINGSTEMPLATEPAGE_H
