/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef CATALOGICONSDELEGATE_H
#define CATALOGICONSDELEGATE_H

// Generated hynesim headers
#include "common/entity.h"

// Qt headers
#include <QHash>
#include <QPixmap>
#include <QStyledItemDelegate>

namespace Hnv {

/*******************************************************************************
* CatalogIconsDelegate
*/
class CatalogIconsDelegate : public QStyledItemDelegate
{
    Q_OBJECT
public:
    CatalogIconsDelegate(QObject *parent = 0);
    QSize sizeHint(const QStyleOptionViewItem &option, const QModelIndex &index) const;
    void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    QPixmap extractFrameFromPixmap(QPixmap pixmap, int targetFrame, int framePerLine, int frameSize=32) const;
    QStyleOptionViewItem paintExtraPixmap(QPixmap pixmap, QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;

public slots:
    void transactionStarted(QPersistentModelIndex index);
    void stopTimer();

signals:
    void requestUpdate(QPersistentModelIndex index);

protected:
    void timerEvent(QTimerEvent *event);
    int extraIconsCount(const QModelIndex &index) const;

private:
    QPixmap _lockedPixmap;
    QPixmap _unknowStatus;
    QPixmap _syncingFramesPixmap;
    QPixmap _savedUndefinedPixmap;
    QPixmap _linkedPixmap;
    QHash<QPersistentModelIndex, int> _syncingItems;
    QHash<Hns::Status, QPixmap> _statusHash;
    int _syncingTimerID;
};

} // namespace Hnv
#endif // CATALOGICONSDELEGATE_H
