#ifndef GRAPHICSELECTORDIALOG_H
#define GRAPHICSELECTORDIALOG_H

// Qt headers
#include <QHash>
#include <QDialog>

namespace Ui {
class GraphicSelectorDialog;
} // namespace Ui

namespace Hnv {

class GraphicSelectorDialog : public QDialog
{
    Q_OBJECT

public:
    explicit GraphicSelectorDialog(QHash<QString, QByteArray> customGraphicHash, QWidget *parent = 0);
    ~GraphicSelectorDialog();
    bool isFileNew() const;
    QString selectedFileName() const;

private slots:
    void on_buttonBox_accepted();
    void _browseButtonClickedSlot();
    void _clearButtonClickedSlot();
    void _deleteButtonClickedSlot();
    void _itemSelectionChangedSlot();

private:
    Ui::GraphicSelectorDialog *ui;
    QHash<QString, QByteArray> _customGraphicHash;
    QPushButton *_browseButton;
    QPushButton *_clearButton;
    QPushButton *_deleteButton;
    bool _newFile;
    QString _selectedFileName;
};

} // namespace Hnv
#endif // GRAPHICSELECTORDIALOG_H
