/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "accessrightpage.h"
#include "ui_accessrightpage.h"
#include "ressources.h"
#include "accessrightwidget.h"

// hynesim hnsclient headers
#include <libhnsclient/entry.h>

// Qt headers
#include <QToolButton>

namespace Hnv {
AccessRightPage::AccessRightPage(HnsClient::CatalogItem *catalogItem, Hns::EntryPropertiesPtr entryProperties, QWidget *parent, bool readOnly, bool defined)
    : EntryPropertiesPage(catalogItem, entryProperties,parent,readOnly, defined)
    , ui(new Ui::AccessRightPage)
{
    ui->setupUi(this);
    HnsClient::CatalogItem *validCatalogItem = qobject_cast<HnsClient::CatalogItem *>(_sourceEntry);
    if (validCatalogItem)
        ui->accessRightWidget->initialize(validCatalogItem);
    _disableWidgetsWhenNecessary(readOnly);
}

AccessRightPage::~AccessRightPage()
{
    delete ui;
}

void AccessRightPage::initFocus()
{
}

QToolButton *AccessRightPage::getPageButton()
{
    return _generatePageButton(tr("Access policies"), QIcon(Ressources::themedPath(Constants::ICON_PERMISSION)));
}

void AccessRightPage::_disableWidgetsWhenNecessary(bool necessary)
{
    ui->accessRightWidget->setDisabled(necessary);
}

void AccessRightPage::_validate(bool &isModified, bool &isInvalid)
{
    _computeValidationState(_sourceEntry->validateACLList(ui->accessRightWidget->aclList()), isModified, isInvalid);
}

} // namespace Hnv
