/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DOMAINNETWORKCARDWIDGET_H
#define DOMAINNETWORKCARDWIDGET_H

// Generated hynesim headers
#include "common/domainentry.h"
#include "common/domainentryproperties.h"

// Qt headers
#include <QWidget>

namespace Ui {
class DomainNetworkCardWidget;
} // namespace Ui

namespace Hnv {
/*******************************************************************************
* DomainNetworkCardWidget
*/
class DomainNetworkCardWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DomainNetworkCardWidget(QWidget *parent = 0, QString domainType = "");
    ~DomainNetworkCardWidget();
    void setCardInfo(Hns::Netcard card, Hns::DomainEntryPropertiesPtr domainProperties);
    void displayErrors(int error);
    void clearErrors();
    Hns::Netcard getCardInfo();
    void setDisabled(bool disabled);
    void initNewCard();

private:
    Ui::DomainNetworkCardWidget *ui;
    Hns::Netcard _card;
    QString _domainType;
};

} // namespace Hnv
#endif // DOMAINNETWORKCARDWIDGET_H
