/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DOMAINNETWORKPAGE_H
#define DOMAINNETWORKPAGE_H

// Project headers
#include "hnv_entryproperties.h"

// Generated hynesim headers
#include "common/domainentry.h"
#include "common/domainentryproperties.h"

namespace Ui {
class DomainNetworkPage;
} // namespace Ui

namespace Hnv {

class DomainNetworkCardWidget;
/*******************************************************************************
* DomainNetworkPage
*/
class DomainNetworkPage : public EntryPropertiesPage
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit DomainNetworkPage(HnsClient::CatalogItem *entry,Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool define = false);
    ~DomainNetworkPage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();
    virtual void _validate(bool &isModified, bool &isInvalid);


protected:
    void _disableWidgetsWhenNecessary(bool necessary);

private slots:
    void on_tabWidget_tabCloseRequested(int index);
    DomainNetworkCardWidget *_addNetcardTab(QString label);
    DomainNetworkCardWidget *_addNetcard();

private:
    void _initNetcardTab(Hns::Netcard card);
    void _initNetcardTab(Hns::Netcard card, DomainNetworkCardWidget *tab);
    void _setNoCardsTab();
    DomainNetworkCardWidget *getNetworkCardWidget(int index);
    Hns::EntryPropertiesPtr _properties;
    Hns::DomainEntryPropertiesPtr _domainProperties;
    Ui::DomainNetworkPage *ui;
    bool _noValidCards;

    QHash<Ice::Long, int> _errorNetworkCardList;
    int _maxNetworkCards;
};

} // namespace Hnv
#endif // DOMAINNETWORKPAGE_H
