/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DOMAINSTORAGEPAGE_H
#define DOMAINSTORAGEPAGE_H

// Project headers
#include "hnv_entryproperties.h"

// Generated hynesim headers
#include "common/domainentry.h"
#include "common/domainentryproperties.h"

namespace Ui {
class DomainStoragePage;
} // namespace Ui

namespace Hnv {

class DomainStorageWidget;
/*******************************************************************************
* DomainPage
*/
class DomainStoragePage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    Q_INVOKABLE explicit DomainStoragePage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0,bool readOnly = false,bool defined = false);
    ~DomainStoragePage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();
    virtual void _validate(bool &/*isModified*/, bool &/*isInvalid*/);

private slots:
    DomainStorageWidget *getStorageWidget(int index);
    DomainStorageWidget *_addStorageTab(QString label);

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    void _initStorageTab(Hns::Disk disk);

private:
    Hns::EntryPropertiesPtr _properties;
    Hns::DomainEntryPropertiesPtr _domainProperties;
    QHash<QString, int> _errorDiskList;
    Ui::DomainStoragePage *ui;
};

} // namespace Hnv
#endif // DOMAINSTORAGEPAGE_H
