/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DOMAINSTORAGEWIDGET_H
#define DOMAINSTORAGEWIDGET_H

// Generated hynesim headers
#include "common/domainentry.h"
#include "common/domainentryproperties.h"

// Qt headers
#include <QWidget>

namespace Ui {
class DomainStorageWidget;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* DomainStorageWidget
*/
class DomainStorageWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DomainStorageWidget(QWidget *parent = 0);
    ~DomainStorageWidget();
    void setStorageInfos(Hns::Disk disk, Hns::DomainEntryPropertiesPtr domainProperties);
    Hns::Disk getStorageInfos();
    void clearErrors();
    void displayErrors(int error);

private slots:
    void on_busComboBox_currentIndexChanged(const QString &arg1);

private:
    Ui::DomainStorageWidget *ui;
    Hns::DomainEntryPropertiesPtr _domainProperties;
    Hns::Disk _disk;
};

} // namespace Hnv
#endif // DOMAINSTORAGEWIDGET_H
