/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef DYNAMIPSCONFIGURATINOPAGE_H
#define DYNAMIPSCONFIGURATINOPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class DynamipsConfigurationPage;
} // namespace

namespace HnsClient {
class DynamipsRouterEntity;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
* DynamipsRouterPage
*/
class DynamipsConfigurationPage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    Q_INVOKABLE explicit DynamipsConfigurationPage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~DynamipsConfigurationPage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    virtual void _validate(bool &isModified, bool &isInvalid);

private slots:
    void on_reloadRom_clicked();
    void on_reloadFile_clicked();
    void on_pushButtonRomToFile_clicked();
    void on_pushButtonFileToRom_clicked();
    void _pushConfigurationSlot();
    void _printConfigurationFrom64(::std::string);

private:
    Ui::DynamipsConfigurationPage *ui;
    HnsClient::DynamipsRouterEntity * _dynamipsEntity;
};

} // namespace Hnv
#endif // DYNAMIPSROUTERPAGE_H
