/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef EXTRAPAGE_H
#define EXTRAPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class ExtraPage;
} // namespace Ui

namespace HnsClient {
class EntityEntry;
class Entry;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
* Extrapage
*/
class ExtraPage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    explicit ExtraPage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent /*= 0*/, bool readOnly /*= false*/, bool defined /*= false*/, bool editabletemplate);
    ~ExtraPage();

    virtual void initFocus();
    virtual QToolButton *getPageButton();

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    void _displayCreationDate(QString date);
    void _displayModificationDate(QString date);
    void _displayUUID(QString uuid);
    void _displayPath(QString path);
    void _displayTemplate(HnsClient::EntityEntry * entityentry);

    HnsClient::Entry* _entry();

    virtual void _validate(bool &isModified, bool &isInvalid);
    int _validatePath();
    bool _isTopologyEntry();

    Ui::ExtraPage *ui;

};

} // namespace Hnv
#endif // EXTRAPAGE_H
