/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef GENERALPAGE_H
#define GENERALPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class GeneralPage;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* GeneralPage
*/
class GeneralPage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    explicit GeneralPage(HnsClient::CatalogItem *sourceItem, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~GeneralPage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    void _displayShortName(QString shortName);
    void _displayLongName(QString longName);
    void _displayDescription(QString description);
    void _displayTags(QString tagList);

    HnsClient::ValidationResult _validateShortName();
    HnsClient::ValidationResult _validateLongName();
    HnsClient::ValidationResult _validateDescription();
    HnsClient::ValidationResult _validateTags();

    virtual void _validate(bool &isModified, bool &isInvalid);
    Ui::GeneralPage *_ui;

};

} // namespace Hnv
#endif // GENERALPAGE_H
