/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HybridNetcardPage_H
#define HybridNetcardPage_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class HybridNetcardPage;
} // namespace Ui

namespace Hnv {
/*******************************************************************************
* HybridNetcardPage
*/
class HybridNetcardPage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    Q_INVOKABLE explicit HybridNetcardPage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~HybridNetcardPage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();

protected:
    void _displayNodeName(QString);
    void _displayPlugIndex(QString);
    void _disableWidgetsWhenNecessary(bool necessary);
    virtual void _validate(bool &isModified, bool &isInvalid);

private:
    Ui::HybridNetcardPage *ui;
};

} // namespace Hnv
#endif // HybridNetcardPage_H
