// Project headers
#include "newvlanform.h"
#include "ui_newvlanform.h"

namespace Hnv {

NewVlanForm::NewVlanForm(QList<int> ids, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::NewVlanForm),
    _ids(ids)

{
    ui->setupUi(this);
    this->setWindowTitle(tr("Add New VLAN"));

    for(int i = 0; i<_ids.count(); i++) {
        if(!_ids.contains(i)) {
            _ID = i;
            break;
        }
        else
            _ID = i+1;
    }

    ui->sbID->setValue(_ID);

}

NewVlanForm::~NewVlanForm()
{
    delete ui;
}

int NewVlanForm::getID()
{
    return _ID;
}

QString NewVlanForm::getName()
{
    return _name;
}

QString NewVlanForm::getDescription()
{
    return _description;
}
void NewVlanForm::on_leName_textChanged(const QString &arg1)
{
    _name = arg1;
}

void NewVlanForm::on_leDescription_textChanged(const QString &arg1)
{
    _description = arg1;
}

void NewVlanForm::on_sbID_valueChanged(int arg1)
{
    _ID = arg1;
}

void NewVlanForm::on_buttonBox_accepted()
{
    if (!_ids.contains(_ID)) {
        ui->labelID->setStyleSheet("color:white;");
        emit accept();
    }
    else {
        ui->labelID->setStyleSheet("color:red");
    }
}

} // namespace Hnv
