/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SWITCHPAGE_H
#define SWITCHPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class SwitchPage;
} // namespace Ui

namespace Hnv {
/*******************************************************************************
* SwitchPage
*/
class SwitchPage : public EntryPropertiesPage
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit SwitchPage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~SwitchPage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();
signals:
    void portNumberChanged(int);

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    void _displayPorts(int number);
    void _displayHub(bool value);
    void _displayStp(bool value);

    virtual void _validate(bool &isModified, bool &isInvalid);

private slots:
    void cbTextChanged();
    void _hubCheckBoxChangedSlot(bool value);
    void _portSpinBoxValueChangedSlot(int value);

private:
    Ui::SwitchPage *ui;
    bool _portMirroringSupported;
    bool _stpSupported;
};

} // namespace Hnv
#endif // SWITCHPAGE_H
