/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYGATEPAGE_H
#define TOPOLOGYGATEPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class TopologyGatePage;
} // namespace Ui

namespace Hnv {

class TopologyGatePage : public EntryPropertiesPage
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit TopologyGatePage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent, bool readOnly, bool defined);
    ~TopologyGatePage();

    virtual void initFocus();
    virtual QToolButton *getPageButton();
    
protected:
    virtual void _displayNetworkName(QString name);
    virtual void _validate(bool &isModified, bool &isInvalid);
    virtual void _disableWidgetsWhenNecessary(bool necessary);

private:
    Ui::TopologyGatePage *ui;
};

} // namespace Hnv
#endif // TOPOLOGYGATEPAGE_H
