/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef USERSELECTORDIALOG_H
#define USERSELECTORDIALOG_H

// Qt headers
#include <QDialog>

class QModelIndex;

namespace Ui {
class UserSelectorDialog;
} // namespace Ui

namespace Hnv {
class UsersModel;
class GroupsModel;
class TreeSortFilterProxyModel;

class UserSelectorDialog : public QDialog
{
    Q_OBJECT

public:
    explicit UserSelectorDialog(UsersModel *usersModel, QWidget *parent = 0);
    explicit UserSelectorDialog(GroupsModel *groupsModel, QList<qlonglong> userGroupList, QWidget *parent = 0);
    ~UserSelectorDialog();
    void setCurrentItemID(qlonglong itemID);
    qlonglong getSelectedItemID();

private slots:
    void on_lineEdit_textChanged(const QString &arg1);
    void on_tableView_doubleClicked(const QModelIndex &index);
    void on_buttonBox_accepted();

private:
    void _acceptWithIndex(QModelIndex index);
    Ui::UserSelectorDialog *ui;
    UsersModel * _usersModel;
    GroupsModel * _groupsModel;
    TreeSortFilterProxyModel *_sortModel;
    qlonglong _selectedItemID;
};

} // namespace Hnv
#endif // USERSELECTORDIALOG_H
