/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
#ifndef VLANPAGE_H
#define VLANPAGE_H

// Project headers
#include "hnv_entryproperties.h"

class QWidget;
class QModelIndex;

namespace Ui {
class VlanPage;
} // namespace Ui

namespace Hnv {

class VlanModel;

class VlanPage : public EntryPropertiesPage
{
    Q_OBJECT

public:
    Q_INVOKABLE explicit VlanPage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~VlanPage();
    virtual void initFocus();
    virtual void init();
    virtual QToolButton *getPageButton();

public slots:
    void portNumberChangedSlot(int);

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    virtual void _validate(bool &isModified, bool &isInvalid);

private slots:
    void on_tableViewVLan_pressed(const QModelIndex &index);

    void on_pushButtonAdd_clicked();

    void on_tableViewVLan_doubleClicked(const QModelIndex &index);

private:
    Ui::VlanPage *ui;
    VlanModel *_model;
    EntryProperties *_parentPage;
};

} // namespace Hnv
#endif // VLANPAGE_H
