/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIREPAGE_H
#define WIREPAGE_H

// Project headers
#include "hnv_entryproperties.h"

namespace Ui {
class WirePage;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* WirePage
*/
class WirePage : public EntryPropertiesPage
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit WirePage(HnsClient::CatalogItem *entry, Hns::EntryPropertiesPtr entryProperties, QWidget *parent = 0, bool readOnly = false, bool defined = false);
    ~WirePage();
    virtual void initFocus();
    virtual QToolButton *getPageButton();

protected:
    void _disableWidgetsWhenNecessary(bool necessary);
    void _displayLoss(int lossLR, int lossRL);
    void _displayDelay(int delayLR,int  delayRL );
    void _displayDup(int dupLR,int dupRL);
    void _displayBandWidth(int bandwidthLR, int bandwidthRL);
    void _displayMtu(int mtuLR, int mtuRL);
    virtual void _validate(bool &isModified, bool &isInvalid);
    Ui::WirePage * ui;

private slots:
    void _cbImplementationTextChanged();
};

} // namespace Hnv
#endif // WIREPAGE_H
