/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef GROUPEDITDIALOG_H
#define GROUPEDITDIALOG_H

// Generated hynesim headers
#include "common/usermanager.h"

// Qt headers
#include <QDialog>
#include <QModelIndex>
#include <QHash>

namespace Ui {
class GroupEditDialog;
} // namespace Ui

class QLabel;

namespace Hnv {

/*******************************************************************************
* GroupEditDialog
*/
class GroupEditDialog : public QDialog
{
    Q_OBJECT
public:
    explicit GroupEditDialog(Diamesh::GroupPtr &group, QHash<qlonglong, QString> groupNameHash, QHash<qlonglong, QString> usersNameHash, QWidget *parent = 0);
    ~GroupEditDialog();

private:
    Ui::GroupEditDialog *ui;
    Diamesh::GroupPtr &_groupData;
    QString _originalName;
    QHash<qlonglong, QString> _groupNameHash;
    QHash<qlonglong, QString> _usersNameHash;

    bool isNotEmpty(QLabel *targetLabel, QString &text);
    void setLabelValidationStyle(QLabel * targetLabel, bool isValid);

private slots:
    void on_addSelected_clicked();
    void on_allAll_clicked();
    void on_buttonBox_accepted();
    void on_removeSelected_clicked();
    void on_removeAll_clicked();
    void on_listAvailableUsers_doubleClicked(const QModelIndex &index);
    void on_listUsers_doubleClicked(const QModelIndex &index);
};

} // namespace Hnv
#endif // GROUPEDITDIALOG_H
