// Project headers
#include "dialogbuttonlistwidget.h"
#include "ui_dialogbuttonlistwidget.h"

// Qt headers
#include <QToolButton>

namespace Hnv {

DialogButtonListWidget::DialogButtonListWidget(QWidget *parent) :
    ButtonListWidget(parent),
    ui(new Ui::DialogButtonListWidget)
{
    ui->setupUi(this);
}

DialogButtonListWidget::~DialogButtonListWidget()
{
    delete ui;
}

void DialogButtonListWidget::addButton(QToolButton *toolButton)
{
    int size = _buttonHash.size();
    _buttonHash.insert(size, toolButton);
    ui->verticalLayout->insertWidget(size, toolButton);
    connect(toolButton, SIGNAL(clicked()), this, SLOT(_toolButtonClickedSlot()));
    if (size == 0) { //first time
        _currentCheckButton = toolButton;
        toolButton->setChecked(true);
    }
}

void DialogButtonListWidget::setCurrentButton(QToolButton *toolButton)
{
    _currentCheckButton->setChecked(false);
    _currentCheckButton = toolButton;
    _currentCheckButton->setChecked(true);
    int index = _buttonHash.key(toolButton, -1);
    if (index != -1) {
        emit currentButtonChanged(index);
    }
}


void DialogButtonListWidget::_toolButtonClickedSlot()
{
    QToolButton *toolButton = qobject_cast<QToolButton *>(sender());
    if (!toolButton)
        return;
    _currentCheckButton->setChecked(false);
    _currentCheckButton = toolButton;
    _currentCheckButton->setChecked(true);
    int index = _buttonHash.key(toolButton, -1);
    if (index != -1) {
        emit currentButtonChanged(index);
    }
}

} // namespace Hnv
