/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HYNEVIEWSTATUSBAR_H
#define HYNEVIEWSTATUSBAR_H

// Project headers
#include "connectionstatuswidget.h"

// Qt headers
#include <QStatusBar>

namespace Hnv {

class StatusBarLabel;
class ZoomSliderWidget;

/*******************************************************************************
* HyneviewStatusBar
*/
class HyneviewStatusBar : public QStatusBar
{
    Q_OBJECT
public:
    explicit HyneviewStatusBar(QWidget *parent = 0);

signals:
    void toggleSideBar();
    void toggleRightSideBar();
    void toggleLogMessageWidget(bool);
    void zoomValueChanged(int value);

public slots:
    void displayCursorPosition(int x, int y, bool isContainer);
    void setNetworkStatus(ConnectionStatusWidget::ConnectionState state, QString message = "");
    void setZoomValue(int value);
    void clearLabelCoord();
    void uncheckMessageAction();
    void enableSideBar(bool enable, bool isVisible);
    void enableRightSideBar(bool enable, bool isVisible);
    QList<QAction *> statusBarActions();
    void enableTopologyActions(bool enable);

private:
    StatusBarLabel *_cursorPosLabel;
    ConnectionStatusWidget *_netStatusWidget;
    ZoomSliderWidget *_zoomSliderWidget;
    QAction *_messagesAction;
    QAction *_sideBarAction;
    QAction *_rightSideBarAction;
    QList<QAction *> _statusBarActionlist;
};

} // namespace Hnv
#endif // HYNEVIEWSTATUSBAR_H
