#ifndef CUSTOMRIGHTDIALOG_H
#define CUSTOMRIGHTDIALOG_H

#include <QDialog>
#include <QStringListModel>

#include "accessrightwidget.h"

#include "libhnsclient/entry.h"

#include "common/importable.h"

class QCheckBox;

namespace Ui {
class CustomRightDialog;
}

namespace Hnv {
class CustomRightDialog : public QDialog
{
    Q_OBJECT

public:
    explicit CustomRightDialog(Hns::ImportOptionsList importList, QWidget *parent = 0);
    ~CustomRightDialog();
    Hns::ImportOptionsList options();

private slots:
    void onTableViewClickedSlot(const QModelIndex &index);

private:
    Ui::CustomRightDialog *ui;
    QHash<int, AccessRightWidget *> _widgetHash;
    QHash<int, QCheckBox *> _checkboxHash;
    QHash<int, HnsClient::TopologyEntry *> _entryHash;
    QStringListModel *_model;
};

} //Hnv
#endif // CUSTOMRIGHTDIALOG_H

