#ifndef IMPORT_H
#define IMPORT_H

// Generated hynesim headers
#include "common/catalogimporter.h"


// Qt headers
#include <QDialog>
#include <QMap>
#include <QList>
#include <QHash>

class QSortFilterProxyModel;
class QModelIndex;

namespace HnsClient {
class EntityEntry;
class CatalogImporter;
} // namespace HnsClient

namespace Ui {
class ImportDialog;
} // namespace Ui

namespace Hnv {
class ImportEntryModel;
class ArchiveTreeModel;

class ImportDialog : public QDialog
{
    Q_OBJECT

public:
    explicit ImportDialog(QWidget *parent = 0);
    ~ImportDialog();

private slots:
    void _getArchiveListSlot(Hns::ImportableArchiveList archiveList);
    void _getImportableEntityEntrySlot(QMap<QString, HnsClient::EntityEntry *> importableMap);
    void _selectionChangedSlot();
    void _slotImportArchiveFinished(bool success);
    void _importFolderSlot(bool success);
    void _sessionDisconnected();
    void on_importPushButton_clicked();
    void on_tabWidget_currentChanged(int index);
    void on_topologiesTreeView_expanded(const QModelIndex &index);
    void on_importCountSpinBox_valueChanged(int value);
    void on_customRightsButton_clicked();
    void _progressUpdatedSlot(int value);

private:
    Ui::ImportDialog *ui;
    QSortFilterProxyModel *_filterProxyModel;
    ImportEntryModel * _importEntryModel;
    HnsClient::CatalogImporter *_catalogImporter;
    QMap<QString, HnsClient::EntityEntry *> _mapEntitiesImport;
    QList< ::Hns::ImportableArchivePtr> _importableList;
    ArchiveTreeModel *_archiveTreeModel;
    int _numberOfImport;
    QHash<int, Hns::ImportOptionsList> _optionsList;
};

} // namespace Hnv
#endif // Import_H
