#ifndef IMPORTMODEL_H
#define IMPORTMODEL_H

// Generated hynesim headers
#include "common/importable.h"

// Qt headers
#include <QAbstractItemModel>

namespace HnsClient {
class EntityEntry;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
 *****ImportModel
 *******************************************************************************/
class ImportEntryModel : public QAbstractTableModel
{
    Q_OBJECT
public:
    enum {
        COLUMN_NAME,
        COLUMN_UUID,
        COLUMN_COUNT
    };
    explicit ImportEntryModel(const QMap<QString, HnsClient::EntityEntry *> importableEntryMap, QObject *parent =0);
    ~ImportEntryModel();
    int rowCount(const QModelIndex &parent) const;
    int columnCount(const QModelIndex &parent) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    QVariant data(const QModelIndex &index, int role) const;
    void setEntryList(const QList<Hns::ImportableEntryPtr> list);
    void setImportableMap(const QMap<QString, HnsClient::EntityEntry *> map);
    void resetImportableMap();

protected:
    int _rowCount;
    QList<QString> _pathList;
    QList<Hns::ImportableEntryPtr> _importableEntryList;
};

} // namespace Hnv
#endif // ImportModel_H
