/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef OPTIONSEDITIONWIDGET_H
#define OPTIONSEDITIONWIDGET_H

// ZeroC Ice headers
#include <Ice/Config.h>

// Qt headers
#include <QWidget>
#include <QMap>

namespace Ui {
class OptionsEditionWidget;
} // namespace Ui

namespace Hns {
struct CaptureJobOptions;
struct PcapInfo;
} // namespace Hns

namespace HnsClient {
class GenericEntity;
} // namespace HnsClient

namespace Hnv {

class OptionsEditionWidget : public QWidget
{
    Q_OBJECT

public:
    explicit OptionsEditionWidget(QWidget *parent = 0);
    ~OptionsEditionWidget();
    Hns::CaptureJobOptions getOptions();
    void setEntity(HnsClient::GenericEntity*);
    void setCaptureSettings(Hns::PcapInfo sourceInfo);

protected:
    void setInterfaceList();
    void enableInterface(bool);

private slots:
    void _availableInterfacesForCaptureChanged(QList<int>);
    void on_pbLaunchCaptureJob_clicked();
    void on_pbResetCaptureJob_clicked();

private:
    Ui::OptionsEditionWidget *ui;
    HnsClient::GenericEntity *_entity;
    QMap<Ice::Int, QString> _mapInterfaces;
};

} // namespace Hnv
#endif // OPTIONSEDITIONWIDGET_H
