/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef LISTNODEDELEGATE_H
#define LISTNODEDELEGATE_H

// Qt headers
#include <QStyledItemDelegate>

#define NOT_DEFINED "Not defined"
#define AUTO "Auto"

class QComboBox;
class QCheckBox;

namespace Hnv {

class LoadBalancerDialog;

class ComboboxToNode : public QObject{
    Q_OBJECT
public:
    explicit ComboboxToNode(qlonglong idEntity, LoadBalancerDialog *grandparent, QComboBox *);
    ~ComboboxToNode();

signals:
    void comboboxChange(qlonglong,const QString & newNodeName);
    void checkboxChange(qlonglong,int);

public slots:
    void comboboxChangeSlot(int index);
    void checkboxChangeSlot(bool);

protected:
    qlonglong _idEntity;
    QComboBox * _comboBox;
};

class ListNodeDelegate : public QStyledItemDelegate
{
    Q_OBJECT

public:
    ListNodeDelegate(int comboColumn, int checkColumn ,QObject *parent = 0);
    virtual ~ListNodeDelegate();
    void clear();
    QWidget *createEditor(QWidget *parent,
                          const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;
    virtual void setEditorData(QWidget *editor, const QModelIndex &index) const;
    virtual void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    virtual void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const;
    virtual void updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &index) const;
    void changeEntity(qlonglong entityId, QModelIndex index);

private slots:
    void _comboboxDestroyedSlot(QObject *comboBox);
    void _checkBoxDestroyedSlot(QObject *checkBox);

private:
    int _comboColumn;
    int _checkColumn;
    mutable QHash<qlonglong, ComboboxToNode *> _hashSignalDelegate;
    mutable QHash<qlonglong, QComboBox *> _comboBoxHash;
    mutable QHash<qlonglong, QCheckBox *> _checkBoxHash;
};

} // namespace Hnv
#endif
