#ifndef MACADDRESSMANAGERWIDGET_H
#define MACADDRESSMANAGERWIDGET_H

// Qt headers
#include <QWidget>

namespace Ui {
class MacAddressManagerWidget;
} // namespace Ui

namespace HnsClient {
class MacAddressManager;
} // namespace HnsClient

namespace Hnv {

class MacAddressManagerWidget : public QWidget
{
    Q_OBJECT
public:
    explicit MacAddressManagerWidget(QWidget *parent = 0);
    ~MacAddressManagerWidget();

    void setReadOnly(bool);
    void generate(QString vendor = "");
    QString macAddress();
    void setMacAddress(QString address);

private slots:
    void _generateRandomAddressSlot(QString address);
    void _getVendorFromPrefixSlot(QString vendor);

    void on_macAddressLine_textChanged(const QString &macAddress);
    void on_randomButton_clicked();
    void completerActivated(const QString &vendor);

private:
    Ui::MacAddressManagerWidget *ui;
    HnsClient::MacAddressManager *_macAddressManager;
    QPair<QString, QString> *_currentMacVendor;
};

} // namespace Hnv

#endif // MACADDRESSMANAGERWIDGET_H
