/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NODERESOURCEWIDGET_H
#define NODERESOURCEWIDGET_H

// Qt headers
#include <QWidget>

class QProgressBar;

namespace Ui {
class NodeResourceWidget;
} // namespace Ui

namespace HnsClient {
class NodeInformation;
} // namespace HnsClient

namespace Hnv {

class NodeResourceWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NodeResourceWidget(HnsClient::NodeInformation *nodeInformation ,QWidget *parent = 0);
    ~NodeResourceWidget();

    qlonglong initialCpu();
    qlonglong inititalMemory();
    QString nodeKey();
    QString nodeName();

    void addPrevisionResource(int cpu, int memory);
    void removePrevisionResource(int cpu, int memory);

signals:
    void overloaded( const QString &, int);

protected:
    virtual void _drawProgressBar(int value, int valueMax, QProgressBar *progressBar , bool &overflow , bool prev = true, bool valueToDisplayIsMemory = false);

private:
    Ui::NodeResourceWidget *ui;
    QString _nodeKey;
    QString _nodeName;
    int _initialDefinedEntities;
    int _previsionDefinedEntities;
    qlonglong _initialCpu;
    qlonglong _totalCpu;
    qlonglong _previsionCpu;
    qlonglong _initialMemory;
    qlonglong _totalMemory;
    qlonglong _previsionMemory;
    int _overloaded;
};

} // namespace Hnv
#endif // NODERESOURCEWIDGET_H
