/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef OVERLAYEXPANDABLEWIDGET_H
#define OVERLAYEXPANDABLEWIDGET_H

// Project headers
#include "overlaywidget.h"

namespace Ui {
class OverlayExpandableWidget;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* OverlayExpandableWidget
*******************************************************************************/
class OverlayExpandableWidget : public OverlayWidget
{
    Q_OBJECT
public:
    explicit OverlayExpandableWidget(QString title, QWidget *parent);
    explicit OverlayExpandableWidget(QString title, Qt::Corner corner, QWidget *parent);
    ~OverlayExpandableWidget();
    virtual void setAttachCorner(Qt::Corner corner);
    void setCentralWidget(QWidget *widget);
    QWidget *centralWidget();

protected:
    virtual bool eventFilter(QObject *obj, QEvent *event);
    virtual void resizeEvent(QResizeEvent *event);
    void _setTitleBarPosition(Qt::Corner attachCorner);

private slots:
    void _toggleButtonClicked(bool checked);

private:
    void _initTitleBar(QString title);
    void _updateSize();
    Ui::OverlayExpandableWidget *ui;
    QWidget *_centralWidget;
    bool _centralIsVisible;
};

} // namespace Hnv
#endif // OVERLAYEXPANDABLEWIDGET_H
