/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef OVERLAYWIDGET_H
#define OVERLAYWIDGET_H

// Project headers
#include "hnvwidgets.h"

namespace Hnv {

/*******************************************************************************
* OverlayWidget
*******************************************************************************/
class OverlayWidget : public StyledWidget
{
    Q_OBJECT
public:
    explicit OverlayWidget(QWidget *parent);
    explicit OverlayWidget(Qt::Corner corner, QWidget *parent);
    virtual void setAttachCorner(Qt::Corner corner);
    void setParent(QWidget *parent);

protected:
    void _attachToParent();
    virtual void paintEvent(QPaintEvent *event);
    virtual bool eventFilter(QObject *obj, QEvent *event);
    Qt::Corner _attachCorner;
};

} // namespace Hnv
#endif // OVERLAYWIDGET_H
