/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SIMULATIONMODEWIDGET_H
#define SIMULATIONMODEWIDGET_H

// Project headers
#include "modebrowserwidget.h"

namespace Hnv {

class TopologyWidget;

/*******************************************************************************
* SimulationModeWidget
*******************************************************************************/
class SimulationModeWidget : public ModeWidget
{
    Q_OBJECT
public:
    static SimulationModeWidget* create(QWidget *parent);
    static SimulationModeWidget* instance();
    ~SimulationModeWidget();

    TopologyWidget * topologyWidget();

    virtual bool hasSideBar();
    virtual bool hasRightSideBar();

protected:
    void _initModeAction();

private:
    explicit SimulationModeWidget(QWidget *parent = 0);
    TopologyWidget * _topologyWidget;
    static SimulationModeWidget *_instance;
};

} // namespace Hnv
#endif // SIMULATIONMODEWIDGET_H
