/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
#ifndef SNAPSHOTCREATIONDIALOG_H
#define SNAPSHOTCREATIONDIALOG_H

// Qt headers
#include <QDialog>

namespace Ui {
class SnapshotCreationDialog;
} // namespace Ui

namespace HnsClient {
class DomainEntity;
} // namespace HnsClient

namespace Hnv {

class SnapshotCreationDialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit SnapshotCreationDialog(HnsClient::DomainEntity *entity, QWidget *parent, const char *slot);
    ~SnapshotCreationDialog();
    
private slots:
    void on_buttonBox_accepted();
    void on_buttonBox_rejected();

signals:
    void dialogRejected(bool);

private:
    Ui::SnapshotCreationDialog *ui;
    HnsClient::DomainEntity *_sourceEntity;
    const char *_returnSlot;
};

} // namespace Hnv
#endif // SNAPSHOTCREATIONDIALOG_H
