/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SNAPSHOTTREEMODEL_H
#define SNAPSHOTTREEMODEL_H

// Project headers
#include "treemodel.h"

namespace Hnv {
class SnapshotTreeModelItem;

class SnapshotTreeModel : public TreeModel
{
    Q_OBJECT

public:
    SnapshotTreeModel(int columns = 0, QObject *parent = 0);
    ~SnapshotTreeModel();

    virtual void add(SnapshotTreeModelItem *parent, SnapshotTreeModelItem *child);
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role) const;
    virtual SnapshotTreeModelItem *getCurrentSnapshot();
    virtual void setCurrentSnapshot(SnapshotTreeModelItem *item);

private:
    SnapshotTreeModelItem *_currentSnapshot;
};

} // namespace Hnv
#endif // SNAPSHOTTREEMODEL_H
