/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef SNAPSHOTTREEMODELITEM_H
#define SNAPSHOTTREEMODELITEM_H

// Project headers
#include "treemodelitem.h"

// Generated hynesim headers
#include "common/snapshot.h"

// Qt headers
#include <QVariant>

namespace Hnv {

class SnapshotTreeModelItem : public TreeModelItem
{
    Q_OBJECT

public:
    enum {
        COLUMN_NAME,
        COLUMN_CURRENT_DATE,
        COLUMN_DESCRIPTION,
        COLUMN_COUNT
    };
    SnapshotTreeModelItem(Hns::Snapshot snapshot, bool isCurrentSnapshot = false, int columns = 0, QObject *parent = 0);
    ~SnapshotTreeModelItem();

    virtual QVariant data(int column = 0, int role = Qt::DisplayRole) const;
    Hns::Snapshot getSnapshot();
    bool isCurrentSnapshot();
    void setCurrentSnapshot(bool isCurrentSnapshot);

private:
    Hns::Snapshot _snapshot;
    bool _isCurrentSnapshot;
};

} // namespace Hnv
#endif // SNAPSHOTTREEMODELITEM_H
