/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef CONNECTIONSTATUSWIDGET_H
#define CONNECTIONSTATUSWIDGET_H

// Qt headers
#include <QWidget>
#include <QPixmap>

namespace Ui {
class ConnectionStatusWidget;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* ConnectionStatusWidget
*******************************************************************************/
class ConnectionStatusWidget : public QWidget
{
    Q_OBJECT
public:
    explicit ConnectionStatusWidget(QWidget *parent = 0);
    ~ConnectionStatusWidget();

    enum ConnectionState {
        Online,
        Offline,
        Working,
        Error
    };

    void setStatus(ConnectionStatusWidget::ConnectionState state, QString message = "");
    void setMessage(QString message);

private:
    Ui::ConnectionStatusWidget *_ui;
    QPixmap _onlinePixmap;
    QPixmap _offlinePixmap;
    QPixmap _workingPixmap;
    QPixmap _errorPixmap;
};

} // namespace Hnv
#endif // CONNECTIONSTATUSWIDGET_H
