/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef ZOOMSLIDERWIDGET_H
#define ZOOMSLIDERWIDGET_H

// Qt headers
#include <QWidget>
#include <QRegExp>

class QRegExpValidator;

namespace Ui {
class ZoomSliderWidget;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* ZoomSliderWidget
*******************************************************************************/
class ZoomSliderWidget : public QWidget
{
    Q_OBJECT
public:
    explicit ZoomSliderWidget(QWidget *parent = 0);
    ~ZoomSliderWidget();

signals:
    void valueChanged(int value);
public slots:
    void zoomChanged(int value);
private slots:
    void _valueChanged(int value);
    void on_comboBox_currentIndexChanged(int index);
    void _editingFinished();

private:
    QString _intToCbItem(int i);
    void _checkRange();
    int _getIntFromCb();
    Ui::ZoomSliderWidget *ui;
    int _zoomMaxi;
    int _zoomMini;
    int _initValue;
    int _factorValue;
    QList<int> _listZooms;
    QRegExp _regExpCb;
    QRegExpValidator * _validator;
};

} // namespace Hnv
#endif // ZOOMSLIDERWIDGET_H
