/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYDETAILSWIDGET_H
#define TOPOLOGYDETAILSWIDGET_H

// Qt headers
#include <QWidget>

namespace Ui {
class TopologyDetailsWidget;
} // namespace Ui

namespace HnsClient {
class TopologyEntry;
class Topology;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
* TopologyDetailsWidget
*******************************************************************************/
class TopologyDetailsWidget : public QWidget
{
    Q_OBJECT
public:
    explicit TopologyDetailsWidget(QWidget *parent = 0);
    ~TopologyDetailsWidget();

    void setItem(HnsClient::TopologyEntry *topologyEntry, HnsClient::Topology *topology);
    void setDefaultsDetails();

private:
    QPixmap _getScreenshot(HnsClient::TopologyEntry *entry);
    Ui::TopologyDetailsWidget *_ui;
};

} // namespace Hnv
#endif // TOPOLOGYDETAILSWIDGET_H
