/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYEXPORTWIDGET_H
#define TOPOLOGYEXPORTWIDGET_H

// Generated hynesim headers
#include "common/archivedescriptor.h"
#include "libhnsclient/entry.h"

// Qt headers
#include <QWidget>

namespace Ui {
class TopologyExportWidget;
} // namespace Ui

namespace Hnv {
class TopologyCatalogModel;
class EntitiesModel;
class TopologyItem;
class CheckBoxDelegate;
class TopologyAdministrator;

class TopologyExportWidget : public QWidget
{
    Q_OBJECT

public:
    explicit TopologyExportWidget(TopologyAdministrator *administrator, QWidget *parent = 0);
    ~TopologyExportWidget();
    void setTopology(qlonglong id);

protected:
    qlonglong _setControls(HnsClient::TopologyEntry *entry);

private slots:
    void on_exportPushButton_clicked();
    void _exportEnded(bool success);
    void _topologyEntryUpdatedSlot(HnsClient::TopologyEntry *entry);

    void on_compressAllPushButton_clicked();

private:
    Hns::ArchiveDescriptorPtr _createArchiveDescriptor(HnsClient::TopologyEntry *topologyEntry);

    Ui::TopologyExportWidget *ui;
    TopologyAdministrator *_administrator;
    EntitiesModel *_entitiesModel;
    qlonglong _currentId;
    CheckBoxDelegate *_delegate;
    bool _compressAllButtonState;
};

} // namespace Hnv
#endif // TOPOLOGYEXPORTWIDGET_H
