/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "dynamipsrouterloadidle.h"
#include "ui_dynamipsrouterloadidle.h"

// Qt headers
#include <QCloseEvent>

namespace Hnv {

/*******************************************************************************
* DynamipsRouterLoadIdle
*******************************************************************************/
DynamipsRouterLoadIdle::DynamipsRouterLoadIdle(const QString & label, QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::DynamipsRouterLoadIdle)
{
    ui->setupUi(this);
    ui->label->setText(label);
    ui->buttonBox->hide();
}

DynamipsRouterLoadIdle::~DynamipsRouterLoadIdle()
{
    delete ui;
}

void DynamipsRouterLoadIdle::setEnabledErrorMode(const QString & label){
    ui->label->setText(label);
    ui->progressBar->hide();
    ui->buttonBox->show();
}

void DynamipsRouterLoadIdle::closeEvent(QCloseEvent *event)
{
    if(!ui->progressBar->isHidden()) event->ignore();
}

} // namespace Hnv
