// ****************************************************************************
//
// Copyright (C) 2003-2014 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ENTITYPLUGGINGDIALOG_H
#define ENTITYPLUGGINGDIALOG_H

// Generated hynesim headers
#include "common/entity.h"

// Qt headers
#include <QDialog>
#include <QMap>
#include <QHash>

namespace Ui {
class EntityPluggingDialog;
} // namespace Ui

namespace HnsClient {
class Entity;
} // namespace HnsClient

namespace Hnv {
class EntityPluggingWidget;

class EntityPluggingDialog : public QDialog
{
    Q_OBJECT

public:
    explicit EntityPluggingDialog(HnsClient::Entity *entity, QMap<qlonglong, QString> colorMap, QPixmap screenshot, QWidget *parent = 0);
    ~EntityPluggingDialog();
    QMap<qlonglong, Hns::Plug> plugMap() const;
    bool isTrullyRejected();
public slots:
    virtual void reject();

private slots:
    void _onAcceptedSlot();

private:
    Ui::EntityPluggingDialog *ui;
    HnsClient::Entity *_entity;
    QHash<qlonglong, EntityPluggingWidget *> _pluggingWidgetsHash; //id is wireId
    QMap<qlonglong, Hns::Plug> _plugMap; //wireId, entityPlug
    bool _trullyRejected;
};

} // namespace Hnv
#endif // ENTITYPLUGGINGDIALOG_H
