// ****************************************************************************
//
// Copyright (C) 2003-2014 DIATEAM. All rights reserved.
//
// This file is part of Hynesim.
//
// Hynesim is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2
// as published by the Free Software Foundation.
//
// Hynesim is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// ****************************************************************************

#ifndef ENTITYPLUGGINGWIDGET_H
#define ENTITYPLUGGINGWIDGET_H

// Qt headers
#include <QWidget>

namespace Ui {
class EntityPluggingWidget;
} // namespace Ui

namespace Hnv {

class EntityPluggingWidget : public QWidget
{
    Q_OBJECT

public:
    explicit EntityPluggingWidget(QMap<QString, QPair<QString, int> > map, qlonglong wireId, const QString &color, QWidget *parent = 0);
    ~EntityPluggingWidget();
    int selectedPlugId() const;
    bool isSelected() const;

private slots:
    void on_checkBox_clicked(bool checked);

private:
    Ui::EntityPluggingWidget *ui;
    qlonglong _wireId;
};

} // namespace Hnv

#endif // ENTITYPLUGGINGWIDGET_H
