/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYSCENE_H
#define TOPOLOGYSCENE_H

// Qt headers
#include <QGraphicsScene>
#include <QHash>

class QGraphicsSvgItem;
class QGraphicsLineItem;

namespace HnsClient {
class Job;
} // namespace HnsClient

namespace Hnv {

class TopologyView;

/*******************************************************************************
* TopologyScene
*******************************************************************************/
class TopologyScene : public QGraphicsScene
{
    Q_OBJECT
public:
    TopologyScene(qreal x, qreal y, qreal width, qreal height, TopologyView *view = 0);
    void startWireLine(QPointF scenePos);
    void extendWireLineTo(QPointF scenePos);
    void endWireLine();
    QGraphicsLineItem *currentLine();
    void displayCloneGraphic(qlonglong entryID, int cloneJobID, QPoint position);

public slots:
//    void updateSceneRect(QList<QRectF> list = QList<QRectF>());

protected slots:
    void _getJobSlot(HnsClient::Job *job);
    void _cloneJobProgressChangedSlot(int jobId, double progress);
    void _cloneJobCancelledSlot(int jobId);

protected:
    QGraphicsLineItem *_currentLine;
    TopologyView *_view;
    QHash<int, QGraphicsSvgItem *> _cloneGraphics;
    QHash<int, QGraphicsTextItem *> _cloneText;
    QHash<int, QPair<QPoint, qlonglong> > _clonePosition;
    QHash<int, HnsClient::Job *> _cloneJobs;
    int _minimumWireLength;
};

} // namespace Hnv

#endif // TOPOLOGYSCENE_H
