/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "wifiapconnectedpeerswidget.h"
#include "ui_wifiapconnectedpeerswidget.h"

// hynesim hnsclient headers
#include <libhnsclient/entity.h>

namespace Hnv {

WifiAPConnectedPeersWidget::WifiAPConnectedPeersWidget(HnsClient::WifiAPEntity * entity,QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::WifiAPConnectedPeersWidget)
{
    ui->setupUi(this);
    this->setWindowTitle(tr("Connected Peers"));
    _connectedPeers = entity->connectedPeers();
    _model.setStringList(_connectedPeers);
    ui->listView->setModel(&_model);
    ui->labelSsid->setText(tr("SSID: %1").arg(entity->getSSID()));

    connect(entity, SIGNAL(peerJoined(QString)), this, SLOT(_peerJoinedSlot(QString)));
    connect(entity, SIGNAL(peerLeft(QString)), this, SLOT(_peerLeftSlot(QString)));
}

WifiAPConnectedPeersWidget::~WifiAPConnectedPeersWidget()
{
    delete ui;
}

void WifiAPConnectedPeersWidget::_peerJoinedSlot(QString s)
{
    _connectedPeers.append(s);
    _model.setStringList(_connectedPeers);
}

void WifiAPConnectedPeersWidget::_peerLeftSlot(QString s)
{
    _connectedPeers.removeAll(s);
    _model.setStringList(_connectedPeers);
}

} // namespace Hnv
