/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIFIAPCONNECTEDPEERSWIDGET_H
#define WIFIAPCONNECTEDPEERSWIDGET_H

// Qt headers
#include <QDialog>
#include <QStringListModel>

namespace Ui {
class WifiAPConnectedPeersWidget;
} // namespace Ui

namespace HnsClient {
class WifiAPEntity;
} // namespace HnsClient

namespace Hnv {

class WifiAPConnectedPeersWidget : public QDialog
{
    Q_OBJECT

public:
    explicit WifiAPConnectedPeersWidget(HnsClient::WifiAPEntity * entity,QWidget *parent = 0);
    ~WifiAPConnectedPeersWidget();

private:
    Ui::WifiAPConnectedPeersWidget *ui;
    QStringListModel _model;
    QStringList _connectedPeers;

private slots:
    void _peerJoinedSlot(QString);
    void _peerLeftSlot(QString);

};

} // namespace Hnv
#endif // WIFIAPCONNECTEDPEERSWIDGET_H
