#include "wireaddtocatalogdialog.h"
#include "ui_wireaddtocatalogdialog.h"

#include "hyneviewsession.h"

#include "libhnsclient/entry.h"

namespace Hnv {

WireAddToCatalogDialog::WireAddToCatalogDialog(HnsClient::WireEntry *entry, QWidget *parent)
    : QDialog(parent)
    , ui(new Ui::WireAddToCatalogDialog)
    , _entry(entry)
{
    ui->setupUi(this);

    HyneviewSession * session = HyneviewSession::instance();

    QMapIterator<QString, QString> iterator(session->entityCatalogStorageMap());

    while (iterator.hasNext()) {
         iterator.next();
         QString storageName = iterator.value();
         ui->cbPath->addItem(storageName, QVariant(storageName + ":/"));
     }

     if(ui->cbPath->count() <= 1)
         ui->cbPath->setDisabled(true);

     ui->nameEdit->setText(_entry->getShortName());
}

WireAddToCatalogDialog::~WireAddToCatalogDialog()
{
    delete ui;
}

void WireAddToCatalogDialog::on_buttonBox_accepted()
{
    _entry->entityEntry()->path = ui->cbPath->currentText().toStdString() +":";
    _entry->setShortName(ui->nameEdit->text());
    accept();
}

} //namespace Hnv
