/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIREPLUGSELECTOR_H
#define WIREPLUGSELECTOR_H

// Qt headers
#include <QDialog>

namespace Ui {
class WirePlugSelector;
} // namespace Ui

namespace HnsClient {
class Entity;
} // namespace HnsClient

namespace Hnv {

/*******************************************************************************
* WirePlugSelector
*******************************************************************************/
class WirePlugSelector : public QDialog
{
    Q_OBJECT

public:
    explicit WirePlugSelector(HnsClient::Entity * from, HnsClient::Entity *to, int &fromPort, int &toPort, QWidget *parent = 0);
    ~WirePlugSelector();

private slots:
    void on_buttonBox_accepted();
    void on_buttonBox_rejected();

private:
    Ui::WirePlugSelector *ui;
    HnsClient::Entity * _fromEntity;
    HnsClient::Entity * _toEntity;
    int &_fromSelectedPort;
    int &_toSelectedPort;
};

} // namespace Hnv
#endif // WIREPLUGSELECTOR_H
