/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIREPLUGTOENTITYDIALOG_H
#define WIREPLUGTOENTITYDIALOG_H

// Qt headers
#include <QDialog>

namespace HnsClient {
class GenericEntity;
} // namespace HnsClient

namespace Ui {
class WirePlugToEntityDialog;
} // namespace Ui

namespace Hnv {

class WirePlugToEntityDialog : public QDialog
{
    Q_OBJECT

public:
    explicit WirePlugToEntityDialog(HnsClient::GenericEntity *entity, QWidget *parent = 0);
    ~WirePlugToEntityDialog();
    int entityPort();
    bool isTrullyRejected();
public slots:
    virtual void reject();

private slots:
    void _onAcceptedSlot();
    void _onRejectedSlot();

private:
    Ui::WirePlugToEntityDialog *ui;
    HnsClient::GenericEntity *_entity;
    int _entityPort;
    bool _trullyRejected;
};

} // namespace Hnv
#endif // WIREPLUGTOENTITYDIALOG_H
