/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYCONTENTWIDGET_H
#define TOPOLOGYCONTENTWIDGET_H

// Project headers
#include "sidebar.h"

class QWidget;

namespace HnsClient {
class GenericEntity;
} // namespace HnsClient

namespace Hnv {

class SimulationModeWidget;
class TopologyWidget;
class TopologyContentModel;

class TopologyContentWidget : public SideBarTreeWidget
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit TopologyContentWidget(QWidget *parent = 0);
    ~TopologyContentWidget();
    static QString title();
    static QString sideBarId();

protected slots:
    void _topologyActivatedSlot(QVariant topologyUUID);
    void _entitySelectionChanged(QList<HnsClient::GenericEntity *> entityList);

protected:
    virtual void _indexClicked(const QModelIndex &index);
    virtual void _indexDoubleClicked(const QModelIndex &index);
    virtual void _contextMenuRequested(const QModelIndex &index, const QPoint &position);

    void _setContentModel(TopologyContentModel *contentModel);

private slots:
    void _actionPropertiesTriggeredSlot();
    void _actionDeleteTriggeredSlot();

private:
    SimulationModeWidget *_simulationModeWidget;
    TopologyWidget *_topologyWidget;
    QMenu *_menu;
    QAction *_actionDelete;
    QAction *_actionProperties;
    TopologyContentModel * _topologyContentModel;
};

} // namespace Hnv

#endif // TOPOLOGYCONTENTWIDGET_H
