/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYSAVEALLDIALOG_H
#define TOPOLOGYSAVEALLDIALOG_H

// Qt headers
#include <QDialog>
#include <QList>
#include <QHash>

namespace Ui {
class TopologySaveAllDialog;
} // namespace Ui

namespace Hnv {

class TopologyViewArea;

class TopologySaveAllDialog : public QDialog
{
    Q_OBJECT
public:
    explicit TopologySaveAllDialog(QHash<QString,TopologyViewArea*> hashArea,QWidget *parent = 0);
    ~TopologySaveAllDialog();
    QList<QString> getTopologyUUIDToSave();

private slots:
    void on_buttonBox_accepted();
    void on_pbSelectAll_clicked();
    void on_pbDeselectAll_clicked();

private:
    Ui::TopologySaveAllDialog *ui;
    QHash<QString,TopologyViewArea*> _hashArea;
    QList<QString> _topologyUUIDToSave;
};

} // namespace Hnv
#endif // TOPOLOGYSAVEALLDIALOG_H
