/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYSAVEDIALOG_H
#define TOPOLOGYSAVEDIALOG_H

// hynesim hnsclient headers
#include <libhnsclient/common.h>

// Qt headers
#include <QDialog>

namespace HnsClient {
class TopologyEntry;
} // namespace HnsClient

namespace Ui {
class TopologySaveDialog;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* TopologySaveDialog
*******************************************************************************/
class TopologySaveDialog : public QDialog
{
    Q_OBJECT
public:
    explicit TopologySaveDialog(HnsClient::TopologyEntry *topologyEntry, QWidget *parent = 0);
    ~TopologySaveDialog();

private:
    Ui::TopologySaveDialog *ui;
    HnsClient::TopologyEntry *_topologyEntry;

protected:
    void _displayPath(QString path);
    HnsClient::ValidationResult _validateShortName();
    HnsClient::ValidationResult _validatePath();
    void _computeValidationState(HnsClient::ValidationResult result, bool &isModified, bool &isInvalid);

private slots:
    void on_buttonBox_accepted();
};

} // namespace Hnv
#endif // TOPOLOGYSAVEDIALOG_H
