/******************************************************************************
**
** Copyright (C) 2003-2017 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef USBMANAGERDIALOG_H
#define USBMANAGERDIALOG_H

// hynesim hnsclient headers
#include <libhnsclient/entity.h>


#include <QDialog>

class QAbstractButton;

namespace Ui {
class UsbManagerDialog;
}

namespace RemoteAccess {
class UsbManager;
}

namespace Hnv {

class UsbManagerDialog : public QDialog
{
    Q_OBJECT
public:
    enum {
        COLUMN_REDIRECT,
        COLUMN_MANUFACTURER,
        COLUMN_PRODUCT,
        COLUMN_DESCRIPTOR,
        COLUMN_BUS,
        COLUMN_ADDRESS,
        COLUMN_CONNECTED,
        COLUMN_ANOTHER_SESSION,
        COLUMN_COUNT //always last
    };
    explicit UsbManagerDialog(HnsClient::DomainEntity *entity, QWidget *parent = 0);
    ~UsbManagerDialog();
    void apply();

public slots:
    void refresh();

private slots:
    void on_buttonBox_clicked(QAbstractButton *button);

private:
    Ui::UsbManagerDialog *ui;
    HnsClient::DomainEntity *_entity;
    RemoteAccess::UsbManager *_usbManager;
    QList<int> _alreadyConnectedDevices;
};

} // namespace Hnv
#endif // USBMANAGERDIALOG_H
