/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// Project headers
#include "usermanagermodewidget.h"
#include "usermanagertabs.h"
#include "ressources.h"

// Qt headers
#include <QAction>

namespace Hnv {

/*******************************************************************************
* UserManagerModeWidget
*******************************************************************************/
UserManagerModeWidget::UserManagerModeWidget(QWidget *parent)
    : ModeWidget(parent)
{
    UserManagerTabs *w = new UserManagerTabs(this);
    _initDisplayArea(w);
}

bool UserManagerModeWidget::hasSideBar()
{
    return false;
}

bool UserManagerModeWidget::hasRightSideBar()
{
    return false;
}

/*******************************************************************************
* UserManagerModeWidget - Protected
*/
void UserManagerModeWidget::_initModeAction()
{
    _modeAction = new QAction(QIcon(Ressources::themedPath(Constants::ICON_GROUP)), tr("User manager"), this);
}

} // namespace Hnv
