/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef USERCLONEDIALOG_H
#define USERCLONEDIALOG_H

// Qt headers
#include <QDialog>

class QLabel;

namespace Ui {
class UserCloneDialog;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* UserCloneDialog
*/

class UserCloneDialog : public QDialog
{
    Q_OBJECT

public:
    explicit UserCloneDialog(QString userName, int &cloneCount, QString &password, QWidget *parent = 0);
    ~UserCloneDialog();

private:
    Ui::UserCloneDialog *ui;
    int &_cloneCount;
    QString &_password;

    bool isNotEmpty(QLabel *targetLabel, QString &text);
    void setLabelValidationStyle(QLabel * targetLabel, bool isValid);

private slots:
    void on_buttonBox_accepted();
    void on_toolButton_clicked();
    void on_lePassword_textEdited(QString );
    void on_leConfirmPassword_textEdited(QString );
};

} // namespace Hnv
#endif // USERCLONEDIALOG_H
