/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef USEREDITDIALOG_H
#define USEREDITDIALOG_H

// Generated hynesim headers
#include "common/usermanager.h"

// Qt headers
#include <QString>
#include <QHash>
#include <QDialog>

class QModelIndex;
class QLabel;

namespace Ui {
class UserEditDialog;
} // namespace Ui

namespace Hnv {

/*******************************************************************************
* UserEditDialog
*/

class UserEditDialog : public QDialog
{
    Q_OBJECT

public:
    explicit UserEditDialog(Hns::UserPtr &user, QString &password, QHash<qlonglong, QString> groupNameHash, QWidget *parent = 0);
    ~UserEditDialog();

private:
    Hns::UserPtr &_userData;
    QString &_password;
    QHash<qlonglong, QString> _groupNameHash;
    QString _originalLogin;
    Ui::UserEditDialog *ui;

    bool isNotEmpty(QLabel *targetLabel, QString &text);
    void setLabelValidationStyle(QLabel * targetLabel, bool isValid);

private slots:
    void on_removeAll_clicked();
    void on_removeSelected_clicked();
    void on_allAll_clicked();
    void on_addSelected_clicked();
    void on_buttonBox_accepted();
    void on_action_Generate_password_triggered();
    void on_lePassword_textEdited(QString );
    void on_leConfirmPassword_textEdited(QString );
    void on_listAvailableGroups_doubleClicked(const QModelIndex &index);
    void on_listGroups_doubleClicked(const QModelIndex &index);
    void on_leUsername_textEdited(const QString &text);

};

} // namespace Hnv

#endif // USEREDITDIALOG_H
