/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WELCOMEMODEWIDGET_H
#define WELCOMEMODEWIDGET_H

// Project headers
#include "modebrowserwidget.h"

namespace Hnv {

class WelcomeScreenWidget;

class WelcomeModeWidget : public ModeWidget
{
    Q_OBJECT

public:
    explicit WelcomeModeWidget(QWidget *parent = 0);
    ~WelcomeModeWidget();

    virtual bool hasSideBar();
    virtual bool hasRightSideBar();

signals:
    void connectTriggered();
    void quickConnectTriggered();
    void newSessionTriggered();
    void openSessionTriggered();

public slots:
    void connectedSlot(HyneviewSession* session);
    void disconnectedSlot();
    void enableQuickConnect(bool);

protected:
    void _initModeAction();

private:
    WelcomeScreenWidget * _screen;

};

} // namespace Hnv
#endif // WELCOMEMODEWIDGET_H
