/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WELCOMESCREENWIDGET_H
#define WELCOMESCREENWIDGET_H

// Qt headers
#include <QWidget>

class QPushButton;

namespace Ui {
class WelcomeScreenWidget;
} // namespace Ui

namespace Hnv {

class HyneviewSession;

class WelcomeScreenWidget : public QWidget
{
    Q_OBJECT
public:
    explicit WelcomeScreenWidget(QWidget *parent = 0);
    ~WelcomeScreenWidget();
    void setConnected(bool connected);
    void enableQuickConnect(bool);

signals:
    void connectTriggered();
    void quickConnectTriggered();
    void newSessionTriggered();
    void openSessionTriggered();

protected slots:
    void _aboutSlot();
    void _simulationSlot();

private:
    Ui::WelcomeScreenWidget * _ui;
    bool _enableQuickConnect;
};

} // namespace Hnv
#endif // WELCOMESCREENWIDGET_H
