/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim hnsclient headers
#include "libhnsclient/private/common_p.h"

namespace HnsClient {

/*******************************************************************************
* Callback_ProxySession_getInfo
*******************************************************************************/
Callback_ProxySession_getInfo::Callback_ProxySession_getInfo()
    : QObject()
    , ::IceUtil::Shared()
{
}

Callback_ProxySession_getInfo::~Callback_ProxySession_getInfo()
{
}

void Callback_ProxySession_getInfo::_success(const Diamesh::SessionInfo &information)
{
    emit succeeded(information);
}

void Callback_ProxySession_getInfo::_failure(const Ice::Exception &e)
{
    emit failed(QSharedPointer<Ice::Exception>(e.ice_clone()));
}

} // namespace HnsClient
