/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_DYNAMIPSROUTERDB_H
#define HNSCLIENT_DYNAMIPSROUTERDB_H

// Generated hynesim headers
#include "common/dynamipsrouterentry.h"
#include "common/proxies_dynamipsrouterdb.h"

// Qt headers
#include <QObject>
#include <QString>
#include <QMap>

namespace HnsClient {

class DynamipsRouterDBPrivate;

/*******************************************************************************
* DynamipsRouterDB
*******************************************************************************/
class DynamipsRouterDB : public QObject
{
    Q_OBJECT
    Q_DECLARE_PRIVATE(DynamipsRouterDB)
public:
    ~DynamipsRouterDB();
    // Local methods, access to data stored in cache
    QMap<QString, Hns::DataDynamipsRouter > getDynamipsRouterMap() const;
    QMap<QString, Hns::DynamipsRouterModule > getDynamipsModuleMap() const;

signals:
    void loaded();

protected:
    explicit DynamipsRouterDB(QObject *parent = 0);
    void _load(Hns::DynamipsRouterDBQPrx qprx);
    void _callEnded();
    void _checkLoading();
    void _init();

    DynamipsRouterDBPrivate * const d_ptr;

protected slots:
    void _loadDynamipsRouterMapSlot(::Hns::DataDynamipsRouterMap routerMap);
    void _loadDynamipsModuleMapSlot(::Hns::DataDynamipsRouterModuleMap moduleMap);

private:
    friend class Session;
};

} // namespace HnsClient

#endif //HNSCLIENT_DYNAMIPSROUTERDB_H
