/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_HSETMANAGER_H
#define HNSCLIENT_HSETMANAGER_H

// diamesh headers
#include <diamesh/proxies_hsetmanager.h>

// Qt headers
#include <QObject>

namespace HnsClient {

class HSetManagerPrivate;
/*******************************************************************************
* HSetManager
*******************************************************************************/
class HSetManager : public QObject
{
    Q_OBJECT
    Q_DECLARE_PRIVATE(HSetManager)
public:
    ~HSetManager();

    Diamesh::HierarchicalSet getHSetById(qlonglong hSetId) const;

    static Diamesh::HierarchicalSet invalidHSet();

signals:
    void loaded();

protected:
    explicit HSetManager(QObject *parent = 0);
    void _load(Diamesh::HSetManagerQPrx qprx);
    void _callEnded();
    void _checkLoading();
    void _init();

protected slots:
    void _loadGetHSetsSlot(::Diamesh::HierarchicalSetList list);

    void _hSetAddedSlot(Ice::Long hSetId);
    void _hSetChangedSlot(Ice::Long hSetId);
    void _hSetRemovedSlot(Ice::Long hSetId);

private:
    friend class Session;
    HSetManagerPrivate * const d_ptr;
};

} // namespace HnsClient

#endif //HNSCLIENT_HSETMANAGER_H
