/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_ACLMANAGER_P_H
#define HNSCLIENT_ACLMANAGER_P_H

// diamesh headers
#include <diamesh/proxies_accessrights.h>
#include <diamesh/accessrightshelper.h>

// Qt headers
#include <QObject>
#include <QString>
#include <QHash>

namespace HnsClient {

/*******************************************************************************
* GetACLsForTagetCookie
*******************************************************************************/
class GetACLsForTagetCookie : public QObject
{
    Q_OBJECT
public:
    explicit GetACLsForTagetCookie(QObject *receiver, const char *slot);
    ~GetACLsForTagetCookie();
    void emitCompleted(const Diamesh::ACLList &aclList);

signals:
    void completed(Diamesh::ACLList aclList);
};

/*******************************************************************************
* ACLManagerPrivate
*******************************************************************************/
class ACLManagerPrivate
{
public:

    explicit ACLManagerPrivate();
    virtual ~ACLManagerPrivate();

    Diamesh::ACLManagerQPrx aclManagerQPrx;
    int remoteCallCount;
    Diamesh::AccessRightsHelper *helper;
    Diamesh::AccessRightList rightList;
    Diamesh::StringStringMap typeMap;
    QHash<QString, QString> entryTargetToPrefix;
};

} // namespace HnsClient

#endif //HNSCLIENT_ACLMANAGER_P_H
