/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_CATALOG_P_H
#define HNSCLIENT_CATALOG_P_H

#include "common/catalog.h"

// ZeroC Ice headers
#include <Ice/Config.h>

// Qt headers
#include <QObject>
#include <QHash>

namespace HnsClient {

/*******************************************************************************
* CatalogPrivate
*******************************************************************************/
class CatalogPrivate : QObject
{
    Q_OBJECT
public:
    CatalogPrivate();
    virtual ~CatalogPrivate();
    
    QHash<Ice::Long, Hns::LockType> lockedEntries;
    int remoteCallCount;
};


/*******************************************************************************
* GetACLsForEntryCookie
*******************************************************************************/
class GetACLsForEntryCookie : public QObject
{
    Q_OBJECT
public:
    GetACLsForEntryCookie(qlonglong entryId);
    ~GetACLsForEntryCookie();
    qlonglong getEntryId() const;
private:
    qlonglong _entryId;
};


}//namespace HnsClient

#endif // HNSCLIENT_CATALOG_P_H
