/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef COMMON_P_H
#define COMMON_P_H

// ZeroC Ice headers
#include <Ice/Exception.h>
#include <IceUtil/Shared.h>

// diamesh headers
#include <diamesh/proxies_sessionManager.h>

// Qt headers
#include <QObject>

namespace HnsClient {

/*******************************************************************************
* Callback_ProxySession_getInfo
*******************************************************************************/
class Callback_ProxySession_getInfo : public QObject, public ::IceUtil::Shared
{
    Q_OBJECT
public:
    explicit Callback_ProxySession_getInfo();
    ~Callback_ProxySession_getInfo();
    void _success(const ::Diamesh::SessionInfo &information);
    void _failure(const ::Ice::Exception &e);
signals:
    void succeeded(::Diamesh::SessionInfo);
    void failed(QSharedPointer<Ice::Exception>);
};

typedef IceUtil::Handle<Callback_ProxySession_getInfo> Callback_ProxySession_getInfoPtr;

} // namespace HnsClient
#endif // COMMON_P_H
