/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_ENTITYINFO_P_H
#define HNSCLIENT_ENTITYINFO_P_H

// Generated hynesim headers
#include "common/proxies_entityinfo.h"
#include "common/entity.h"

// Qt headers
#include <QList>

namespace HnsClient {

class EntityInfo;

/*******************************************************************************
* EntityInfoPrivate
*******************************************************************************/
class EntityInfoPrivate
{
public:
    explicit EntityInfoPrivate();
    virtual ~EntityInfoPrivate();

    Hns::EntityInfoQPrx infoQtProxy;
    qlonglong entityId;
    qlonglong entryId;
    Hns::EntityInfoData data;
    Hns::Status status;
    qlonglong statusIndex;
    int remoteCallCount;
};


/*******************************************************************************
* EntityInfoListPrivate
*******************************************************************************/
class EntityInfoListPrivate
{
public:
    explicit EntityInfoListPrivate();
    virtual ~EntityInfoListPrivate();

    QList<EntityInfo *> infoList;
};

} // namespace HnsClient

#endif //HNSCLIENT_ENTITYINFO_P_H
