/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_JOBMANAGER_P_H
#define HNSCLIENT_JOBMANAGER_P_H

// Generated hynesim headers
#include "common/proxies_job.h"
#include "common/proxies_jobmanager.h"

// Qt headers
#include <QObject>
#include <QString>

namespace HnsClient {

class Job;
class JobManager;

/*******************************************************************************
* JobPrivate
*******************************************************************************/
class JobPrivate
{
public:
    explicit JobPrivate();
    virtual ~JobPrivate();

    Hns::JobQPrx jobQPrx;
    int jobId;
    bool isRunning;
    QString errorMessage;
    double progress;
    int remoteCallCount;
};


/*******************************************************************************
* JobManagerPrivate
*******************************************************************************/
class JobManagerPrivate
{
public:
    explicit JobManagerPrivate();
    virtual ~JobManagerPrivate();

    Hns::JobManagerQPrx jobManagerQPrx;
};


/*******************************************************************************
* GetJobCookie
*******************************************************************************/
class GetJobCookie : public QObject
{
    Q_OBJECT
public:
    explicit GetJobCookie(int jobId, QObject *receiver, const char *slot, QObject *parent = 0);
    ~GetJobCookie();
    void setJobQPrx(Hns::JobQPrx qprx);

signals:
    void completed(HnsClient::Job *job);

private slots:
    void _loadedSlot();

private:
    int _jobId;
    Job *_job;
};

} // namespace HnsClient

#endif //HNSCLIENT_JOBMANAGER_P_H
