/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSCLIENT_MACADDRESSMANAGER_P_H
#define HNSCLIENT_MACADDRESSMANAGER_P_H

// Generated hynesim headers
#include "common/proxies_macaddressmanager.h"

// Qt headers
#include <QObject>
#include <QStringList>

namespace HnsClient {

/*******************************************************************************
* MacAddressManagerPrivate
*******************************************************************************/
class MacAddressManagerPrivate
{
public:
    explicit MacAddressManagerPrivate();
    virtual ~MacAddressManagerPrivate();

    Hns::MacAddressManagerQPrx macAdressManagerQPrx;
    QStringList *networkCardsVendorList;
};


/*******************************************************************************
* GenerateRandomAddressCookie
*******************************************************************************/
class GenerateRandomAddressCookie : public QObject
{
    Q_OBJECT
public:
    explicit GenerateRandomAddressCookie(QObject *receiver, const char *slot);
    ~GenerateRandomAddressCookie();
    void emitCompleted(QString result);
signals:
    void completed(QString result);
};


/*******************************************************************************
* GetVendorFromPrefixCookie
*******************************************************************************/
class GetVendorFromPrefixCookie : public QObject
{
    Q_OBJECT
public:
    explicit GetVendorFromPrefixCookie(QObject *receiver, const char *slot);
    ~GetVendorFromPrefixCookie();
    void emitCompleted(QString result);
signals:
    void completed(QString result);
};


/*******************************************************************************
* IsUsedCookie
*******************************************************************************/
class IsUsedCookie : public QObject
{
    Q_OBJECT
public:
    explicit IsUsedCookie(QObject *receiver, const char *slot);
    ~IsUsedCookie();
    void emitCompleted(bool result);
signals:
    void completed(bool result);
};

} // namespace HnsClient

#endif //HNSCLIENT_MACADDRESSMANAGER_P_H
