/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PRIVATESESSIONACCESSOR_H
#define PRIVATESESSIONACCESSOR_H

// ZeroC Ice headers
#include <Ice/ObjectAdapter.h>
#include <Ice/Communicator.h>

// Qt headers
#include <QObject>

namespace HnsClient {

class Session;

/*******************************************************************************
* PrivateSessionAccessor
*******************************************************************************/
class PrivateSessionAccessor : public QObject
{
    Q_OBJECT
public:
    static PrivateSessionAccessor *instance();
    Session *session();
    const Ice::ObjectAdapterPtr &adapter();
    const Ice::CommunicatorPtr &communicator();
signals:
    
public slots:
    
protected:
    explicit PrivateSessionAccessor(Session *session, QObject *parent = 0);
private:
    Session *_session;
    static PrivateSessionAccessor *_singleton;
    friend class Session;
};

} // namespace HnsClient

#endif // PRIVATESESSIONACCESSOR_H
