/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim hnsclient headers
#include "libhnsclient/private/privatesessionaccessor.h"
#include "libhnsclient/session.h"

// diamesh headers
#include <diamesh/sessionhelper.h>

// ZeroC Ice headers
#include <Ice/ObjectAdapter.h>
#include <Ice/Communicator.h>

namespace HnsClient {

/*******************************************************************************
* PrivateSessionAccessor
*******************************************************************************/
PrivateSessionAccessor * PrivateSessionAccessor::_singleton = 0;

PrivateSessionAccessor::PrivateSessionAccessor(Session *session, QObject *parent) :
    QObject(parent)
    , _session(session)
{
    _singleton = this;;
}

Session *PrivateSessionAccessor::session()
{
    return _session;
}

const Ice::ObjectAdapterPtr &PrivateSessionAccessor::adapter()
{
    return _session->sessionHelper()->adapter();
}

const Ice::CommunicatorPtr &PrivateSessionAccessor::communicator()
{
    return _session->sessionHelper()->communicator();
}

PrivateSessionAccessor *PrivateSessionAccessor::instance()
{
    return _singleton;
}

} // namespace HnsClient
