/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim server headers
#include "scriptrunner.h"

namespace HnsServer {

ScriptRunner::ScriptRunner(QObject *parent)
    : ProcessRunner(parent)
    , _scriptsDirectory("./")
{
}

ScriptRunner::~ScriptRunner()
{
}

void ScriptRunner::setScriptDirectory(const QString &scriptDirectory)
{
    _scriptsDirectory = scriptDirectory;
    if (!_scriptsDirectory.endsWith("/"))
        _scriptsDirectory.append("/");
}

void ScriptRunner::_beforeStart()
{
    _program = QString("%1%2").arg(_scriptsDirectory).arg(_program);
}

} // namespace HnsServer
