/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef STORAGEMANAGER_H
#define STORAGEMANAGER_H

// Qt headers
#include <QObject>
#include <QHash>
#include <QReadWriteLock>

namespace HnsServer {

class StorageManager : public QObject
{
    Q_OBJECT

public:
    explicit StorageManager(const QString &settingsFileName, QObject *parent = 0);
    QString getFullPathFromMixed(const QString &storageType,const QString &mixedPath, const QString &uuid = QString());
    QString _settingsFileName;
    QHash<QString,QHash<QString,QString> > _typeStorageHash;
    QReadWriteLock _storageLock;

private:
    bool _loadStorages();
};

} // namespace HnsServer

#endif // STORAGEMANAGER_H
