/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef CAPTUREJOBI_H
#define CAPTUREJOBI_H

// Generated hynesim headers
#include "qiceobj_capturejob.h"
#include "common/capturejoboptions.h"
#include "common/nodecapturejob.h"
#include "common/proxies_job.h"

// Qt headers
#include <QReadWriteLock>

namespace Hns {

class CaptureJobI : public _Hns_CaptureJob
{
    Q_OBJECT
public:
    ~CaptureJobI();
    CaptureJobI();

    bool cancel(const ::Ice::Current &current);
    HnsNode::CaptureJobPrx getCaptureJobPrx();
    void setCaptureJobPrx(HnsNode::CaptureJobPrx captureJobPrx);
    PcapInfo getPcapInfo(const ::Ice::Current &current = ::Ice::Current());

protected:
    void _run();
    bool setOptions(const ::Hns::CaptureJobOptions &jobOptions, const ::Ice::Current &current);

protected slots:
    void _updateNodeProgress(Ice::Int jobId, Ice::Double progress);

private:
    HnsNode::CaptureJobPrx _nodeJobProxy;
    JobQPrx _nodeJobProxyQtice;
    QReadWriteLock _pcapInfoLock;
    PcapInfo _pcapInfo;
};

} // namespace Hns

#endif // CAPTUREJOBI_H
