/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_ENTITY_CATALOG_DB_STORAGE_H
#define HNS_ENTITY_CATALOG_DB_STORAGE_H

// hynesim master headers
#include "catalogdbstorage.h"

// Generated hynesim headers
#include "common/entry.h"
#include "common/folder.h"

// Qt headers
#include <QList>

namespace Hns {

class EntityCatalogDBStorage : public CatalogDBStorage
{
    Q_OBJECT
public:
    EntityCatalogDBStorage(const QString &settingsFileName);
    ~EntityCatalogDBStorage();

    bool addFolderEntry(::Ice::Long folderId, ::Ice::Long entryId);
    bool removeFolderEntry(::Ice::Long folderId, ::Ice::Long entryId);

    QList<FolderPtr> getFolders();

private:
    Diamesh::LongList _entryFolderList(qulonglong entryId);
};

} // namespace Hns

#endif // HNS_ENTITY_CATALOG_DB_STORAGE_H
