/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_CLONE_JOB_DYNAMIPS_ROUTER_H
#define HNS_CLONE_JOB_DYNAMIPS_ROUTER_H

// hynesim master headers
#include "clonejobimplementation.h"

// Generated hynesim headers
#include "common/entityentry.h"
#include "common/dynamipsrouterentry.h"

// Qt headers
#include <QStringList>

class QTimer;

namespace Hns {

class CloneJobDynamipsRouter : public CloneJobImplementation
{
    Q_OBJECT

public:
    Q_INVOKABLE CloneJobDynamipsRouter (Hns::EntityEntryPtr originalEntry, Hns::EntityEntryPtr clonedEntry, int flags);
    virtual ~CloneJobDynamipsRouter();
    static bool canClone(const Hns::EntityEntryPtr &entityEntry);

protected slots:
    virtual void _run();
    void _updateCloneProgress();

protected:
    virtual void _copyDisksAndDatas(const Hns::DynamipsRouterEntryPtr &domainEntry);
    QString _clonedFile;
    QTimer *_timer;
    long _originalFileSize;
    QStringList _listFilterCopie;
    QString _clonedSource;
    QString _originalSource;
};

} // namespace Hns

#endif // HNS_CLONE_JOB_DYNAMIPS_ROUTER_H
