/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "clonejoblxc.h"

// hynesim server headers
#include "libhnsserver/processrunner.h"

namespace Hns {

static RegisterCloneImplementation<CloneJobLxc> registerMe(&CloneJobLxc::canClone);

CloneJobLxc::CloneJobLxc(Hns::EntityEntryPtr originalEntry, Hns::EntityEntryPtr clonedEntry, int flags)
    : CloneJobDomain(originalEntry, clonedEntry, flags)
{
    addFileSystem("rootfs");
}

CloneJobLxc::~CloneJobLxc()
{
}

bool CloneJobLxc::canClone(const EntityEntryPtr &entityEntry)
{
    Hns::DomainEntryPtr domain = Hns::DomainEntryPtr::dynamicCast(entityEntry);
    if (domain && domain->type == "lxc")
        return true;
    return false;
}

} // namespace Hns
