/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_CLONE_JOB_VBOX_H
#define HNS_CLONE_JOB_VBOX_H

// hynesim master headers
#include "clonejobdomain.h"

namespace Hns {

class CloneJobVBox : public CloneJobDomain
{
    Q_OBJECT

public:
    Q_INVOKABLE CloneJobVBox(Hns::EntityEntryPtr originalEntry, Hns::EntityEntryPtr clonedEntry, int flags);
    virtual ~CloneJobVBox();
    static bool canClone(const Hns::EntityEntryPtr &entityEntry);

protected:
    virtual bool _copyDisks(const Hns::DomainEntryPtr &domainEntry);
    virtual double getGeneralProgress();

protected slots:
    void _readData(QString data);
    void _readDataError(QString data);

private:
    double _generalProgress;
};

} // namespace Hns

#endif // HNS_CLONE_JOB_VBOX_H
