/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "clonejobvmware.h"

namespace Hns {

static RegisterCloneImplementation<CloneJobVMware> registerMe(&CloneJobVMware::canClone);

CloneJobVMware::CloneJobVMware(Hns::EntityEntryPtr originalEntry, Hns::EntityEntryPtr clonedEntry, int flags)
    : CloneJobDomain(originalEntry, clonedEntry, flags)
{
}

CloneJobVMware::~CloneJobVMware()
{
}

bool CloneJobVMware::canClone(const EntityEntryPtr &entityEntry)
{
    Hns::DomainEntryPtr domain = Hns::DomainEntryPtr::dynamicCast(entityEntry);
    if (domain && domain->type == "vmware")
        return true;
    return false;
}

} // namespace Hns
