/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_ENTITYCLONEJOB_H
#define HNS_ENTITYCLONEJOB_H

// hynesim common headers
#include "common/jobI.h"

// Generated hynesim headers
#include "common/entityentry.h"

// diamesh headers
#include <diamesh/usermanager.h>

namespace Hns {
class CloneJobImplementation;

class EntityCloneJob : public JobI
{
    Q_OBJECT

public:
    EntityCloneJob(EntityEntryPtr originalEntry, Ice::Int flags = 0, const Diamesh::UserPtr &currentUser = Diamesh::UserPtr());
    virtual ~EntityCloneJob();
    EntityEntryPtr clonedEntry();
    void setClonedEntry(EntityEntryPtr newEntry);
    Ice::Long clonedEntryId();

protected slots:
    void _run();
    void _updateImplementationProgress(Ice::Int jobID, Ice::Double);
    void _getEntryModified(::Hns::EntityEntryPtr entry);
    void _implementationCancelled(Ice::Int id);

protected:
    EntityEntryPtr _originalEntry;
    EntityEntryPtr _clonedEntry;
    Diamesh::UserPtr _currentUser;

    CloneJobImplementation *_impl;

    int _flags;
    Ice::Long _clonedEntryId;
};

} // namespace Hns
#endif // HNS_ENTITYCLONEJOB_H
