#ifndef TOPOLOGYCLONEJOB_H
#define TOPOLOGYCLONEJOB_H

// hynesim common headers
#include "common/jobI.h"

// Generated hynesim headers
#include "common/topologyentry.h"

// diamesh headers
#include <diamesh/usermanager.h>

namespace Hns {

class TopologyCloneJob : public JobI
{
    Q_OBJECT
public:
    TopologyCloneJob(TopologyEntryPtr originalEntry, int flags = 0, const Diamesh::UserPtr &currentUser= Diamesh::UserPtr(), const QString &newName = QString());
    ~TopologyCloneJob();
    const TopologyEntryPtr &originalEntry();

protected slots:
    void _run();

private slots:
    void _entityCloneJobFinishedSlot(Ice::Int jobId);
    void _entityCloneJobCancelledSlot(Ice::Int jobId);

private:
    void _addTopologyEntryToCatalog();

    TopologyEntryPtr _originalEntry;
    TopologyEntryPtr _clonedEntry;
    Diamesh::UserPtr _currentUser;
    int _flags;

    QHash<int, qlonglong> _jobOldEntryHash;
    int _remainingEntities;
    int _entitiesCount;
    qlonglong _topologyFolderId;
};

} // namespace Hns

#endif // TOPOLOGYCLONEJOB_H
