/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_DYNAMIPS_ROUTER_H
#define _HNS_DYNAMIPS_ROUTER_H

// Generated hynesim headers
#include "qiceobj_dynamipsrouter.h"
#include "common/entity.h"

// Qt headers
#include <QMap>

namespace Hns {

class DynamipsRouterI : public _Hns_DynamipsRouter
{
    Q_OBJECT

public:
    Q_INVOKABLE DynamipsRouterI();
    ~DynamipsRouterI();
    virtual ::std::string fixIdle(const ::Ice::Current &current = ::Ice::Current());
    virtual ::std::string extractConfiguration(const ::Ice::Current &current = ::Ice::Current());
    virtual bool pushConfiguration(const ::std::string &configuration, const ::Ice::Current &current = ::Ice::Current());

protected:
    QMap<Ice::Long, Hns::Plug> _getPlugs();
    bool _beforeUndefine();
    void _initStatusesList();
};

} // namespace Hns

#endif  //_HNS_DYNAMIPS_ROUTER_H
