/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_DYNAMIPS_ROUTER_DB_H
#define _HNS_DYNAMIPS_ROUTER_DB_H

// Generated hynesim headers
#include "qiceobj_dynamipsrouterdb.h"
#include "common/dynamipsrouterdb.h"
#include "common/entry.h"
#include "common/dynamipsrouterentry.h"

// Qt headers
#include <QMap>
#include <QString>

namespace Hns {

class DynamipsRouterDBI : public _Hns_DynamipsRouterDB
{
    Q_OBJECT
public:
    ~DynamipsRouterDBI();
    static DynamipsRouterDBI *instance();
    bool isValid(const ::Hns::EntryPtr &entry, QString &error) const;
    void populate(::Hns::EntryPtr &entry);
    DynamipsRouterDBPrx proxy();
    virtual ::Hns::DataDynamipsRouterMap getDataDynamipsMap(const ::Ice::Current &current = ::Ice::Current());
    virtual ::Hns::DataDynamipsRouterModuleMap getDynamipsRouterModuleMap(const ::Ice::Current &current = ::Ice::Current());

protected:
    DynamipsRouterDBI();
    static DynamipsRouterDBI *_instance;
    void _fillData();
    QMap<QString, Hns::DataDynamipsRouter> _dataDynamipsRouterMap;
    QMap<QString, Hns::DynamipsRouterModule> _mapModule;
    Ice::Identity _id;
};

} // namespace Hns

#endif //_HNS_DYNAMIPS_ROUTER_DB_H
