/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_ENTITY_FACTORY_H
#define _HNS_ENTITY_FACTORY_H

// Generated hynesim headers
#include "qiceobj_entityfactory.h"
#include "common/entityentry.h"

// Qt headers
#include <QString>
#include <QMetaObject>
#include <QHash>

namespace Hns {

class EntityFactoryI : public _Hns_EntityFactory
{
    Q_OBJECT
public:
    EntityFactoryI();
    ~EntityFactoryI();
    EntityPrx createEntity(const ::Hns::EntityEntryPtr &entry, const ::Ice::Current &current);
    EntityPrx createEntityFromId(::Ice::Long entryId, const ::Ice::Current &current);

public:
    template <typename T1, typename T2> void registerMetaObject()
    {
        _factoryHash.insert(QString::fromStdString(T1::ice_staticId()), T2::staticMetaObject);
    }

    // const QHash<QString, QMetaObject> & getFactoryHash(){return _factoryHash;}
    bool matchClass(const QString &classId , const QString &classMeta);

private:
    QHash<QString, QMetaObject> _factoryHash;
    QHash<QString, ::Ice::Int> _uuidHash; //UUID, entity id
};

} // namespace Hns

#endif // _HNS_ENTITY_FACTORY_H
