/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_ENTITYINFO_H
#define _HNS_ENTITYINFO_H

// Generated hynesim headers
#include "qiceobj_entityinfo.h"

// Qt headers
#include <QPointer>

namespace Hns {

class EntityI;

class EntityInfoI : public _Hns_EntityInfo
{
    Q_OBJECT

public:
    EntityInfoI(EntityI * entity);
    ~EntityInfoI();

    virtual Status getStatus(const ::Ice::Current &current = ::Ice::Current());
    virtual Ice::Long entryId(const ::Ice::Current &current = ::Ice::Current());
    virtual ::Hns::EntityInfoData infoData(const ::Ice::Current &current = ::Ice::Current());

    Ice::Long entityId();
    EntityInfoPrx proxy();
    void removeFromAdapter();

protected:
    void _refreshDataFromEntry();

protected slots:
    void _entryChanged();
    void _statusChanged(Ice::Int status, Ice::Long cpt);

private:
    Ice::Long _entityId;
    Ice::Long _entryId;
    QPointer<EntityI> _entity;
    ::Ice::Identity _proxyIdentity;
    ::Hns::EntityInfoData _infoData;
    Status _status;
    long _idxStatus;
};

} // namespace Hns

#endif // _HNS_ENTITYINFO_H
