/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef ENTRYPROPERTIESMANAGER_H
#define ENTRYPROPERTIESMANAGER_H

// hynesim master headers
#include "entrypropertiessetter.h"

// Generated hynesim headers
#include "qiceobj_entrypropertiesmanager.h"
#include "common/entry.h"
#include "common/entryproperties.h"

// Qt headers
#include <QSharedPointer>

namespace Hns {

class EntryPropertiesManagerI : public _Hns_EntryPropertiesManager
{
    Q_OBJECT
public:
    explicit EntryPropertiesManagerI();
    EntryPropertiesPtr getProperties(const EntryPtr &entry, const ::Ice::Current &current = ::Ice::Current());
    bool canValidateEntry(const Hns::EntryPtr &entry, const Ice::Current &current = ::Ice::Current());
    EntryPtr validateEntry(const EntryPtr &entry, const ::Ice::Current &current = ::Ice::Current());
    QSharedPointer<EntryPropertiesSetter> propertiesSetter(const EntryPtr &entry);

private:
    EntryPropertiesSetter* _getPropertiesSetter(const EntryPtr &entry);
};

} // namespace Hns

#endif // ENTRYPROPERTIESMANAGER_H
