/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of HYNESIM.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef CATALOGIMPORTERI_H
#define CATALOGIMPORTERI_H

// Generated hynesim headers
#include "common/archivedescriptor.h"
#include "common/importable.h"
#include "common/topologyentry.h"
#include "qiceobj_catalogimporter.h"

// Qt headers
#include <QList>

namespace Hns {

class Handler;

class CatalogImporterI : public _Hns_CatalogImporter
{
    Q_OBJECT
public:
    static CatalogImporterI *create();
    static CatalogImporterI *instance();
    CatalogImporterPrx proxy();
    ~CatalogImporterI();

    bool importData(const ImportablePtr &, const std::string &entityStorage, const std::string &topologyStorage = "", const ImportOptionsList &list = ImportOptionsList(), const Ice::Current &current = Ice::Current());
    bool exportData(const DescriptorPtr &desc, bool isArchive, const Ice::Current & = Ice::Current());

    bool exportTopology(const ArchiveDescriptorPtr &, bool, const Ice::Current & current = Ice::Current());
    ImportableArchiveList getArchiveList(const Ice::Current &);
    virtual ::Hns::EntityEntryToImportMap showEntityEntry(const ::Ice::Current& = ::Ice::Current());

private:
    CatalogImporterI();
    QList<ImportablePtr> _getImportableList(int flags);
    void _parseImportFolder(int flags, QList<ImportablePtr> *list, QString path = QString());

    Ice::Long _importEntityEntry(const ::std::string& folder, const ::std::string& storage, const Ice::Current &iceCurrent);

    void _unlockEntities(QList<qlonglong> idList);
    void _addCatalogImporter(const QString& storagePath,::Hns::EntityEntryToImportMap & entryMap);
    void _releaseTopologies(QList<TopologyEntryPtr> topologies, const Ice::Current &current);

    Ice::Identity _id;
    static CatalogImporterI *_instance;
    QList<Handler*> _handlerList;
};

} // namespace Hns
#endif // CATALOGIMPORTERI_H
