/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of HYNESIM.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HANDLER_H
#define HANDLER_H

// Generated hynesim headers
#include "common/importable.h"

// Qt headers
#include <QString>
#include <QStringList>

namespace Hns {

class Handler
{
public:
    Handler();
    ~Handler();
    virtual bool canHandle(QString path) = 0;
    virtual ImportablePtr handle(QString path) = 0;
};

class FolderHandler : public Handler
{
public:
    FolderHandler();
    ~FolderHandler();
    bool canHandle(QString path);
    ImportablePtr handle(QString path);
};

class CompressedHandler : public Handler
{
public:
    CompressedHandler();
    ~CompressedHandler();
    bool canHandle(QString path);
    ImportablePtr handle(QString path);
    QStringList _handledExtensions;
};

} // namespace Hns
#endif // HANDLER_H
