/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of HYNESIM.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef IMPORTABLESERIALIZER_H
#define IMPORTABLESERIALIZER_H

// Generated hynesim headers
#include "common/importable.h"

// Qt headers
#include <QObject>

namespace Hns {

class ImportableSerializer : public QObject
{
    Q_OBJECT
public:
    explicit ImportableSerializer(QObject *parent = 0);
    ~ImportableSerializer();
    virtual ImportablePtr deserialize(const QString &fileContent) = 0;
};

class ImportableEntrySerializer : public ImportableSerializer
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit ImportableEntrySerializer(QObject *parent = 0);
    ~ImportableEntrySerializer();
    ImportablePtr deserialize(const QString &fileContent);
};

class ImportableArchiveSerializer : public ImportableSerializer
{
    Q_OBJECT
public:
    Q_INVOKABLE explicit ImportableArchiveSerializer(QObject *parent = 0);
    ~ImportableArchiveSerializer();
    ImportablePtr deserialize(const QString &fileContent);
    QString serialize(const ArchiveDescriptorPtr &archiveDescriptor);
};

} // namespace Hns
#endif // IMPORTABLESERIALIZER_H
