/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_JOB_MANAGER_H
#define HNS_JOB_MANAGER_H

// Generated hynesim headers
#include <qiceobj_jobmanager.h>

// Qt headers
#include <QHash>

namespace Hns {

class JobI;

class JobManagerI : public _Hns_JobManager
{
    Q_OBJECT
public:
    virtual ~JobManagerI();
    static JobManagerI *create();
    static JobManagerI *instance();
    JobManagerPrx proxy();
    ::Ice::Int addJob(JobI *job);
    virtual ::Hns::JobPrx getJob(::Ice::Int id, const ::Ice::Current &current = ::Ice::Current());
    virtual bool removeJob(::Ice::Int, const ::Ice::Current &current = ::Ice::Current());
    JobI *job(::Ice::Int id);

private:
    explicit JobManagerI();

private:
    static JobManagerI *_instance;
    ::Ice::Int _jobId;
    Ice::Identity _id;
    QHash< ::Ice::Int, JobPrx> _jobHash;
};

} // namespace Hns

#endif // HNS_JOB_MANAGER_H
