/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_LAYOUT_SERIALIZER_H
#define HNS_LAYOUT_SERIALIZER_H

// Generated hynesim headers
#include "common/layout.h"

// Qt headers
#include <QObject>

class QDomDocument;
class QDomElement;

namespace Hns {

class EntityLayoutSerializer : public QObject
{
    Q_OBJECT
public:
    Q_INVOKABLE EntityLayoutSerializer();
    static QDomElement serialize(QDomDocument *doc, EntityLayoutPtr layout);
    static EntityLayoutPtr unserialize(const QDomElement &element);
};

class WireLayoutSerializer : public QObject
{
    Q_OBJECT
public:
    Q_INVOKABLE WireLayoutSerializer();
    static QDomElement serialize(QDomDocument *doc, WireLayoutPtr layout);
    static WireLayoutPtr unserialize(const QDomElement &element);
};

} // namespace Hns

#endif // HNS_LAYOUT_SERIALIZER_H
