/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "masterI.h"
#include "sqluserstorage.h"

// hynesim common headers
#include "common/hns.h"
#include "common/version.h"

// diamesh headers
#include <diamesh/coreapplication.h>
#include <diamesh/constants.h>

// Qt headers
#include <QDebug>

int main(int argc, char **argv)
{
    QHash<QString, QString> appConfigHash;
    appConfigHash.insert(Diamesh::Constants::APP_CONFIG_NAME, "hynesim-master");
    appConfigHash.insert(Diamesh::Constants::APP_CONFIG_ORGANIZATION, "diateam");
    Diamesh::CoreApplication * app = Diamesh::CoreApplication::create(argc, argv, NULL, appConfigHash);
    Hns::loadTranslation(QString("hynesim_"), false);
    Diamesh::VersionInfo info = Hns::versionInfo();
    QString version=QString("Master: %1 %2 %3  %4 %5  %6 %7 %8").arg(QString("Version:"),QString::fromStdString(info.version),QString::fromStdString(info.versionDescription),QString("Revision:"),QString::fromStdString(info.revision),QString("Build date:"),QString::fromStdString(info.buildDate),QString::fromStdString(info.buildTime));
    qDebug()<<version;
    Hns::MasterI master;
    master.setUserManager(Hns::SqlUserStorage::create(master.db()));
    master.start();
    return app->exec();
}
