#ifndef MEMORYDUMPJOB_H
#define MEMORYDUMPJOB_H

#include "common/jobI.h"
#include "common/types.h"
#include "common/nodedomain.h"

namespace Hns {

class MemoryDumpJob : public JobI
{
    Q_OBJECT

public:
    MemoryDumpJob(HnsNode::DomainPrx domainProxy);
    ~MemoryDumpJob();
    MemoryDumpInfo memoryDumpInfo();

    void setName(const QString &name);
    void setTopologyPath(const QString &path);

protected slots:
    virtual void _run();

private:
    MemoryDumpInfo _memoryDumpInfo;
    HnsNode::DomainPrx _domainProxy;
    QString _topologyPath;
};

} // namespace Hns

#endif // MEMORYDUMPJOB_H
