/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_NODEINFOI_H
#define HNS_NODEINFOI_H

// Generated hynesim headers
#include "qiceobj_nodeinfo.h"
#include "common/entityentry.h"
#include "common/platforminfo.h"
#include "common/noderesourceinfo.h"
#include "common/proxies_nodemonitor.h"
#include "common/proxies_node.h"

// diamesh headers
#include <diamesh/types.h>
#include <diamesh/info.h>

// Qt headers
#include <QSet>

namespace Hns {

class NodeMonitorI;

class NodeInfoI : public _Hns_NodeInfo
{
    Q_OBJECT
public:
    NodeInfoI(const QString &nodeKey, const NodePrx &node);

    bool canBuild(const ::Hns::EntityEntryPtr &entry, const ::Ice::Current &current);
    bool canBuildAll(const EntityEntryPtr &entityEntry, const EntityEntryList &alreadyComputedEntries, const Ice::Current &current);
    Diamesh::LongList canBuildFromEntryMap(QMap<Ice::Long, EntityEntryPtr> entryMap);
    Diamesh::VersionInfo getVersionInfo(const ::Ice::Current &current);
    HnsNode::ResourceInfo getResourceInfo(const ::Ice::Current &current = ::Ice::Current());
    PlatformInfoMap getPlatforms(const ::Ice::Current &current = ::Ice::Current());
    ::Diamesh::LongList getEntityDefineIds(const ::Ice::Current &current = ::Ice::Current());
    Hns::NodeMonitorPrx getNodeMonitor(const ::Ice::Current &current = ::Ice::Current());

protected slots:
    void _addEntity(long);
    void _removeEntity(long);

protected:
    NodeQPrx _nodeProxyQtice;
    QSet<qlonglong> _setEntityId;
    NodeMonitorI *_nodeMonitor;
};

} // namespace Hns

#endif // HNS_NODEINFOI_H
