/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "nodemonitorI.h"
#include "masterI.h"

namespace Hns {

NodeMonitorI::NodeMonitorI(HnsNode::NodeMonitorPrx monitorPrx, QString nodeKey)
    : _Hns_NodeMonitor()
{
    _id.name = QString("nodeMonitor_%1").arg(nodeKey).toStdString();
    MasterI::instance()->adapter()->add(this, _id);
    _nodeMonitorQtProxy = HnsNode::NodeMonitorQPrx(monitorPrx, MasterI::instance()->adapter());
    QObject::connect(_nodeMonitorQtProxy.data(), SIGNAL(entityDataChanged(Hns::EntityMonitorDataMap)), this, SIGNAL(entityDataChanged(Hns::EntityMonitorDataMap)));
}

NodeMonitorI::~NodeMonitorI()
{
    _nodeMonitorQtProxy = 0;
}

EntityMonitorDataMap NodeMonitorI::getEntityMonitorDataMap(const Ice::Current &current)
{
    Q_UNUSED(current)
    return _nodeMonitorQtProxy->getEntityMonitoringDataMap();
}

NodeMonitorPrx NodeMonitorI::proxy()
{
    return NodeMonitorPrx::uncheckedCast(MasterI::instance()->adapter()->createProxy(_id));
}

void NodeMonitorI::destroy()
{
    emit requestDeletion(MasterI::instance()->adapter(), _id);
}

} // namespace Hns
