/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
#ifndef HNS_NODEMONITORI_H
#define HNS_NODEMONITORI_H

// Generated hynesim headers
#include "qiceobj_nodemonitor.h"
#include "common/monitordata.h"
#include "common/proxies_nodelocalmonitor.h"

namespace Hns {

class NodeMonitorI : public _Hns_NodeMonitor
{
    Q_OBJECT
public:
    explicit NodeMonitorI(HnsNode::NodeMonitorPrx monitorPrx, QString nodeKey);
    ~NodeMonitorI();
    EntityMonitorDataMap getEntityMonitorDataMap(const Ice::Current &current = ::Ice::Current());
    NodeMonitorPrx proxy();

public slots:
    void destroy();

private:
    Ice::Identity _id;
    HnsNode::NodeMonitorQPrx _nodeMonitorQtProxy;
};

} // namespace Hns

#endif // HNS_NODEMONITORI_H
