/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "scriptrunner.h"

// hynesim common headers
#include "common/constants.h"

// diamesh headers
#include <diamesh/diamesh.h>

// Qt headers
#include <QSettings>

namespace Hns {

ScriptRunner::ScriptRunner(QObject *parent)
    : HnsServer::ScriptRunner(parent)
{
    QSettings settings(Diamesh::instance()->configFileName(), QSettings::IniFormat, this);
    settings.beginGroup(Constants::SETTINGS_HYNESIM_GROUP);
    setScriptDirectory(settings.value(Constants::SETTINGS_SCRIPTS_DIRECTORY, ".").toString());
    settings.endGroup();
}

ScriptRunner::~ScriptRunner()
{
}


} // namespace Hns
