/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNS_SQLUSERSTORAGE_H
#define HNS_SQLUSERSTORAGE_H

// diamesh headers
#include <diamesh/sqluserstorage.h>
#include <diamesh/usermanager.h>

// Qt headers
#include <QString>
#include <QVariant>
#include <QHash>

namespace Diamesh {
class SqlDatabase;
} // namespace Diamesh

namespace Hns {

class SqlUserStorage : public Diamesh::SqlUserStorage
{

public:
    static SqlUserStorage* create(Diamesh::SqlDatabase *db);
    virtual Diamesh::UserPtr getUser(::Ice::Long userId);
    virtual Ice::Long addUser(const ::Diamesh::UserPtr &user, const QHash<QString, QVariant> &additionalFields);
    virtual bool updateUser(const ::Diamesh::UserPtr &user, const QHash<QString, QVariant> &additionalContent=QHash<QString, QVariant>());

protected:
    SqlUserStorage(Diamesh::SqlDatabase* db);
    virtual void _loadFromDb();
};

} // namespace Hns

#endif // SQLUSERSTORAGE_H
