/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "switchI.h"

// Generated hynesim headers
#include "common/switchentry.h"

// diamesh headers
#include <diamesh/utils.h>

namespace Hns {

SwitchI::SwitchI()
{
    Diamesh::setFlags(Hns::NET_CAPTURE, _flags);
}

SwitchI::~SwitchI()
{
}

QMap<Ice::Long, Hns::Plug> SwitchI::_getPlugs()
{
    SwitchEntryPtr switchEntry = SwitchEntryPtr::dynamicCast(_entityEntry);

    QMap<Ice::Long, Hns::Plug> plugMap;
    for (int i = 0; i < switchEntry->ports; i++) {
        Hns::Plug plug;
        plug.id = i;
        plug.name = QString("port_%1").arg(i).toStdString();
        plugMap.insert(i, plug);
    }
    return plugMap;
}

} // namespace Hns
