/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TAGMANAGERI_H
#define TAGMANAGERI_H

// Generated hynesim headers
#include <qiceobj_tagmanager.h>

// diamesh headers
#include <diamesh/types.h>

// Qt headers
#include <QList>
#include <QHash>
#include <QReadWriteLock>

namespace Diamesh {
class SqlDatabase;
} // namespace Diamesh

namespace Hns {

class TagManagerI : public _Hns_TagManager
{
    Q_OBJECT
public:
    explicit TagManagerI(Ice::ObjectAdapterPtr adapter, const QString &settingsFileName);
    virtual ~TagManagerI();
    TagManagerPrx proxy();

    bool addTag(Ice::Long elementId, const std::string &tagName, const Ice::Current &current = Ice::Current());
    bool addTags(qlonglong elementId, Diamesh::StringList tags);
    bool removeTag(Ice::Long elementId, const std::string &tagName, const Ice::Current &current = Ice::Current());
    bool removeTags(Ice::Long elementId, const Ice::Current &current = Ice::Current());
    Diamesh::StringList tags(qlonglong elementId);
    bool updateTags(qlonglong elementId, Diamesh::StringList newTags);

private:
    void _init();

    Diamesh::SqlDatabase *_database;
    QReadWriteLock _tagsLock;
    Ice::Identity _id;
    Ice::ObjectAdapterPtr _adapter;
    QHash<qlonglong, QString> _tags;
    QHash<qlonglong, QList<qlonglong> > _tagsItems; //elementid, taglist
};

} // namespace Hns

#endif // USERMANAGERI_H

