/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim master headers
#include "wifiapI.h"

// Generated hynesim headers
#include "common/entity.h"

// diamesh headers
#include <diamesh/utils.h>

namespace Hns {

WifiAPI::WifiAPI()
{
    Diamesh::setFlags(Hns::NET_CAPTURE, _flags);
}

WifiAPI::~WifiAPI()
{
}

QMap<Ice::Long, Hns::Plug> WifiAPI::_getPlugs()
{
    QMap<Ice::Long, Hns::Plug> plugMap;
    Hns::Plug plug;
    plug.id = 0;
    plug.name = "wlan";
    plugMap.insert(0, plug);
    return plugMap;
}

::Diamesh::StringList WifiAPI::connectedPeers(const ::Ice::Current &current)
{
    Q_UNUSED(current)
    if (isDefined()){
        _wifiApPrx = WifiAPPrx::uncheckedCast(_entityProxy);
        return _wifiApPrx->connectedPeers();
    }
    return ::Diamesh::StringList();
}

bool WifiAPI::_afterDefine()
{
    _wifiApQPrx = HnsNode::WifiAPQPrx::uncheckedCast(_entityProxyQtice);
    if (_wifiApQPrx){
        QObject::connect(_wifiApQPrx.data(),SIGNAL(peerJoined(QString)),this,SIGNAL(peerJoined(QString)));
        QObject::connect(_wifiApQPrx.data(),SIGNAL(peerLeft(QString)),this,SIGNAL(peerLeft(QString)));
        return true;
    }
    return false;
}

} // namespace Hns
