/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIFIAPI_H
#define WIFIAPI_H

// Generated hynesim headers
#include "qiceobj_wifiap.h"
#include "common/proxies_nodewifiap.h"

// diamesh headers
#include <diamesh/types.h>

// Qt headers
#include <QMap>

namespace Hns {

class WifiAPI : public _Hns_WifiAP
{
    Q_OBJECT

    friend class PlatformWifiAp;
public:
    Q_INVOKABLE WifiAPI();
    ~WifiAPI();
    ::Diamesh::StringList connectedPeers(const ::Ice::Current &current);

protected :
    QMap<Ice::Long , Hns::Plug> _getPlugs();
    bool _afterDefine();
    WifiAPPrx _wifiApPrx;
    HnsNode::WifiAPQPrx _wifiApQPrx;

};

} // namespace Hns
#endif // WIFIAPI_H
