/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_WIRE_H
#define _HNS_WIRE_H

// Generated hynesim headers
#include "qiceobj_wire.h"
#include "common/proxies_entity.h"
#include "common/proxies_nodeentity.h"

namespace Hns {

class WireI : public _Hns_Wire
{
    Q_OBJECT

public:
    Q_INVOKABLE WireI();
    ~WireI();
    void setLinkedEntities(EntityPrx fromEntity, int fromPort, EntityPrx toEntity, int toPort);
    void changePortFrom(int port);
    void changePortTo(int port);

protected:
    bool _beforeDefine(const HnsNode::EntityPrx &entityProxy);
    QString defineDoneMessage() override;

private:
    EntityPrx _fromEntity;
    int _fromPort;
    EntityPrx _toEntity;
    int _toPort;
};

} // namespace Hns

#endif // _HNS_WIRE_H
