/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef CAPTUREHANDLERFACTORY_H
#define CAPTUREHANDLERFACTORY_H

// Generated hynesim headers
#include "common/entityentry.h"

// Qt headers
#include <QMetaObject>

namespace HnsNode {

typedef QMetaObject (*CaptureHandlerHelper) (const::Hns::EntityEntryPtr &);

class CaptureHandlerFactory
{
public:
    static QMetaObject getCaptureHandler(const Hns::EntityEntryPtr &entry);
    
    static QMetaObject registerDomainCaptureHandler(const Hns::EntityEntryPtr &entry);
    static QMetaObject registerDynamipsCaptureHandler(const Hns::EntityEntryPtr &entry);
    static QMetaObject registerHybridCaptureHandler(const Hns::EntityEntryPtr &entry);
    static QMetaObject registerSwitchCaptureHandler(const Hns::EntityEntryPtr &entry);
    static QMetaObject registerWifiAPCaptureHandler(const Hns::EntityEntryPtr &entry);
    static QMetaObject registerTopologyGateCaptureHandler(const Hns::EntityEntryPtr &entry);

private:
    CaptureHandlerFactory() {}
};

} // namespace HnsNode

#endif // CAPTUREHANDLERFACTORY_H
