/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NODECAPTUREJOBI_H
#define NODECAPTUREJOBI_H

// Generated hynesim headers
#include "qiceobj_nodecapturejob.h"
#include "common/capturejoboptions.h"
#include "common/entityentry.h"

namespace HnsNode {

class EntityI;
class CaptureHandler;

class CaptureJobI : public _HnsNode_CaptureJob
{
    Q_OBJECT
public:
    CaptureJobI(EntityI *entity, QString captureJobPath);
    ~CaptureJobI();
    bool cancel(const::Ice::Current &current);
    virtual bool setOptions(const Hns::CaptureJobOptions &jobOptions, const Ice::Current &current);
    std::string getCaptureJobFileMixedPath(const Ice::Current &current);
    Hns::PcapInfo getPcapInfo(const Ice::Current &current);

signals:
    void endCapture();

protected slots:
    virtual void _run();

private:
    QString _captureJobMixedPath;
    CaptureHandler *_captureHandler;

};

} // namespace HnsNode

#endif // NODECAPTUREJOBI_H
