/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim node headers
#include "domaincapturehandler.h"
#include "nodedomainI.h"
#include "netcard.h"

namespace HnsNode {

DomainCaptureHandler::DomainCaptureHandler()
{
}

DomainCaptureHandler::~DomainCaptureHandler()
{
}

QString DomainCaptureHandler::_getFileNamePrefix()
{
    DomainI *domain = qobject_cast<DomainI *>(_entity);
    QString interfaceName;
    foreach (Netcard *netcard, domain->netcards()) {
        Hns::Netcard netcardEntry = netcard->netcardEntry();
        if (netcardEntry.id == _jobOptions.interfaceList.front() && _availableInterfaces.contains(netcardEntry.id))
            interfaceName = QString::fromStdString(netcardEntry.source);
    }
    return interfaceName;
}

QString DomainCaptureHandler::_getInterfaceToCapture()
{
    DomainI *domain = qobject_cast<DomainI *>(_entity);
    QString tapName;
    foreach (Netcard *netcard, domain->netcards()) {
        Hns::Netcard netcardEntry = netcard->netcardEntry();
        if (netcardEntry.id == _jobOptions.interfaceList.front() && _availableInterfaces.contains(netcardEntry.id))
            tapName = netcard->devName();
    }
    return tapName;
}

} // namespace HnsNode
