/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim node headers
#include "dynamipsroutercapturehandler.h"
#include "nodedynamipsrouterI.h"

namespace HnsNode {

DynamipsRouterCaptureHandler::DynamipsRouterCaptureHandler()
{
}

DynamipsRouterCaptureHandler::~DynamipsRouterCaptureHandler()
{
}

QString DynamipsRouterCaptureHandler::_getFileNamePrefix()
{
    DynamipsRouterI *dynamipsRouter = qobject_cast<DynamipsRouterI *>(_entity);
    QString interfaceName;
    QVector<QString> netCardTaps =  dynamipsRouter->getNetCardTap();
    for (int portId = 0; portId < netCardTaps.size(); portId++) {
        if (portId == _jobOptions.interfaceList.front() &&  _availableInterfaces.contains(portId))
            interfaceName = QString("portDynamips_%1").arg(portId);
    }
    return interfaceName;
}

QString DynamipsRouterCaptureHandler::_getInterfaceToCapture()
{
    DynamipsRouterI *dynamipsRouter = qobject_cast<DynamipsRouterI *>(_entity);
    QString tapName;
    QVector<QString> netCardTaps = dynamipsRouter->getNetCardTap();
    for (int portId = 0; portId < netCardTaps.size(); portId++) {
        if (portId == _jobOptions.interfaceList.front() && _availableInterfaces.contains(portId))
            tapName = netCardTaps.at(portId);
    }

    return tapName;
}

} // namespace HnsNode
