#ifndef ENTITYPLUGI_H
#define ENTITYPLUGI_H

// hynesim node headers
#include "nodedomainI.h"

// Generated hynesim headers
#include "qiceobj_entityplug.h"

// Qt headers
#include <QObject>
#include <QString>

namespace HnsNode {

class EntityI;

/*******************************************************************************
 * EntityPlugI
 ******************************************************************************/
class EntityPlugI : public _HnsNode_EntityPlug
{
    Q_OBJECT

public:
    EntityPlugI(const QString &bridgeName);
    ~EntityPlugI();
    std::string getHost(const Ice::Current &current = Ice::Current());
    std::string getBridgeName(const Ice::Current &current = Ice::Current());
    virtual void plug(const Ice::Current &current = Ice::Current());
    virtual void unplug(const Ice::Current &current = Ice::Current());
    void setInterface(const std::string &interfaceName, const Ice::Current &current = Ice::Current());
    std::string getInterfaceName(const Ice::Current &current = Ice::Current());
    void createVxlan(Ice::Long id, const std::string &dstIp, const Ice::Current &current = Ice::Current());
    void setEntity(EntityI *entity);
    QString interfaceName();
    void applyProperties(const Hns::WireProperty &property, const Ice::Current &current = Ice::Current());
    void removeVxlan(const Ice::Current &current = Ice::Current());

signals:
    void interfaceStateChanged(QString bridgeName, bool stateUp);

protected:
    EntityI *_entity;
    QString _bridgeName;
    QString _interfaceName;
    bool _vxlan;
};

/*******************************************************************************
 * SwitchPlug
 ******************************************************************************/
class SwitchPlug : public EntityPlugI
{
public:
    SwitchPlug(const QString &bridgeName);
    ~SwitchPlug();

    virtual void plug(const Ice::Current &current = Ice::Current());
    virtual void unplug(const Ice::Current &current = Ice::Current());

    void setPort(int port);

protected:
    int _port;
};

} // namespace HnsNode

#endif // ENTITYPLUGI_H
