/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef KERNELBRIDGESWITCHIMPLEMENTATION_H
#define KERNELBRIDGESWITCHIMPLEMENTATION_H

// hynesim node headers
#include "switchimplementation.h"

// Qt headers
#include <QMutex>

namespace HnsNode {

class EntityI;

class KernelBridgeSwitchImplementation : public SwitchImplementation
{
    Q_OBJECT

public:
    KernelBridgeSwitchImplementation(EntityI *entity);
    bool define();
    bool destroy();
    bool start();
    bool stop();
    bool updateEntry(const::Hns::EntityEntryPtr &entry);
    EntityPlugI *createPlug(Ice::Int port);
    QList<Ice::Int> initAvailablePlugsForCapture();
    void plug(int port, const QString &tapName);
    void unplug(int port);

private:
    QMutex _mutex;
};

} // namespace HnsNode

#endif // KERNELBRIDGESWITCHIMPLEMENTATION_H
