/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NATIVEDPIPEWIREIMPLEMENTATION_H
#define NATIVEDPIPEWIREIMPLEMENTATION_H

// hynesim node headers
#include "wireimplementation.h"

// Generated hynesim headers
#include "common/entityentry.h"
#include "common/wireentry.h"
#include "common/entityplug.h"

namespace HnsNode {

class EntityI;

class NativeWireImplementation : public WireImplementation
{
    Q_OBJECT

public:
    explicit NativeWireImplementation(Hns::EntityEntryPtr entityEntryPtr);
    virtual ~NativeWireImplementation();

    virtual bool define(EntityI *entityI);
    virtual bool destroy();
    virtual bool updateEntry(const::Hns::EntityEntryPtr &entry);
    virtual bool setLinkedEntities(const::HnsNode::EntityPrx &fromEntity, ::Ice::Int fromPort, const::HnsNode::EntityPrx &toEntity, ::Ice::Int toPort);

private:
    void _applySettings(const Hns::WireEntryPtr &entry);

    EntityPlugPrx _fromPlug;
    EntityPlugPrx _toPlug;
    QString _interfaceName;
};

} // namespace HnsNode

#endif // NATIVEDPIPEWIREIMPLEMENTATION_H
