/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim node headers
#include "netcard.h"

namespace HnsNode {

Netcard::Netcard(Hns::Netcard netcardEntry, const QString &devName, const QString &vethName)
    : _netcardEntry(netcardEntry)
    , _devName(devName)
    , _vethName(vethName)
{
    if (_vethName.isEmpty())
        _vethName = _devName + "v";
}

Netcard::~Netcard()
{
}

const Hns::Netcard &Netcard::netcardEntry()
{
    return _netcardEntry;
}

QString Netcard::macAddress()
{
    return QString::fromStdString(_netcardEntry.macAddress);
}

const QString &Netcard::devName()
{
    return _devName;
}

const QString &Netcard::vethName()
{
    return _vethName;
}

} // namespace HnsNode
