/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_NODE_DYNAMIPS_ROUTER_H
#define _HNS_NODE_DYNAMIPS_ROUTER_H

// Generated hynesim headers
#include "qiceobj_nodedynamipsrouter.h"

// diamesh headers
#include <diamesh/types.h>

// Qt headers
#include <QString>
#include <QVector>

namespace HnsNode {

class DynamipsPlugin;

class DynamipsRouterI : public _HnsNode_DynamipsRouter
{
    Q_OBJECT

    friend class PlatformDynamipsRouter;
    friend class DynamipsPlugin;

public:
    Q_INVOKABLE DynamipsRouterI();
    ~DynamipsRouterI();
    std::string fixIdle(const Ice::Current &current = ::Ice::Current());
    std::string extractConfiguration(const Ice::Current &current = ::Ice::Current());
    bool pushConfiguration(const ::std::string &configuration, const ::Ice::Current &current = ::Ice::Current());
    QVector<QString>  getNetCardTap();
    ::Diamesh::IntList getPlugs(const::Ice::Current &current = ::Ice::Current());
    int routerId();
    int telnetPort();
    DynamipsPlugin *plugin();
    void setPlugin(DynamipsPlugin *plugin);

protected:
    EntityPlugI *_createPlug(::Ice::Int port);
    bool _define(const ::Ice::Current &current = ::Ice::Current());
    bool _destroy(const::Ice::Current &current = ::Ice::Current());
    bool _start(const::Ice::Current &current = ::Ice::Current());
    bool _stop(const::Ice::Current &current = ::Ice::Current());
    bool _suspend(const::Ice::Current &current = ::Ice::Current());
    bool _resume(const::Ice::Current &current = ::Ice::Current());
    void _createNetcards();

private:
    QVector<QString> _vectVdeTapPlug;
    DynamipsPlugin *_plugin;
    int _routerId;
    int _telnetPort;

};

} // namespace HnsNode

#endif // _HNS_NODE_DYNAMIPS_ROUTER_H
