/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_NODE_HYBRID_NETCARD_H
#define _HNS_NODE_HYBRID_NETCARD_H

// Generated hynesim headers
#include "qiceobj_nodehybridnetcard.h"

namespace HnsNode {

class HybridNetcardI : public _HnsNode_HybridNetcard
{
    Q_OBJECT

    friend class PlatformHybridNetcard;

public:
    Q_INVOKABLE HybridNetcardI();
    ~HybridNetcardI();
    ::Diamesh::IntList getPlugs(const ::Ice::Current &current = ::Ice::Current());
    QString interfaceName();
    Hns::MacAddressMap getMacAddresses(const Ice::Current &current = ::Ice::Current());

protected:
    EntityPlugI *_createPlug(::Ice::Int port);
    bool _define(const ::Ice::Current &current = ::Ice::Current());
    bool _destroy(const ::Ice::Current &current = ::Ice::Current());
    bool _start(const ::Ice::Current &current = ::Ice::Current());
    bool _stop(const ::Ice::Current &current = ::Ice::Current());

private:
    QString _bridgeName;
    QString _interfaceName;
};

} // namespace HnsNode

#endif // _HNS_NODE_HYBRID_NETCARD_H
