/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_NODE_NODEMONITORI_H
#define _HNS_NODE_NODEMONITORI_H

// Generated hynesim headers
#include "qiceobj_nodelocalmonitor.h"

class QSignalMapper;

namespace HnsNode {

class EntityI;
class EntityFactoryI;

class NodeMonitorI : public _HnsNode_NodeMonitor
{
    Q_OBJECT
public:
    explicit NodeMonitorI(EntityFactoryI *factory);
    ~NodeMonitorI();
    ::Hns::EntityMonitorDataMap getEntityMonitoringDataMap(const Ice::Current &current = ::Ice::Current());

protected:
    void timerEvent(QTimerEvent *event);
    Hns::EntityMonitorDataMap _dataAsStdMap();

protected slots:
    void _entityAdded(EntityI *entity);
    void _removeEntity(long entityId);
    void _monitorEntity(EntityI *entity);
    void _monitoringDataUpdated(::Hns::EntityMonitoringDataPtr data);
    void _entityStatusChanged(QObject *object);
    void _dataChanged();

private:
    QMap<Ice::Long, Hns::EntityMonitoringDataPtr> _entitiesDataMap;
    int _updateTimerId;
    QSignalMapper *_entityMapper;
    QReadWriteLock _dataLocker;
};

} // namespace HnsNode

#endif // _HNS_NODE_NODEMONITORI_H
