/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_NODE_SWITCH_H
#define _HNS_NODE_SWITCH_H

// Generated hynesim headers
#include "qiceobj_nodeswitch.h"

namespace HnsNode {

class SwitchImplementation;

class SwitchI : public _HnsNode_Switch
{
    Q_OBJECT

public:
    Q_INVOKABLE SwitchI();
    ~SwitchI();

    ::Diamesh::IntList getPlugs(const ::Ice::Current &current = ::Ice::Current());
    void setImplementation(SwitchImplementation *implementation);
    SwitchImplementation *implementation();
    void enableCapture(QString captureFilePath, QStringList portsToCapture, int maxPackets, QString pcapFilter);
    void disableCapture();
    int getPacketsCount();
    QHash<int, QString> getTapHash();
    QString getBridgeName();

protected:
    EntityPlugI *_createPlug(::Ice::Int port);
    bool _updateEntry(const::Hns::EntityEntryPtr &entry);
    void _initAvailablePlugsForCapture(const ::Ice::Current &current = ::Ice::Current());

protected slots:
    bool _define(const ::Ice::Current &current = ::Ice::Current());
    bool _destroy(const ::Ice::Current &current = ::Ice::Current());
    bool _start(const ::Ice::Current &current = ::Ice::Current());
    bool _stop(const ::Ice::Current &current = ::Ice::Current());

private:
    SwitchImplementation *_implementation;
    QString _type;
    int _dumpedPacketsCount;
};

} // namespace HnsNode

#endif // _HNS_NODE_SWITCH_H
