/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TOPOLOGYGATEI_H
#define TOPOLOGYGATEI_H

// Generated hynesim headers
#include "qiceobj_nodetopologygate.h"

namespace HnsNode {

class EntityPlug;

class TopologyGateI : public _HnsNode_TopologyGate
{
    Q_OBJECT

public:
    Q_INVOKABLE TopologyGateI();
    ~TopologyGateI();

    QString getNetworkName();
    ::Diamesh::IntList getPlugs(const ::Ice::Current &current = ::Ice::Current());

    QString getBridgeName() const;
    void setBridgeName(const QString &bridgeName);

protected:
    EntityPlugI *_createPlug(::Ice::Int port);

    bool _define(const Ice::Current &current = ::Ice::Current());
    bool _destroy(const Ice::Current &current = ::Ice::Current());
    bool _start(const Ice::Current &current = ::Ice::Current());
    bool _stop(const Ice::Current &current = ::Ice::Current());

private:
    QString _bridgeName;
    QString _networkName;
};

} // namespace HnsNode

#endif // TOPOLOGYGATEI_H
