/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef NODEWIFIAPI_H
#define NODEWIFIAPI_H

// Generated hynesim headers
#include "qiceobj_nodewifiap.h"

// Qt headers
#include <QTimer>
#include <QStringList>

namespace HnsNode {

class EntityPlugI;

class WifiAPI : public _HnsNode_WifiAP
{
    Q_OBJECT
public:
    Q_INVOKABLE WifiAPI();
    ::Diamesh::StringList connectedPeers(const ::Ice::Current &current = ::Ice::Current());
    ~WifiAPI();
    ::Diamesh::IntList getPlugs(const ::Ice::Current &current = ::Ice::Current());

    QString getSsid() const;
    QString getBridgeName() const;

    void setSsid(const QString &ssid);
    void setBridgeName(const QString &bridgeName);

    QString getInterfaceName() const;
    void setInterfaceName(const QString &interfaceName);

protected :
    bool _define(const ::Ice::Current &current = ::Ice::Current());
    bool _destroy(const ::Ice::Current &current = ::Ice::Current());
    bool _start(const ::Ice::Current &current = ::Ice::Current());
    bool _stop(const ::Ice::Current &current = ::Ice::Current());
    EntityPlugI *_createPlug(::Ice::Int port);

private slots:
    void _checkPeersSlot();

private :
    QString _ssid;
    QString _bridgeName;
    QString _interfaceName;
    QTimer _checkPeersTimer;
    QStringList _connectedPeers;
};

} // namespace HnsNode
#endif // NODEWIFIAPI_H
