/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_NODE_WIRE_H
#define _HNS_NODE_WIRE_H

// Generated hynesim headers
#include "qiceobj_nodewire.h"
#include "common/proxies_nodeentity.h"
#include "common/entityplug.h"

namespace HnsNode {

class WireImplementation;

class WireI : public _HnsNode_Wire
{
    Q_OBJECT

public:
    Q_INVOKABLE WireI();
    ~WireI();
    bool setLinkedEntities(const ::HnsNode::EntityPrx &fromEntity, ::Ice::Int fromPort, const ::HnsNode::EntityPrx &toEntity, ::Ice::Int toPort, const ::Ice::Current &current = ::Ice::Current());
    virtual HnsNode::CaptureJobPrx createCaptureJob(const std::string &captureJobPath,const Ice::Current &current);
    void setImplementation(WireImplementation *wireImplementation);
    WireImplementation *implementation();

protected:
    bool _define(const ::Ice::Current &current = ::Ice::Current());
    bool _destroy(const ::Ice::Current &current = ::Ice::Current());
    bool _updateEntry(const::Hns::EntityEntryPtr &entry);

private:
    EntityPlugPrx _fromPlug;
    EntityPlugPrx _toPlug;
    WireImplementation *_wireImplementation;
    HnsNode::EntityPrx _fromEntity;
    int _fromPort;
    HnsNode::EntityPrx _toEntity;
    int _toPort;
};

} // namespace HnsNode

#endif // _HNS_NODE_WIRE_H
