/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PCAPCAPTUREHANDLER_H
#define PCAPCAPTUREHANDLER_H

// hynesim node headers
#include "capturehandler.h"

// QPcap headers
#include "qpcap.h"

// external headers
#include "pcap.h"

namespace HnsNode {

class PcapCaptureHandler : public CaptureHandler
{
    Q_OBJECT

public:
    PcapCaptureHandler();
    ~PcapCaptureHandler();
    bool initCapture();
    void startCapture();
    virtual bool setOptions(const Hns::CaptureJobOptions &jobOptions);

public slots:
    void endCapture();

protected slots:
    void _afterPcapClosed();
    void _packetReceived(QPcapHeader packetHeader, const uchar *packet);

protected:
    virtual QString _getInterfaceToCapture() = 0;
    int _getPacketsCount();

private:
    QString _interfaceToCapture;
    int _packetsCount;
    pcap_dumper_t *_dumper;

protected:
    QPcap *_qpcap;
    bool _creating;
};

} // namespace HnsNode

#endif // PCAPCAPTUREHANDLER_H
