/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef HNSNODE_PLATFORMHYBRIDNETCARD_H
#define HNSNODE_PLATFORMHYBRIDNETCARD_H

// hynesim node headers
#include "platform.h"

// Generated hynesim headers
#include "common/entityentry.h"

// Qt headers
#include <QHash>
#include <QList>
#include <QReadWriteLock>

namespace HnsNode {

class EntityI;

class PlatformHybridNetcard : public Platform
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformHybridNetcard *instance();
    static bool canBuild(const::Hns::EntityEntryPtr &entityEntry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());
    bool defineEntity(EntityI *entity);
    bool undefineEntity(EntityI *entity);
    bool createEntity(EntityI *entity);
    bool destroyEntity(EntityI *entity);
    QHash<QString, QString> getHybridNetCards();

protected:
    explicit PlatformHybridNetcard();
    ~PlatformHybridNetcard();
    bool _loadHybridNetcards();

private:
    static PlatformHybridNetcard *_instance;
    QHash<QString, QString> _hybridNetcards;
    QList<QString> _hybridNetcardsInUse;
    QReadWriteLock _lock;
};

} // namespace HnsNode

#endif // HNSNODE_PLATFORMHYBRIDNETCARD_H
