/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PLATFORMKERNELBRIDGESWITCH_H
#define PLATFORMKERNELBRIDGESWITCH_H

// hynesim node headers
#include "platformswitch.h"

// Generated hynesim headers
#include "common/entityentry.h"

namespace HnsNode {

class EntityI;
class SwitchImplementation;

class PlatformKernelBridgeSwitch : public PlatformSwitch
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformKernelBridgeSwitch *instance();
    static bool canBuild(const Hns::EntityEntryPtr &entry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());
    bool updateEntry(const Hns::EntityEntryPtr &entry, SwitchImplementation *implementation);

protected:
    PlatformKernelBridgeSwitch();
    ~PlatformKernelBridgeSwitch();
    void _beforeDefineSwitch(EntityI *entity);
    QList<Ice::Int> initAvailablePlugsForCapture(SwitchImplementation *implementation);

private:
    static PlatformKernelBridgeSwitch *_instance;
};

} // namespace HnsNode

#endif // PLATFORMKERNELBRIDGESWITCH_H
