#ifndef PLATFORMLXC_H
#define PLATFORMLXC_H

// hynesim node headers
#include "platformdomain.h"

// Generated hynesim headers
#include "common/entityentry.h"

// Qt headers
#include <QList>
#include <QMetaObject>
#include <QReadWriteLock>

class QDomDocument;

namespace HnsNode {

class DomainI;

class PlatformLxc : public PlatformDomain
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformLxc *instance();

protected:
    PlatformLxc();
    ~PlatformLxc();

    bool _beforeLibvirtDefine(QDomDocument &xml, DomainI *domain);
    bool _beforeLibvirtCreate(DomainI *domain);
    bool _afterLibvirtCreate(DomainI *domain);
    void _createEntityCleanup();

    int getEntityFlags();

    static bool canBuild(const::Hns::EntityEntryPtr &entityEntry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());
    static PlatformLxc *_instance;
    QReadWriteLock _oneDomainIsStarting;

private:
    bool _enableUserNS;
    int _uidMappingTarget;
    int _uidMappingCount;
    int _gidMappingTarget;
    int _gidMappingCount;
};

} // namespace HnsNode

#endif // PLATFORMLXC_H
