#ifndef PLATFORMOPENVSWITCH_H
#define PLATFORMOPENVSWITCH_H

// hynesim node headers
#include "platformswitch.h"

// Generated hynesim headers
#include "common/entityentry.h"

// Qt headers
#include <QList>

namespace HnsNode {

class SwitchImplementation;

class PlatformOpenVSwitch : public PlatformSwitch
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformOpenVSwitch *instance();
    static bool canBuild(const Hns::EntityEntryPtr &entry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());
    bool updateEntry(const Hns::EntityEntryPtr &entry, SwitchImplementation *implementation);

protected:
    PlatformOpenVSwitch();
    ~PlatformOpenVSwitch();

    void _beforeDefineSwitch(EntityI *entity);
    QList<Ice::Int> initAvailablePlugsForCapture(SwitchImplementation *implementation);

private:
    static PlatformOpenVSwitch *_instance;
};

} // namespace HnsNode

#endif // PLATFORMOPENVSWITCH_H
