/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_PLATFORM_OPENVZ_H
#define _HNS_PLATFORM_OPENVZ_H

// hynesim node headers
#include "platformdomain.h"

// Generated hynesim headers
#include "common/entityentry.h"

// Qt headers
#include <QList>
#include <QMetaObject>

class QDomDocument;

namespace HnsNode {

class DomainI;

class PlatformOpenVz : public PlatformDomain
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformOpenVz *instance();

protected:
    PlatformOpenVz();
    ~PlatformOpenVz();
    bool _beforeLibvirtDefine(QDomDocument &xml, DomainI *domain);
    bool _afterLibvirtDefine(DomainI *domain);
    bool _afterLibvirtCreate(DomainI *domain);
    bool _beforeLibvirtDestroy(DomainI *domain);
    bool _afterLibvirtDestroy(DomainI *domain);
    bool _beforeLibvirtUndefine(DomainI *domain);
    bool _afterLibvirtResume(DomainI *domain);
    bool _saveDomain(DomainI *domain);
    bool _restoreDomain(DomainI *domain);
    static bool canBuild(const::Hns::EntityEntryPtr &entityEntry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());
    static PlatformOpenVz *_instance;
};

} // namespace HnsNode

#endif // _HNS_PLATFORM_OPENVZ_H
