/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef _HNS_PLATFORM_VMWARE_H
#define _HNS_PLATFORM_VMWARE_H

// hynesim node headers
#include "platformdomain.h"

// Generated hynesim headers
#include "common/entityentry.h"
#include "common/domainentry.h"

// Qt headers
#include <QMetaObject>

class QDomDocument;

namespace HnsNode {

class Netcard;
class DomainI;

class PlatformVMware : public PlatformDomain
{
    Q_OBJECT

public:
    static Platform *create();
    static PlatformVMware *instance();

protected:
    PlatformVMware();
    ~PlatformVMware();

    bool _beforeLibvirtDefine(QDomDocument &xml, DomainI *domain);
    bool _afterLibvirtDefine(DomainI *domain);
    bool _afterLibvirtUndefine(DomainI *domain);
    bool _saveDomain(DomainI *domain);
    bool _restoreDomain(DomainI *domain);
    Netcard *_createNetcard(const Hns::Netcard &netcardEntry);
    static bool canBuild(const ::Hns::EntityEntryPtr &entityEntry, const QList<Hns::EntityEntryPtr> &alreadyDefinedEntities = QList<Hns::EntityEntryPtr>());

private:
    void _cleanNetworkIntefaces(const QStringList &interfaces);

    QString _vmxPath(DomainI *domain);
    static PlatformVMware *_instance;
};

} // namespace HnsNode

#endif // _HNS_PLATFORM_VMWARE_H
