/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PLATFORMWIRE_H
#define PLATFORMWIRE_H

// hynesim node headers
#include "platform.h"

// Generated hynesim headers
#include "common/entityentry.h"
#include "common/nodeentity.h"

// Qt headers
#include <QStringList>

namespace HnsNode {

class EntityI;

class PlatformWire : public Platform
{
public:
    static PlatformWire *get(const std::string &wireType);
    bool defineEntity(EntityI *entity);
    bool undefineEntity(EntityI *entity);
    bool createEntity(EntityI *entity);
    bool destroyEntity(EntityI *entity);
    bool updateEntry(EntityI *entity, const::Hns::EntityEntryPtr &entityEntry);
    bool setLinkedEntities(EntityI *entity, const ::HnsNode::EntityPrx &fromEntity, ::Ice::Int fromPort, const ::HnsNode::EntityPrx &toEntity, ::Ice::Int toPort);
    virtual void beforeDefineEntity(EntityI *entity);

protected:
    PlatformWire(const QStringList &wireType);
    virtual ~PlatformWire();

private:
    void _registerPlatformWire(const QString &wireType);
};

} // namespace HnsNode

#endif // PLATFORMWIRE_H
