/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim node headers
#include "router2600.h"

// Generated hynesim headers
#include "common/dynamipsrouterentry.h"

// Qt headers
#include <QtPlugin>

namespace HnsNode {

/******************************************************************************
  * Router2600Plugin
  */
Router2600Plugin::Router2600Plugin(QObject *parent)
    : DynamipsPlugin(parent)
{
}

QString Router2600Plugin::name() const
{
    return tr("Router 2600");
}

QString Router2600Plugin::description() const
{
    return tr("Router 2600 plugin");
}

bool Router2600Plugin::canBuild(const Hns::EntityEntryPtr &entityEntry)
{
    Hns::DynamipsRouterEntryPtr dynamipsRouterEntry = Hns::DynamipsRouterEntryPtr::dynamicCast(entityEntry);
    if (dynamipsRouterEntry && dynamipsRouterEntry->router == "c2600")
        return true;
    return false;
}

} // namespace HnsNode
Q_EXPORT_PLUGIN2(dynamipsc2600Plugin, HnsNode::Router2600Plugin)
