/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
// hynesim node headers
#include "router3745.h"

// Generated hynesim headers
#include "common/dynamipsrouterentry.h"

// Qt headers
#include <QtPlugin>

namespace HnsNode {

/******************************************************************************
  * Router3745Plugin
  */
Router3745Plugin::Router3745Plugin(QObject *parent)
    : DynamipsPlugin(parent)
{
}

QString Router3745Plugin::name() const
{
    return tr("Router 3745");
}

QString Router3745Plugin::description() const
{
    return tr("Router 3745 plugin");
}

bool Router3745Plugin::canBuild(const Hns::EntityEntryPtr &entityEntry)
{
    Hns::DynamipsRouterEntryPtr dynamipsRouterEntry = Hns::DynamipsRouterEntryPtr::dynamicCast(entityEntry);
    if (dynamipsRouterEntry && dynamipsRouterEntry->router == "c3745")
        return true;
    return false;
}

} // namespace HnsNode
Q_EXPORT_PLUGIN2(dynamipsc3745Plugin, HnsNode::Router3745Plugin)
