/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of Hynesim.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// -*- c++ -*-

#ifndef QPCAPIPPACKET_H
#define QPCAPIPPACKET_H

// Qt headers
#include <QHostAddress>

class QPcapTcpPacket;

class QPcapIpPacket
{
public:
    enum IpProtocol {
        IcmpProtocol = 1,
        IgmpProtocol = 2,
        TcpProtocol = 6,
        UdpProtocol = 17,
        Ip6Protocol = 41,
        Icmp6Protocol = 58
    };

    QPcapIpPacket();
    QPcapIpPacket( const uchar *packet );

    ~QPcapIpPacket();

    bool isValid() const;

    int version() const;
    int headerLength() const;

    int protocol() const;

    QHostAddress source() const;
    QHostAddress dest() const;

    int length() const;

    bool isTcpPacket() const;
    QPcapTcpPacket toTcpPacket() const;

private:
    const uchar *packet;
};

#endif // QPCAPIPPACKET_H
