/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef RESOURCEMANAGER_H
#define RESOURCEMANAGER_H

// hynesim common headers
#include "common/resource.h"
#include "common/noderesourceinfo.h"

// Qt headers
#include <QObject>

namespace HnsNode {

class ResourceManager : public QObject
{
    Q_OBJECT
public:
    explicit ResourceManager(QObject *parent = 0);
    void addResource(Hns::Resource resource);
    void removeResource(Hns::Resource resource);
    HnsNode::ResourceInfo getResourceInfo();

signals:
    void resourcesChanged(HnsNode::ResourceInfo resourceInformation);

protected:
    HnsNode::ResourceInfo _resourceInfo;
};

} // namespace HnsNode

#endif // RESOURCEMANAGER_H
