/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef TELNETWRAPPER_H
#define TELNETWRAPPER_H

// Qt headers
#include <QObject>
#include <QByteArray>

// C++ std headers
#include <stdexcept>

class QTcpSocket;

namespace HnsNode {

class TelnetWrapper : public QObject
{
    Q_OBJECT
public:
    explicit TelnetWrapper(QObject *parent = 0);

    ~TelnetWrapper();
    bool connectToHost(const QString &host, int port);
    bool isConnect();
    QByteArray send(const QString &command, bool longWait = false);
    QByteArray send(const QByteArray &command, bool longWait = false);

signals:
    void dataReceived(QByteArray);
    void dataSent(QByteArray);

private:
    QTcpSocket *_socket;

};

class DynamipsError : public std::runtime_error
{
public:
    DynamipsError(const QString &msg)
        : std::runtime_error(msg.toStdString()) {}
};

} // namespace HnsNode

#endif // TELNETWRAPPER_H
