/******************************************************************************
**
** Copyright (C) 2003-2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

// hynesim node headers
#include "topologygatecapturehandler.h"
#include "nodetopologygateI.h"

// Qt headers
#include <QDebug>

namespace HnsNode {

TopologyGateCaptureHandler::TopologyGateCaptureHandler()
{
}

TopologyGateCaptureHandler::~TopologyGateCaptureHandler()
{
}

QString TopologyGateCaptureHandler::_getFileNamePrefix()
{
    return "topologyGate";
}

QString TopologyGateCaptureHandler::_getInterfaceToCapture()
{
    TopologyGateI *topologyGate = qobject_cast<TopologyGateI *>(_entity);
    if (!(_entity->getStatus() == Hns::STARTED)) {
        qCritical() << tr("Libpcap can capture only on interfaces wich are UP so please start the switch");
        return QString();
    }
    return topologyGate->getBridgeName();
}

} // namespace HnsNode
