/******************************************************************************
**
** Copyright (C) 2013 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef WIREIMPLEMENTATION_H
#define WIREIMPLEMENTATION_H

// Generated hynesim headers
#include "common/entityentry.h"
#include "common/nodeentity.h"
#include "common/nodecapturejob.h"

// Qt headers
#include <QObject>

namespace HnsNode {

class EntityI;

class WireImplementation : public QObject
{
    Q_OBJECT

public:
    WireImplementation();
    virtual ~WireImplementation();
    virtual bool define(EntityI *entityI) = 0;
    virtual bool destroy() = 0;
    virtual bool updateEntry(const::Hns::EntityEntryPtr & entry) = 0;
    virtual bool setLinkedEntities(const ::HnsNode::EntityPrx &fromEntity, ::Ice::Int fromPort, const ::HnsNode::EntityPrx &toEntity, ::Ice::Int toPort) = 0;
    virtual HnsNode::CaptureJobPrx createCaptureJob(const std::string &captureJobPath);

protected:
    Hns::EntityEntryPtr _entityEntry;
};

} // namespace HnsNode
#endif // WIREIMPLEMENTATION_H
