/******************************************************************************
**
** Copyright (C) 2003-2017 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/
#ifndef WIREINTERFACEMANAGER_H
#define WIREINTERFACEMANAGER_H

// Qt headers
#include <QObject>
#include <QHash>
#include <QMutex>

class QTimer;

namespace HnsNode {

class WireInterfaceManager : public QObject
{
    Q_OBJECT
public:
    explicit WireInterfaceManager(QObject *parent = 0);
    ~WireInterfaceManager();
    void deleteInterface(const QString &interfaceName);
    void createVxlan(const QString &interfaceName, qlonglong id, const QString &sourceInterface, const QString &dstIp);
    void createVeth(const QString &fromInterface, const QString &toInterface);

private slots:
    void _timeoutSlot(bool wait = true);

private:
    QTimer *_timer;
    QHash<QString, qint64> _interfaces;
    QMutex _mutex;
};

} // Namespace HnsNode
#endif // WIREINTERFACEMANAGER_H
