/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include "testcallback.h"

#include <QtCore/QDebug>

TestCallback::TestCallback() : QObject(), _nbFoldersRemoved(0)
{
}

TestCallback::~TestCallback()
{
}

void TestCallback::startLoop()
{
    _loop.exec();
}

void TestCallback::stopLoop()
{
    _loop.exit();
}

void TestCallback::folderRemoved(bool result)
{
    Q_UNUSED(result);
    qDebug() << "folderRemoved";
    _nbFoldersRemoved++;
    if(_nbFoldersRemoved == 8) {
        stopLoop();
    }
}
