/******************************************************************************
**
** Copyright (C) 2003-2012 DIATEAM. All rights reserved.
**
** This file is part of hynesim.
**
** hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#include "nodeI.h"
#include "scriptrunner.h"
#include <diamesh/coreapplication.h>
#include <diamesh/diamesh.h>
#include <QUuid>
#include <QtCore/QDebug>
#include <Ice/ObjectAdapter.h>

int main(int argc, char **argv)
{
    Diamesh::CoreApplication * app = Diamesh::CoreApplication::create(argc, argv, NULL);
    Q_UNUSED(app);
    Hns::NodeI node;
    node.adapter()->activate();

    HnsNode::ScriptRunner runner;
    QStringList args;
    args << "ok";
    if (!runner.runSynchronous("hnsTestScript.sh", args)) {
        qCritical() << QObject::tr("error while running ok test script");
        return 1;
    }

    args.clear();
    args << "error2";
    if (runner.runSynchronous("hnsTestScript.sh", args)) {
        qCritical() << QObject::tr("no error while running error2 test script");
        return 1;
    }


    return 0;
}
