#include "utils.h"

#include "operators.h"
#include <Ice/Exception.h>
#include <Ice/ObjectAdapter.h>
#include <Ice/Identity.h>
#include <Ice/BuiltinSequences.h>
#include <QtCore/QSharedPointer>
#include <QtCore/QReadWriteLock>

namespace QtIce {

class RegisterMetaTypes
{
public:
  RegisterMetaTypes()
  {
    qRegisterMetaType<QSharedPointer<Ice::Exception> >("QSharedPointer<Ice::Exception>");
    qRegisterMetaType<Ice::ObjectAdapterPtr>("Ice::ObjectAdapterPtr");
    qRegisterMetaType<Ice::Identity>("Ice::Identity");
    qRegisterMetaType<Ice::ByteSeq>("Ice::ByteSeq");
    qRegisterMetaTypeStreamOperators<Ice::ByteSeq>("Ice::ByteSeq");
  }
} _register;

static Ice::CommunicatorPtr applicationCommunicator = 0;
static QReadWriteLock lock;

Ice::CommunicatorPtr iceCommunicator()
{
  QReadLocker locker(&lock);
  return applicationCommunicator;
}

void setIceCommunicator(const Ice::CommunicatorPtr &ptr)
{
  QWriteLocker locker(&lock);
  applicationCommunicator = ptr;
}

} // namespace QtIce
