set(QTICE_GENERATED_OUTPUT_DIR "")

macro(QTICE_WRAP_SLICE generator out_srcs out_hdrs prefix target)
  set(slice_options)
  foreach(_inc_dir ${ICE_SLICE_INCLUDE_DIRS})
    set(slice_options "-I${_inc_dir}" ${slice_options})
  endforeach()

  if(QTICE_GENERATED_OUTPUT_DIR)
    set(_output_dir "${QTICE_GENERATED_OUTPUT_DIR}")
  else()
    set(_output_dir "${CMAKE_CURRENT_BINARY_DIR}")
  endif()
  set(_target_deps "")

  if(NOT ("${prefix}" STREQUAL ""))
    set(slice_options "-p ${prefix}" ${slice_options})
  endif()

  foreach(it ${ARGN})
    get_filename_component(basename ${it} NAME_WE)
    set(out_src ${_output_dir}/${generator}_${basename}.cpp)
    set(out_hdr ${_output_dir}/${generator}_${basename}.h)
    get_filename_component(it ${it} ABSOLUTE)

    add_custom_command(OUTPUT ${out_src} ${out_hdr}
                       COMMAND slice2qt
                       ARGS ${it} -g ${generator} --output-dir ${_output_dir} -I${ICE_SLICE_DIRS} -I${CMAKE_SOURCE_DIR} ${slice_options}
                       DEPENDS ${it}
    )

    set(${out_srcs} ${${out_srcs}} ${out_src})
    set(${out_hdrs} ${${out_hdrs}} ${out_hdr})
    set(_target_deps ${_target_deps} ${out_src} ${out_hdr})
  endforeach()

  add_custom_target(${target} DEPENDS ${_target_deps})
endmacro()

