find_program(BZR_EXECUTABLE bzr
  DOC "Bazaar command line client")
mark_as_advanced(BZR_EXECUTABLE)

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(Bazaar DEFAULT_MSG BZR_EXECUTABLE)

if(BAZAAR_FOUND)
  macro(_run_bzr_revno dir output_var result_var)
    execute_process(COMMAND ${BZR_EXECUTABLE} revno ${dir}
      OUTPUT_VARIABLE ${output_var}
      RESULT_VARIABLE ${result_var}
      ERROR_QUIET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endmacro()

  macro(Bazaar_IS_WT dir prefix)
    _run_bzr_revno(${dir} _revno _bzr_revno_result)
    if(${_bzr_revno_result} EQUAL 0)
      set(${prefix}_WT_ISWT 1)
    else()
      set(${prefix}_WT_ISWT 0)
    endif()
  endmacro()
    
  macro(Bazaar_WT_INFO dir prefix)
    _run_bzr_revno(${dir} ${prefix}_WT_REVISION _bzr_revno_result)
    if(NOT ${_bzr_revno_result} EQUAL 0)
      message(WARNING "Unable to get working tree revision")
    endif()
  endmacro()
endif()
