/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of QtIce.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef GENERATOR_H
#define GENERATOR_H

#include <Slice/Parser.h>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QMultiHash>

class Generator
{
  protected:
    Generator(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString & baseNamePrefix, const QString &prefix);

  public:
    virtual bool generate() = 0;

  protected:
    QString _headerGuardString(const QString & text);
    QString _baseName();
    QMultiHash<QString, QString> _extractMetaData(const std::list<std::string> & metaData, const QString & prefix = "");
    Slice::ClassList _classList(const Slice::ModuleList &modules);

  protected:
    Slice::UnitPtr _unit;
    QString _outputDirPath;
    QString _baseNamePrefix;
    QStringList _includeDirs;
    QString _prefix;
};

class GeneratorFactory
{
  protected:
    GeneratorFactory();

  public:
    virtual Generator * create(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString &prefix) = 0;
};

#endif // GENERATOR_H
