/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of QtIce.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef PROXYGENERATOR_H
#define PROXYGENERATOR_H

#include "generator.h"

class QTextStream;

class ProxyGenerator : public Generator
{
  public:
    ProxyGenerator(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString &prefix);

    bool generate();

  protected:
    void _writeProxyHeaderHeader(QTextStream & stream, QString modulePrefix);
    void _writeProxyHeaderFooter(QTextStream & stream);
    void _writeProxySourceHeader(QTextStream & stream, const QString & header);

    bool _writeProxyFromClass(QTextStream & hStream, QTextStream & sStream, Slice::ClassDefPtr c);

    QString _operationToDeclarations(Slice::OperationPtr op, Slice::ClassDefPtr c);
    QString _operationToDefinition(Slice::OperationPtr op, Slice::ClassDefPtr c, const QString & prefix);
    QString _operationToCbDeclaration(Slice::OperationPtr op, Slice::ClassDefPtr c);
    QString _operationToCbDefinition(Slice::OperationPtr op, Slice::ClassDefPtr c);
    QString _metaDataToSignals(const QList<std::string> & metaData);
    QString _metaDataToSignalsForwarderDeclaration(const QList<std::string> &metaData, Slice::ClassDefPtr c);
    QString _metaDataToSignalsForwarderDefinition(const QList<std::string> &metaData, const QString &prefix, Slice::ClassDefPtr c);
};

class ProxyGeneratorFactory : public GeneratorFactory
{
  public:
    Generator * create(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString &prefix);
};

#endif // PROXYGENERATOR_H
