/******************************************************************************
**
** Copyright (C) 2011-2012 DIATEAM. All rights reserved.
**
** This file is part of QtIce.
**
** Hynesim is free software: you can redistribute it and/or modify
** it under the terms of the GNU General Public License version 2 
** as published by the Free Software Foundation.
**
** Hynesim is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
**
******************************************************************************/

#ifndef QICEOBJECTGENERATOR_H
#define QICEOBJECTGENERATOR_H

#include "generator.h"
#include <Slice/Parser.h>

class QTextStream;

class QIceObjectGenerator : public Generator
{
  public:
    QIceObjectGenerator(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString &prefix);

    bool generate();

protected:
    void _writeProxyHeaderHeader(QTextStream & stream, QString modulePrefix);
    void _writeProxyHeaderFooter(QTextStream & stream);
    void _writeProxySourceHeader(QTextStream & stream, const QString & header);

    bool _writeProxyFromClass(QTextStream & hStream, QTextStream & sStream, Slice::ClassDefPtr c);
    void _writeAmdDeclarations(QTextStream & hStream,Slice::OperationPtr op, Slice::ClassDefPtr c);
    void _writeAmdDefinitions(QTextStream & sStream,Slice::OperationPtr op, Slice::ClassDefPtr c);
    void _createPrototypeAsyncFunction(QString name, QTextStream &stream, Slice::OperationPtr op, Slice::ClassDefPtr c, bool isDef,QStringList *paramsList, QStringList *paramsNameList);
    QString _signalHelperName(const QString & signal);
    QString _defineSignalHelper(const QString & className, const QString & signal, QStringList & sigTypesList, Slice::ClassDefPtr c);

private:
    QList<Slice::OperationPtr> _amdOpList;
};

class QIceObjectGeneratorFactory : public GeneratorFactory
{
  public:
    Generator * create(Slice::UnitPtr u, const QString & outputDirPath, const QStringList &includeDirs, const QString &prefix);
};

#endif // QICEOBJECTGENERATOR_H
