// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `info.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

#ifndef __diamesh__home_yohan_devel_git_diamesh_build_src_core_diamesh_info_h__
#define __diamesh__home_yohan_devel_git_diamesh_build_src_core_diamesh_info_h__

#include <Ice/ProxyF.h>
#include <Ice/ObjectF.h>
#include <Ice/Exception.h>
#include <Ice/LocalObject.h>
#include <Ice/StreamHelpers.h>
#include <IceUtil/ScopedArray.h>
#include <IceUtil/Optional.h>
#include <Ice/StreamF.h>
#include <diamesh/types.h>
#include <Ice/UndefSysMacros.h>

#ifndef ICE_IGNORE_VERSION
#   if ICE_INT_VERSION / 100 != 305
#       error Ice version mismatch!
#   endif
#   if ICE_INT_VERSION % 100 > 50
#       error Beta header file detected
#   endif
#   if ICE_INT_VERSION % 100 < 1
#       error Ice patch level mismatch!
#   endif
#endif

namespace Diamesh
{

struct DiskInfo
{
    ::std::string filesystem;
    ::std::string mountPoint;
    ::Ice::Long totalSpace;
    ::Ice::Long usedSpace;
    ::Ice::Long freeSpace;
    ::Ice::Double percentageUsed;

    bool operator==(const DiskInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return true;
        }
        if(filesystem != __rhs.filesystem)
        {
            return false;
        }
        if(mountPoint != __rhs.mountPoint)
        {
            return false;
        }
        if(totalSpace != __rhs.totalSpace)
        {
            return false;
        }
        if(usedSpace != __rhs.usedSpace)
        {
            return false;
        }
        if(freeSpace != __rhs.freeSpace)
        {
            return false;
        }
        if(percentageUsed != __rhs.percentageUsed)
        {
            return false;
        }
        return true;
    }

    bool operator<(const DiskInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return false;
        }
        if(filesystem < __rhs.filesystem)
        {
            return true;
        }
        else if(__rhs.filesystem < filesystem)
        {
            return false;
        }
        if(mountPoint < __rhs.mountPoint)
        {
            return true;
        }
        else if(__rhs.mountPoint < mountPoint)
        {
            return false;
        }
        if(totalSpace < __rhs.totalSpace)
        {
            return true;
        }
        else if(__rhs.totalSpace < totalSpace)
        {
            return false;
        }
        if(usedSpace < __rhs.usedSpace)
        {
            return true;
        }
        else if(__rhs.usedSpace < usedSpace)
        {
            return false;
        }
        if(freeSpace < __rhs.freeSpace)
        {
            return true;
        }
        else if(__rhs.freeSpace < freeSpace)
        {
            return false;
        }
        if(percentageUsed < __rhs.percentageUsed)
        {
            return true;
        }
        else if(__rhs.percentageUsed < percentageUsed)
        {
            return false;
        }
        return false;
    }

    bool operator!=(const DiskInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const DiskInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const DiskInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const DiskInfo& __rhs) const
    {
        return !operator<(__rhs);
    }
};

typedef std::list<Diamesh::DiskInfo> DiskInfoList;

struct VersionInfo
{
    ::std::string version;
    ::std::string versionDescription;
    ::std::string revision;
    ::std::string buildDate;
    ::std::string buildTime;

    bool operator==(const VersionInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return true;
        }
        if(version != __rhs.version)
        {
            return false;
        }
        if(versionDescription != __rhs.versionDescription)
        {
            return false;
        }
        if(revision != __rhs.revision)
        {
            return false;
        }
        if(buildDate != __rhs.buildDate)
        {
            return false;
        }
        if(buildTime != __rhs.buildTime)
        {
            return false;
        }
        return true;
    }

    bool operator<(const VersionInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return false;
        }
        if(version < __rhs.version)
        {
            return true;
        }
        else if(__rhs.version < version)
        {
            return false;
        }
        if(versionDescription < __rhs.versionDescription)
        {
            return true;
        }
        else if(__rhs.versionDescription < versionDescription)
        {
            return false;
        }
        if(revision < __rhs.revision)
        {
            return true;
        }
        else if(__rhs.revision < revision)
        {
            return false;
        }
        if(buildDate < __rhs.buildDate)
        {
            return true;
        }
        else if(__rhs.buildDate < buildDate)
        {
            return false;
        }
        if(buildTime < __rhs.buildTime)
        {
            return true;
        }
        else if(__rhs.buildTime < buildTime)
        {
            return false;
        }
        return false;
    }

    bool operator!=(const VersionInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const VersionInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const VersionInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const VersionInfo& __rhs) const
    {
        return !operator<(__rhs);
    }
};

struct SystemInfo
{
    ::std::string kernelInfo;
    ::Diamesh::StringList processors;
    ::Ice::Int uptime;
    ::Ice::Double cpuUsage;
    ::Ice::Long freeMemory;
    ::Ice::Long totalMemory;
    ::Ice::Long freeSwap;
    ::Ice::Long totalSwap;
    ::Diamesh::DiskInfoList disks;

    bool operator==(const SystemInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return true;
        }
        if(kernelInfo != __rhs.kernelInfo)
        {
            return false;
        }
        if(processors != __rhs.processors)
        {
            return false;
        }
        if(uptime != __rhs.uptime)
        {
            return false;
        }
        if(cpuUsage != __rhs.cpuUsage)
        {
            return false;
        }
        if(freeMemory != __rhs.freeMemory)
        {
            return false;
        }
        if(totalMemory != __rhs.totalMemory)
        {
            return false;
        }
        if(freeSwap != __rhs.freeSwap)
        {
            return false;
        }
        if(totalSwap != __rhs.totalSwap)
        {
            return false;
        }
        if(disks != __rhs.disks)
        {
            return false;
        }
        return true;
    }

    bool operator<(const SystemInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return false;
        }
        if(kernelInfo < __rhs.kernelInfo)
        {
            return true;
        }
        else if(__rhs.kernelInfo < kernelInfo)
        {
            return false;
        }
        if(processors < __rhs.processors)
        {
            return true;
        }
        else if(__rhs.processors < processors)
        {
            return false;
        }
        if(uptime < __rhs.uptime)
        {
            return true;
        }
        else if(__rhs.uptime < uptime)
        {
            return false;
        }
        if(cpuUsage < __rhs.cpuUsage)
        {
            return true;
        }
        else if(__rhs.cpuUsage < cpuUsage)
        {
            return false;
        }
        if(freeMemory < __rhs.freeMemory)
        {
            return true;
        }
        else if(__rhs.freeMemory < freeMemory)
        {
            return false;
        }
        if(totalMemory < __rhs.totalMemory)
        {
            return true;
        }
        else if(__rhs.totalMemory < totalMemory)
        {
            return false;
        }
        if(freeSwap < __rhs.freeSwap)
        {
            return true;
        }
        else if(__rhs.freeSwap < freeSwap)
        {
            return false;
        }
        if(totalSwap < __rhs.totalSwap)
        {
            return true;
        }
        else if(__rhs.totalSwap < totalSwap)
        {
            return false;
        }
        if(disks < __rhs.disks)
        {
            return true;
        }
        else if(__rhs.disks < disks)
        {
            return false;
        }
        return false;
    }

    bool operator!=(const SystemInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const SystemInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const SystemInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const SystemInfo& __rhs) const
    {
        return !operator<(__rhs);
    }
};

struct ServiceInfo
{
    ::std::string name;
    ::std::string shortName;
    ::std::string description;
    ::std::string host;
    ::std::string maxThread;
    ::Ice::Int uptime;

    bool operator==(const ServiceInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return true;
        }
        if(name != __rhs.name)
        {
            return false;
        }
        if(shortName != __rhs.shortName)
        {
            return false;
        }
        if(description != __rhs.description)
        {
            return false;
        }
        if(host != __rhs.host)
        {
            return false;
        }
        if(maxThread != __rhs.maxThread)
        {
            return false;
        }
        if(uptime != __rhs.uptime)
        {
            return false;
        }
        return true;
    }

    bool operator<(const ServiceInfo& __rhs) const
    {
        if(this == &__rhs)
        {
            return false;
        }
        if(name < __rhs.name)
        {
            return true;
        }
        else if(__rhs.name < name)
        {
            return false;
        }
        if(shortName < __rhs.shortName)
        {
            return true;
        }
        else if(__rhs.shortName < shortName)
        {
            return false;
        }
        if(description < __rhs.description)
        {
            return true;
        }
        else if(__rhs.description < description)
        {
            return false;
        }
        if(host < __rhs.host)
        {
            return true;
        }
        else if(__rhs.host < host)
        {
            return false;
        }
        if(maxThread < __rhs.maxThread)
        {
            return true;
        }
        else if(__rhs.maxThread < maxThread)
        {
            return false;
        }
        if(uptime < __rhs.uptime)
        {
            return true;
        }
        else if(__rhs.uptime < uptime)
        {
            return false;
        }
        return false;
    }

    bool operator!=(const ServiceInfo& __rhs) const
    {
        return !operator==(__rhs);
    }
    bool operator<=(const ServiceInfo& __rhs) const
    {
        return operator<(__rhs) || operator==(__rhs);
    }
    bool operator>(const ServiceInfo& __rhs) const
    {
        return !operator<(__rhs) && !operator==(__rhs);
    }
    bool operator>=(const ServiceInfo& __rhs) const
    {
        return !operator<(__rhs);
    }
};

}

namespace Ice
{
template<>
struct StreamableTraits< ::Diamesh::DiskInfo>
{
    static const StreamHelperCategory helper = StreamHelperCategoryStruct;
    static const int minWireSize = 34;
    static const bool fixedLength = false;
};

template<class S>
struct StreamWriter< ::Diamesh::DiskInfo, S>
{
    static void write(S* __os, const ::Diamesh::DiskInfo& v)
    {
        __os->write(v.filesystem);
        __os->write(v.mountPoint);
        __os->write(v.totalSpace);
        __os->write(v.usedSpace);
        __os->write(v.freeSpace);
        __os->write(v.percentageUsed);
    }
};

template<class S>
struct StreamReader< ::Diamesh::DiskInfo, S>
{
    static void read(S* __is, ::Diamesh::DiskInfo& v)
    {
        __is->read(v.filesystem);
        __is->read(v.mountPoint);
        __is->read(v.totalSpace);
        __is->read(v.usedSpace);
        __is->read(v.freeSpace);
        __is->read(v.percentageUsed);
    }
};

template<>
struct StreamableTraits< ::Diamesh::VersionInfo>
{
    static const StreamHelperCategory helper = StreamHelperCategoryStruct;
    static const int minWireSize = 5;
    static const bool fixedLength = false;
};

template<class S>
struct StreamWriter< ::Diamesh::VersionInfo, S>
{
    static void write(S* __os, const ::Diamesh::VersionInfo& v)
    {
        __os->write(v.version);
        __os->write(v.versionDescription);
        __os->write(v.revision);
        __os->write(v.buildDate);
        __os->write(v.buildTime);
    }
};

template<class S>
struct StreamReader< ::Diamesh::VersionInfo, S>
{
    static void read(S* __is, ::Diamesh::VersionInfo& v)
    {
        __is->read(v.version);
        __is->read(v.versionDescription);
        __is->read(v.revision);
        __is->read(v.buildDate);
        __is->read(v.buildTime);
    }
};

template<>
struct StreamableTraits< ::Diamesh::SystemInfo>
{
    static const StreamHelperCategory helper = StreamHelperCategoryStruct;
    static const int minWireSize = 47;
    static const bool fixedLength = false;
};

template<class S>
struct StreamWriter< ::Diamesh::SystemInfo, S>
{
    static void write(S* __os, const ::Diamesh::SystemInfo& v)
    {
        __os->write(v.kernelInfo);
        __os->write(v.processors);
        __os->write(v.uptime);
        __os->write(v.cpuUsage);
        __os->write(v.freeMemory);
        __os->write(v.totalMemory);
        __os->write(v.freeSwap);
        __os->write(v.totalSwap);
        __os->write(v.disks);
    }
};

template<class S>
struct StreamReader< ::Diamesh::SystemInfo, S>
{
    static void read(S* __is, ::Diamesh::SystemInfo& v)
    {
        __is->read(v.kernelInfo);
        __is->read(v.processors);
        __is->read(v.uptime);
        __is->read(v.cpuUsage);
        __is->read(v.freeMemory);
        __is->read(v.totalMemory);
        __is->read(v.freeSwap);
        __is->read(v.totalSwap);
        __is->read(v.disks);
    }
};

template<>
struct StreamableTraits< ::Diamesh::ServiceInfo>
{
    static const StreamHelperCategory helper = StreamHelperCategoryStruct;
    static const int minWireSize = 9;
    static const bool fixedLength = false;
};

template<class S>
struct StreamWriter< ::Diamesh::ServiceInfo, S>
{
    static void write(S* __os, const ::Diamesh::ServiceInfo& v)
    {
        __os->write(v.name);
        __os->write(v.shortName);
        __os->write(v.description);
        __os->write(v.host);
        __os->write(v.maxThread);
        __os->write(v.uptime);
    }
};

template<class S>
struct StreamReader< ::Diamesh::ServiceInfo, S>
{
    static void read(S* __is, ::Diamesh::ServiceInfo& v)
    {
        __is->read(v.name);
        __is->read(v.shortName);
        __is->read(v.description);
        __is->read(v.host);
        __is->read(v.maxThread);
        __is->read(v.uptime);
    }
};

}

#endif
